unit DigitizerMain;

interface
(*
  DigitizerMain in 'DigitizerMain.pas' {DigitizerForm2},          0,1
  DGlobalsUnit in 'DGlobalsUnit.pas',
  DFileLoaderUnit in 'DFileLoaderUnit.pas',
  DAttributesForm in 'DAttributesForm.pas' {AttributesForm},      4000
    1000 Serial Port, 1100 Digitizer Comm parameters
  DDigitSetForm in 'DDigitSetForm.pas' {DigitizerSettingsForm},
  DRegForm in 'DRegForm.pas' {RegistrationForm},                 2000
  DAbout in 'DAbout.pas' {AboutTracer},                          222
  dAboutComm in 'dAboutComm.pas' {AboutComm},   No Help, just its url
  DDLGCodesForm in 'DDLGCodesForm.pas' {DLGCodeForm},           6000
  DOIForm in 'DOIForm.pas' {DObjectForm},                       5000
  DSysInfo in 'DSysInfo.pas' {SystemInfoForm},        13000... MANY
  buzHelpContextl    buzHelpContextl: Integer = 123;
    buzMemoFrm in '..\common\buz\buzMemoFrm.pas' {buzMemoForm},
    left := buzMessageX;
    top := buzMessageY;
  DFileShpFrm in 'DFileShpFrm.pas' {ShpSaveForm},    8000
  DataListFrm in 'DataListFrm.pas' {DataForm};       7000
*)
uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Printers, Menus, ExtCtrls,
  ComCtrls, StdCtrls, CPDrv,
//MRUList, // some old version.. changed name to MRUFileList
  MRUFileList;

type
  TDigitizerForm2 = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MainMenu2: TMainMenu;
    DF__File: TMenuItem;
    Initialize: TMenuItem;
    OpenFile: TMenuItem;
    SaveFile: TMenuItem;
    DF_Exit: TMenuItem;
    NewFile: TMenuItem;
    DigitizerMenu: TMenuItem;
    DE_Increment: TMenuItem;
    Increment0: TMenuItem;
    Increment1: TMenuItem;
    Increment2: TMenuItem;
    Increment5: TMenuItem;
    Increment10: TMenuItem;
    Increment25: TMenuItem;
    Increment55: TMenuItem;
    Increment95: TMenuItem;
    DE_RN_Resolution1: TMenuItem;
    RN1000: TMenuItem;
    RN500: TMenuItem;
    RN400: TMenuItem;
    RN200: TMenuItem;
    RN100: TMenuItem;
    RN4: TMenuItem;
    RN2: TMenuItem;
    RN1: TMenuItem;
    DE_RR_ReportRate1: TMenuItem;
    DERR2: TMenuItem;
    DERR10: TMenuItem;
    DERR50: TMenuItem;
    DERR110: TMenuItem;
    ResetDigDefaults: TMenuItem;

    DD__Digitization: TMenuItem;
    DoLines: TMenuItem;
    DoPoints: TMenuItem;
    DoPolygons: TMenuItem;
    StopDigitizer: TMenuItem;
    RestartDigitizer: TMenuItem;
    TestDigitizer: TMenuItem;

    DH__Help: TMenuItem;
    DH_HowDoIHelp: TMenuItem;
    About: TMenuItem;
    DH_HelpContents: TMenuItem;
    N2: TMenuItem;
    N4: TMenuItem;
    RN40mm: TMenuItem;
    RN20mm: TMenuItem;
    RN10mm: TMenuItem;
    Increment3: TMenuItem;
    Increment4: TMenuItem;
    Increment15: TMenuItem;
    Increment35: TMenuItem;
    IncrementA: TMenuItem;
    IncrementB: TMenuItem;
    IncrementC: TMenuItem;
    DD_Colors: TMenuItem;
    DDColor1: TMenuItem;
    DDColor2: TMenuItem;
    DDColor3: TMenuItem;
    DDColor4: TMenuItem;
    DDColor5: TMenuItem;
    DDColor6: TMenuItem;
    DDColor7: TMenuItem;
    DDColor8: TMenuItem;
    DDColor9: TMenuItem;
    DDColorYellow: TMenuItem;
    DDColorPurple: TMenuItem;
    DDColorBlack: TMenuItem;
    DoLineStream: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    Black1: TMenuItem;
    Magenta1: TMenuItem;
    Green1: TMenuItem;
    Cyan1: TMenuItem;
    Red1: TMenuItem;
    Blue1: TMenuItem;
    ColorDialog1: TColorDialog;
    Yellow1: TMenuItem;
    StatusBar1: TStatusBar;
    N7: TMenuItem;
    N8: TMenuItem;
    SetupPrinter: TMenuItem;
    PrintScreen: TMenuItem;
    View1: TMenuItem;
    Tools1: TMenuItem;
    SaveAs1: TMenuItem;
    SaveAsBMP: TMenuItem;
    SaveAsDLG: TMenuItem;
    SaveAsDXF: TMenuItem;
    AsciiImage: TMenuItem;
    SaveAsList: TMenuItem;
    ZoomImage: TMenuItem;
    N1: TMenuItem;
    Register1: TMenuItem;
    SerialPortSettings: TMenuItem;
    DLGAttribute: TMenuItem;
    DLGHeader: TMenuItem;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    RefreshDrawing: TMenuItem;
    PointTypes1: TMenuItem;
    Dot0: TMenuItem;
    Box1: TMenuItem;
    LineTypes1: TMenuItem;
    Dashline1: TMenuItem;
    DotLine2: TMenuItem;
    SolidLine0: TMenuItem;
    DashDotLine3: TMenuItem;
    DashDotDotLine4: TMenuItem;
    XBox2: TMenuItem;
    Circle3: TMenuItem;
    DotCircle4: TMenuItem;
    PointX5: TMenuItem;
    PointPlus6: TMenuItem;
    DoPolygonStream: TMenuItem;
    FitToWindow: TMenuItem;
    PanImage: TMenuItem;
    N9: TMenuItem;
    Rersize1: TMenuItem;
    Resize480w: TMenuItem;
    Resize640w: TMenuItem;
    Resize800w: TMenuItem;
    Resize1024w: TMenuItem;
    Resize1280w: TMenuItem;
    StatusTop1: TMenuItem;
    StatusBottom1: TMenuItem;
    ShowXYDigitizing1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    DigiCommPort: TCommPortDriver;
    DigiDraw: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    AsciiDigiz: TMenuItem;
    ObjectInspector1: TMenuItem;
    DxfColors1: TMenuItem;
    Vrgis24Bit1: TMenuItem;
    Layers1: TMenuItem;
    N0020HY: TMenuItem;
    N1050HY: TMenuItem;
    N2070SC: TMenuItem;
    N3080NV: TMenuItem;
    N4090BD: TMenuItem;
    N5150SM: TMenuItem;
    N6170RD: TMenuItem;
    N7180RR: TMenuItem;
    N8190MT: TMenuItem;
    N9200MS: TMenuItem;
    N10300PL: TMenuItem;
    N11600PS: TMenuItem;
    MRUFileList: TMRUFileList;
    N13: TMenuItem;
    OnHelp1: TMenuItem;
    SaveAsSHP: TMenuItem;
    SaveAsBMPList: TMenuItem;
    ShowCoords1: TMenuItem;
    BigCursor1: TMenuItem;
    DataList1: TMenuItem;
    PolygonFill1: TMenuItem;
    PolySolid: TMenuItem;
    PolyBDiagonal: TMenuItem;
    PolyFDiagonal: TMenuItem;
    PolyCross: TMenuItem;
    PolyDiagCross: TMenuItem;
    PolyHorizonalLine: TMenuItem;
    PolyVerticalLine: TMenuItem;
    PolyClear: TMenuItem;
    PolyFillColors: TMenuItem;
    PolyFillBlackW7: TMenuItem;
    PolyFillPurple6: TMenuItem;
    PolyFillBlue5: TMenuItem;
    PolyFillAqua4: TMenuItem;
    PolyFillLimeGreen3: TMenuItem;
    PolyFillYellow2: TMenuItem;
    PolyFillRed1: TMenuItem;
procedure DisplaySplashScreen;    
    procedure DigiDrawClick(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DF_ExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

    procedure NewFileClick(Sender: TObject);
    procedure InitializeClick(Sender: TObject);
    procedure CannotSendError;
    procedure OpenFileClick(Sender: TObject);
    procedure SaveFileClick(Sender: TObject);
    procedure ClearForNewFile;
    procedure DFOpenFiles;
    procedure DOResetDefaults;
    procedure SaveAsciiListAsFile;
    procedure SaveListAsFile;
    procedure DODisabler;
    procedure DOEnabler;
    procedure DODIncrement;
    procedure DODRN;
    procedure DODRR;
    procedure Increment5Click(Sender: TObject);
    procedure Increment1Click(Sender: TObject);
    procedure Increment95Click(Sender: TObject);
    procedure Increment0Click(Sender: TObject);
    procedure Increment2Click(Sender: TObject);
    procedure Increment10Click(Sender: TObject);
    procedure Increment25Click(Sender: TObject);
    procedure Increment55Click(Sender: TObject);
    procedure RN500Click(Sender: TObject);
    procedure RN1000Click(Sender: TObject);
    procedure RN400Click(Sender: TObject);
    procedure RN200Click(Sender: TObject);
    procedure RN100Click(Sender: TObject);
    procedure RN4Click(Sender: TObject);
    procedure RN2Click(Sender: TObject);
    procedure RN1Click(Sender: TObject);
    procedure DERR2Click(Sender: TObject);
    procedure DERR50Click(Sender: TObject);
    procedure DERR10Click(Sender: TObject);
    procedure DERR110Click(Sender: TObject);
    procedure ResetDigDefaultsClick(Sender: TObject);

procedure DigiPolyStopper;
    procedure DoLineStreamClick(Sender: TObject);
    procedure DoPointsClick(Sender: TObject);
    procedure DoPolygonsClick(Sender: TObject);
    procedure DoLinesClick(Sender: TObject);
    procedure DoPolygonStreamClick(Sender: TObject);

    procedure Register1Click(Sender: TObject);

    procedure TestDigitizerClick(Sender: TObject);

    procedure DH_HowDoIHelpClick(Sender: TObject);
    procedure DH_HelpContentsClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);


    procedure RN40mmClick(Sender: TObject);
    procedure RN20mmClick(Sender: TObject);
    procedure RN10mmClick(Sender: TObject);
    procedure IncrementAClick(Sender: TObject);
    procedure IncrementBClick(Sender: TObject);
    procedure IncrementCClick(Sender: TObject);

    procedure DDColor1Click(Sender: TObject);
    procedure DDColor2Click(Sender: TObject);
    procedure DDColor3Click(Sender: TObject);
    procedure DDColor4Click(Sender: TObject);
    procedure DDColor5Click(Sender: TObject);
    procedure DDColor6Click(Sender: TObject);
    procedure DDColor7Click(Sender: TObject);
    procedure DDColor8Click(Sender: TObject);
    procedure DDColor9Click(Sender: TObject);
    procedure DDColorYellowClick(Sender: TObject);
    procedure DDColorPurpleClick(Sender: TObject);
    procedure DDColorBlackClick(Sender: TObject);

    procedure ColorUnclick;
    procedure Black1Click(Sender: TObject);
    procedure Magenta1Click(Sender: TObject);
    procedure Green1Click(Sender: TObject);
    procedure Red1Click(Sender: TObject);
    procedure Yellow1Click(Sender: TObject);
    procedure Blue1Click(Sender: TObject);
    procedure Cyan1Click(Sender: TObject);

procedure ClearLayers;
    procedure N0020HYClick(Sender: TObject);
    procedure N1050HYClick(Sender: TObject);
    procedure N2070SCClick(Sender: TObject);
    procedure N3080NVClick(Sender: TObject);
    procedure N4090BDClick(Sender: TObject);
    procedure N5150SMClick(Sender: TObject);
    procedure N6170RDClick(Sender: TObject);
    procedure N7180RRClick(Sender: TObject);
    procedure N8190MTClick(Sender: TObject);
    procedure N9200MSClick(Sender: TObject);
    procedure N10300PLClick(Sender: TObject);
    procedure N11600PSClick(Sender: TObject);

    procedure AsciiDigizClick(Sender: TObject);
    procedure AsciiImageClick(Sender: TObject);
    procedure DLGAttributeClick(Sender: TObject);
    procedure DLGHeaderClick(Sender: TObject);
    procedure SerialPortSettingsClick(Sender: TObject);
    procedure ObjectInspector1Click(Sender: TObject);

    procedure ChangeRez(NewRez: Integer);


    procedure Image1MouseDown(Sender: TObject;
      Button: TMouseButton;
      Shift: TShiftState;
      X, Y: Integer);
    procedure ZoomImageClick(Sender: TObject);
    procedure FitToWindowClick(Sender: TObject);
    procedure PanImageClick(Sender: TObject);

    procedure Resize480wClick(Sender: TObject);
    procedure Resize640wClick(Sender: TObject);
    procedure Resize800wClick(Sender: TObject);
    procedure Resize1024wClick(Sender: TObject);
    procedure Resize1280wClick(Sender: TObject);
    procedure StatusTop1Click(Sender: TObject);
    procedure StatusBottom1Click(Sender: TObject);
    procedure ShowXYDigitizing1Click(Sender: TObject);
    procedure RefreshDrawingClick(Sender: TObject);

    procedure SaveAsBMPClick(Sender: TObject);
    procedure SaveAsDLGClick(Sender: TObject);
    procedure SaveAsDXFClick(Sender: TObject);
    procedure SaveAsListClick(Sender: TObject);
procedure SaveDXF;
    procedure PrintScreenClick(Sender: TObject);
    procedure SetupPrinterClick(Sender: TObject);
    procedure StopDigitizerClick(Sender: TObject);
    procedure RestartDigitizerClick(Sender: TObject);
    procedure StartDigitizing;
    procedure StopDigitizing;
    procedure DigiCommPortReceiveData(Sender: TObject;
      DataPtr: Pointer; DataSize: Cardinal);
{procedure ApdComPort1TriggerData(CP: TObject; TriggerHandle: Word);
 procedure ApdComPort1TriggerAvail(CP: TObject; Count: Word);}
    procedure ChangeUp13;
    procedure ChangeUp11;
    procedure Number;
Function DoXScaleRatio(InX:Integer):Double;
Function DoYScaleRatio(InY:Integer):Double;
    procedure DoPixel;
    procedure XYMove;
    procedure DVDORedraw;
procedure InspectorRedraw(Layered,DLGOType,DLGOItem:Integer);
    procedure MRUFileListMRUItemClick(Sender: TObject;
      AFilename: TFileName);
    procedure OnHelp1Click(Sender: TObject);
procedure PointSmear;
    procedure Dot0Click(Sender: TObject);
    procedure Box1Click(Sender: TObject);
    procedure XBox2Click(Sender: TObject);
    procedure Circle3Click(Sender: TObject);
    procedure DotCircle4Click(Sender: TObject);
    procedure PointX5Click(Sender: TObject);
    procedure PointPlus6Click(Sender: TObject);
procedure LineSmear;
procedure SetLineType;
    procedure SolidLine0Click(Sender: TObject);
    procedure Dashline1Click(Sender: TObject);
    procedure DotLine2Click(Sender: TObject);
    procedure DashDotLine3Click(Sender: TObject);
    procedure DashDotDotLine4Click(Sender: TObject);
    procedure SaveAsBMPListClick(Sender: TObject);
    procedure SaveAsSHPClick(Sender: TObject);
    procedure ShowCoords1Click(Sender: TObject);
    procedure BigCursor1Click(Sender: TObject);
    procedure DataList1Click(Sender: TObject);
procedure PolySmear;
procedure SetPolyType;
procedure PolyColorUnclick;
    procedure PolySolidClick(Sender: TObject);
    procedure PolyBDiagonalClick(Sender: TObject);
    procedure PolyFDiagonalClick(Sender: TObject);
    procedure PolyCrossClick(Sender: TObject);
    procedure PolyDiagCrossClick(Sender: TObject);
    procedure PolyHorizonalLineClick(Sender: TObject);
    procedure PolyVerticalLineClick(Sender: TObject);
    procedure PolyClearClick(Sender: TObject);
    procedure PolyFillBlackW7Click(Sender: TObject);
    procedure PolyFillBlue5Click(Sender: TObject);
    procedure PolyFillAqua4Click(Sender: TObject);
    procedure PolyFillLimeGreen3Click(Sender: TObject);
    procedure PolyFillRed1Click(Sender: TObject);
    procedure PolyFillYellow2Click(Sender: TObject);
    procedure PolyFillPurple6Click(Sender: TObject);

  private
    { Private declarations }
{    TimerHandle : Word;}{reset when movement has occurred,
                        else stop transmission until restart...
                        Change MENU and Booleans}
{    LFHandle  : Word;}{Line Feed handle}
    {ModelIDHandle  : Word; Model string... }
    {need to also get what follows as that is the actual Model ID}
    { TesterHandle  : Word; Send 'w' Receive 'O' if passed all tests}
function myTestImage: Boolean;
  public
    { Public declarations }
    MaxDigiWidth:Integer;
  end;

var
  DigitizerForm2: TDigitizerForm2;


implementation

{$R *.DFM}
uses
  DGlobalsUnit,
  DAttributesForm, 
  DDigitSetForm, DAbout, DRegForm,
  DOIForm,
  cGKernel, cGPoly,
  AllSplash, DataListFrm, DFileShpFrm,
  buzGlobal, buzGCTP, buzDatum;

  {to pass Digitizer configuration variables}
{const ModelID :String='MM1812  Tablet by Summagraphics Firmware Version';}
                 { X.X}{is also sent...}




function TDigitizerForm2.myTestImage: Boolean;
{ONLY handle 24 bit colors... less than 24 bit is false}
var
  temp: Integer;
  dc: HDC;
begin
  dc := GetDc(0);
  if ((GetDeviceCaps(dc, BITSPIXEL) = 24)
    or (GetDeviceCaps(dc, BITSPIXEL) = 32)) then
  begin
    if (GetDeviceCaps(dc, BITSPIXEL) = 24) then
    begin
{      MyPixelFormat := pf24bit;
      PixelScanSize := 3;}
    end else
    begin
     {      DoMessages(40);    }
{      MyPixelFormat := pf24bit;
      PixelScanSize := 3;}
{        MyPixelFormat:=pf32bit;
         PixelScanSize:=4;}
    end;
    temp := ReleaseDc(0, dc); {Give back the screen dc}
    if temp <> 1 then Application.Terminate;
    myTestImage := True;
  end else
  begin {or 36}
{    DoMessages(11);}
    temp := ReleaseDc(0, dc);
    if temp <> 1 then Application.Terminate;
    myTestImage := False;
  end; {of if 24 bit}
end; {of this}


procedure TDigitizerForm2.DF_ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TDigitizerForm2.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin {prior to Closing - not Destroyed ? }
  DigiQuit := True;
  CanClose := False;
  if (DigiCommPort.Connected = True) then begin
   {If ApdComPort1.OutBuffFree >= 1 then }
   {FLUSH ALL}
    DigiCommPort.FlushBuffers(True {in}, True {out});
    DigiCommPort.SendChar(chr(RD_Stop)); {19 Stop transmission }
    DigiCommPort.DisConnect;
  end;
  DigitizerFormY := DigitizerForm2.top;
  DigitizerFormX := DigitizerForm2.left;
  ProScreenHeight := DigitizerForm2.Height;
    {546- 46=Client-Stat 20= 480}
  ProScreenWidth := DigitizerForm2.Width; {644-4=Client=640}
  ScreenHeight := (ProScreenHeight - 66);
  ScreenWidth := (ProScreenWidth - 4);
  if  ((CurrentPoint > 0)
    or (CurrentLine > 0)
    or (CurrentArea > 0)) then
  begin
    if MessageDlg('Save the file?', mtConfirmation, [mbYes, mbNo], 0)
      = mrYes then
    begin
      SaveFileClick(Sender);
      CanClose := True;
    end else
    begin
      CanClose := True; 
    end
  end else CanClose := True;
  bAttributesToggled:=False;
  AttributesForm.Close;
  DoSaver;
  AttriList.Clear; {Clear all its pointered objects}
  PointList.Clear;
  LineList.Clear;
  AreaList.Clear;
  DLGAreaList.Clear;
  AttriList.Free; {Frees all pointered objects}
  PointList.Free;
  LineList.Free;
  AreaList.Free;
  DLGAreaList.Free;
  Dispose(asDrawingDLGArea);
  Dispose(asDrawingAreaPnt);
  Dispose(asDrawingLnPnt);
  Dispose(asDrawingPnt);
  Dispose(asAttri);
  If BackGroundBitmapLoaded then BackGroundBitmap.Free;
end;


(***********************************************************)
(***********************************************************)

procedure TDigitizerForm2.DisplaySplashScreen;
begin
  SplashScreen := TSplashScreen.Create(Application);
  SplashScreen.SplashSet(8,2000);
  SplashScreen.Show;
  SplashScreen.Refresh;
end;

procedure TDigitizerForm2.FormCreate(Sender: TObject);
var helps: string;
begin {1 Set up Digitizer }
  DisplaySplashScreen;
 {LOAD Raster.RPM and SET these}
  if FileExists(ExtractFilePath(ParamStr(0)) + 'tracer.pof') then
  begin
    DoLoader;
  end else
  begin
    {Directories}
    FilePath := ExtractFilePath(ParamStr(0));
    {LEFT}
    DigitizerFormX := 0;
    DigitizerFormY := 0;
    AboutX := 123;
    AboutY := 123;
    SystemInfoFormX := 123;
    SystemInfoFormY := 123;
    MessageX := 123;
    MessageY := 123;
    DataFormX:=123;
    DataFormY:=123;
      DObjectFormX:= 123;
      DObjectFormY:= 123;
      AttributesFormX:= 123;
      AttributesFormY:= 123;
    DigitSetFormX := 123;
    DigitSetFormY := 123;
    AboutCommX := 123;
    AboutCommY := 123;
    AttribformX := 123; AttribformY := 123;
    HeaderX := 123; HeaderY := 123;
    RegFormX := 123; RegFormY := 123;
    DLGCodeFormX := 123;
    DLGCodeFormY := 123;
      ShpSetFormX:=123;
      ShpSetFormY:=123;
    ColorToolboxX := 123; ColorToolboxY := 123;
    LineToolboxX := 123; LineToolboxY := 123;
    SnapToolboxX := 123; SnapToolboxY := 123;
    TextureToolboxX := 123; TextureToolboxY := 123;
    D3ViewToolboxX := 123; D3ViewToolboxY := 123;
    AnnotateToolboxX := 123; AnnotateToolboxY := 123;
    CurrentColor := clBlack;
   {Digitizer}
    bAutoSave := True;
    SetDigitDefaults;
    CurrentRezDPI := 1000;
    ProScreenHeight := 546; {546-46(menu+form))-20(status)= 480}
    ProScreenWidth := 644; {644-4=640}
    ScreenHeight := 480;
    ScreenWidth := 640;
    DoSaver;
    Application.MessageBox
      ('Please set up Digitizer' + #13#10 +
      'See [Digitizer] Serial Port settings...', 'Initialization',
        MB_OK);
  end;

     {Create Pixel List}{Create the LISTS}
  AttriList := TList.Create;
  PointList := TList.Create;
  LineList := TList.Create;
  AreaList := TList.Create;
  DLGAreaList := TList.Create;
  New(asDrawingDLGArea);
  New(asDrawingAreaPnt);
  New(asDrawingLnPnt);
  New(asDrawingPnt);
  New(asAttri);
  aRegPnt1.Reg := 1;     {NW TL}
  aRegPnt1.X := 250;
  aRegPnt1.Y := 11750;
  aRegPnt1.PX := 20;
  aRegPnt1.PY := 440;
  aRegPnt1.LocoX := 0;
  aRegPnt1.LocoY := 0;
  aRegPnt1.LongX := 0;
  aRegPnt1.LatY := 0;

  aRegPnt2.Reg := 2;       {NE TR}
  aRegPnt2.X := 15750;
  aRegPnt2.Y := 11750;
  aRegPnt2.PX := 620;
  aRegPnt2.PY := 440;
  aRegPnt2.LocoX := 0;
  aRegPnt2.LocoY := 0;
  aRegPnt2.LongX := 0;
  aRegPnt2.LatY := 0;
 {SW BL}
  aRegPnt3.Reg := 3;
  aRegPnt3.X := 15750;
  aRegPnt3.Y := 250;
  aRegPnt3.PX := 620;
  aRegPnt3.PY := 20;
  aRegPnt3.LocoX := 0;
  aRegPnt3.LocoY := 0;
  aRegPnt3.LongX := 0;
  aRegPnt3.LatY := 0;
{SE BR}
  aRegPnt4.Reg := 4;
  aRegPnt4.X := 250;
  aRegPnt4.Y := 250;
  aRegPnt4.PX := 20;
  aRegPnt4.PY := 20;
  aRegPnt4.LocoX := 0;
  aRegPnt4.LocoY := 0;
  aRegPnt4.LongX := 0;
  aRegPnt4.LatY := 0;


{Check Defaults and Change Menu...}
  DODisabler;
  Initialize.Enabled := True;
  DigitizerForm2.Caption :=
    'Please Initialize Digitizer: [Digitizer][Initialize]';

  DOResetDefaults;
  DoLineStream.Checked := False;
  bStreamMode := False;
  StartStreaming := False;
  IsDigiDrawn := False;
  DLGEditing:=False;
  bAttributesToggled:=False;
  BackGroundBitmapLoaded:= False;
  Movement := False;
  Testing := False;
  bShowXYDigit := False;
  ShowXYDigitizing1.Checked := False;
  bShowCoord :=False;
  ShowCoords1.Checked := False;
  NotYetShown:= True;
  CurrentLayer := 0;   {Hypso ... DXF standard}
  CurrentPointType := 1;
  CurrentLineType := 1;
  CurrentAtt := 0;
  CurrentPoint := 0;
  CurrentLine := 0;
  CurrentArea := 0;
  CurrentDLGArea := 0;
  CurrentMajor := 020;
  CurrentMinor := 200;
  CurrentLineWidth := 0;
  FileName := 'NoName.duh';
  DigiQuit := True; {Turns off boguses mouse}
 { Set up Digitizer }
{ DigiCommPort.Connected:=False;}
  sInput := '';
  Application.ProcessMessages;
{Form sizer}
  Zooming := False;
  DXFXScale:=24000;
  DXFYScale:=24000;

  {ScreenRatio := 1.0;}
  PanCentroidX := 0;
  PanCentroidY := 0; {NOT Zooming}

  top := DigitizerFormY;
  left := DigitizerFormX;

  Image1.Align := alNone;
  Image1.Height := ScreenHeight;
  Image1.Width := ScreenWidth;
  Height := ProScreenHeight;
  Width := ProScreenWidth;

{Form sizer needs to reverse the math }
  Image1.Align := alClient;
  Bitmap := TBitmap.Create;
  Bitmap.Width := ScreenWidth; {640}
  Bitmap.Height := ScreenHeight; {480   427}
  Image1.Picture.Graphic := Bitmap;

  CurrentPointType := 1;
  CurrentLineType := 0;
  CurrentPolyType:= 0;
  CurrentBrushColor := clMaroon;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Pen.Color := clBlack;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := CurrentBrushColor;


  RX := (ScreenWidth / (CurrentRezDPI * (DigitWidth-DigitWidthSQ))); { 0.04;}
  RY := (ScreenHeight / (CurrentRezDPI * DigitHeight)); { 0.04;}
  MaxDigiWidth:=(CurrentRezDPI * (DigitWidth-DigitWidthSQ));
  {ScreenHeight,ScreenWidth,DigitHeight,DigitWidth,CurrentRezDPI
   WorldX,WorldY,WorldDX,WorldDY,}
   {ALL THESE CALCULATIONS ARE WRONG NOW
     because i use DigitWidth-DigitWidthSQ
     to remove those nasty 2 inches}
{ Both set to 480/12000 to keep aspect ratio Circles Round
   This makes the right edge of the tablet OFF the screen
   so use it as a menu ...}
{   RX := (640.0 / 18000);     as 1000 dpi : 1000 x 18 = 18000}
{   RY := (480.0 / 12000);      as 1000 dpi: 1000 x 12 = 12000 }
{   RX := (640.0 / 9000);     as 500 dpi : 500 x 18 = 9000}
{   RY := (480.0 / 6000);      as 500 dpi: 500 x 12 = 6000 }
{  TLCoordPnt.X := -1; TLCoordPnt.Y := -1;
  BLCoordPnt.X := -1; BLCoordPnt.Y := -1;
  BRCoordPnt.X := -1; BRCoordPnt.Y := -1;
  TRCoordPnt.X := -1; TRCoordPnt.Y := -1;}
{2 Set up Digitizer}
  OldX := 10;
  OldY := 10;
{  SetROP2(Image1.Canvas.handle, R2_NOT);}
  CursorSizeChanged:=False;
  CurrentCursorSize := CursorSize;
  Image1.Canvas.Pen.Mode := pmNotXor;
  Image1.Canvas.moveto(OldX - 1, OldY);
  Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX + 1, OldY);
  Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX, OldY + 1);
  Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
  Image1.Canvas.moveto(OldX, OldY - 1);
  Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);


{Uncheck Colors}
  ColorUnclick;
If myTestImage then
begin
{ ColorWhite:=clWhite;}
  ColorBlack := clBlack;
  ColorYELLOW := $0000BFBF; {YELLOW 191,191,0}
  ColorPURPLE := $00FE00FE; {254,0,254}
  Color1 := $00FE0000; {LtMBlueWater} {0,0,254} {LIGHT L Blue[!]}
    {clNavy;}
  Color2 := $00FEFE00; {LtMBlueWetland} {0,239,239} {LIGHT M CYAN[!]}
    {clAqua;}
  Color3 := $0000FE00; {LtMGreenForest} {0,254,0} {clGreen;}
  Color4 := $00DFDFFE; {ULAgricultural} {254,223,223} {BROWN }
    {clTeal;}
  Color5 := $0000BFFE; {LtMRangeland} {LIGHT M ORANGE}
  Color6 := $00DFFEDF; {LtMGrayTundra} {223,254,223} {clGreen;}
  Color7 := $00FEEFFE; {LtMBarren} {254,239,254} {clOlive;}
  Color8 := $000000FE; {LLtRedUrban} {254,0,0} {LIGHT L RED[!]}
    {clRed;}
  Color9 := $00BFBFBF; {191,191,191: LIGHT GRAY [!]} {clGray;}
   {ULtWhiteSnow}{LLS:=$00FEFEFE;}{254,254,254}{off M white}
  if CurrentColor = ColorBlack then DDColorBlack.Checked := True else
  if CurrentColor = ColorPURPLE then DDColorPurple.Checked := True else
  if CurrentColor = ColorYELLOW then DDColorYellow.Checked := True else
  if CurrentColor = Color1 then DDColor1.Checked := True else
  if CurrentColor = Color2 then DDColor2.Checked := True else
  if CurrentColor = Color3 then DDColor3.Checked := True else
  if CurrentColor = Color4 then DDColor4.Checked := True else
  if CurrentColor = Color5 then DDColor5.Checked := True else
  if CurrentColor = Color6 then DDColor6.Checked := True else
  if CurrentColor = Color7 then DDColor7.Checked := True else
  if CurrentColor = Color8 then DDColor8.Checked := True else
  if CurrentColor = Color9 then DDColor9.Checked := True;
  {if 24 bit Do Dxf colors too}
  if CurrentColor = clLime then Green1.Checked := True else
  if CurrentColor = clYellow then Yellow1.Checked := True else
  if CurrentColor =clBlue then Blue1.Checked := True else
  if CurrentColor =clRed then Red1.Checked := True else
  if CurrentColor =clAqua then Cyan1.Checked := True else
  if CurrentColor =clPurple then Magenta1.Checked := True else
  begin
  CurrentColor := clBlack;
  Black1.Checked := True;
  end;
end else
begin {Do Dxf colors only}
  if CurrentColor =clRed then Red1.Checked := True else
  if CurrentColor = clYellow then Yellow1.Checked := True else
  if CurrentColor = clLime then Green1.Checked := True else
  if CurrentColor =clAqua then Cyan1.Checked := True else
  if CurrentColor =clBlue then Blue1.Checked := True else
  if CurrentColor =clPurple then Magenta1.Checked := True else
  begin
  CurrentColor := clBlack; {White}
  Black1.Checked := True;
  end;
end;
{Get App Location to load Help}
  Helps := ExtractFilePath(ParamStr(0));
  Helps := Helps + 'tracer.hlp';
  Application.HelpFile := Helps;
  Application.OnHint := ShowHint;
end;

procedure TDigitizerForm2.ShowHint(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := Application.Hint;
end;


(***********************************************************)

procedure TDigitizerForm2.InitializeClick(Sender: TObject);
var tester: integer;
begin
{Set up Digitizer}
  DigiCommPort.Port := CommNumber; {pnCOM5;} {CommNumber;}
    {CommNumber;} {2}
  DigiCommPort.PortName := CommName; {'\\.\COM5';}
  DigiCommPort.BaudRate := Baud;
  DigiCommPort.BaudRateValue := BaudRate; {Baud;} {9600}
  DigiCommPort.DataBits := DataBits; {db8BITS;}
{DataBits;}{DataBits;}{8}
  DigiCommPort.StopBits := StopBits; { sb1BITS;} {StopBits;}
    {StopBits;} {1}
  DigiCommPort.Parity := ptODD; {Parity;} {String;} {pOdd}
{ApdComPort1.TriggerLength:=TriggerLength;}
{Set up the Port of call manager}
  StatusBar1.Panels[1].Text := 'Lets GO further...';
  DigiCommPort.CheckLineStatus := True; {Safety Valve}
  {:=True;}{5460= 300 seconds=5 minutes}
  // Try connecting
  if not DigiCommPort.Connect then
  begin
    Application.MessageBox('Could not connect to serial port.'#13#10
      +
      'Please, check settings and try again.',
      'Error',
      MB_OK or MB_ICONERROR);
    exit;
  end;
  DigiCommPort.CheckLineStatus := False; {Safety Valve}
                             {in}{out}
  DigiCommPort.FlushBuffers(True, True);
{Sleep(10);}
  for Tester := 0 to 11 do Application.ProcessMessages;
  // Do nothing if not connected
  if not DigiCommPort.Connected then exit;
  // Send the character
  if not DigiCommPort.SendChar(chr(17 {RD_Start})) then
    CannotSendError; {17 Resume Transmission}
 { ApdComPort1.PutChar((chr(RD_Reset)));}{0 Resets Tablet to defaults }
{Have to wait 10 milliseconds after reset or power up to receive commands}
{Sleep(10);}
  for Tester := 0 to 11 do Application.ProcessMessages;
  begin
    tester := 0;
    if DigiCommPort.SendChar((chr(RD_ReportRateDef))) then
      inc(tester);
    if DigiCommPort.SendChar(chr(RD_ResolutionDef)) then
      inc(tester); {'j' sets to 1000 DPI }
    if DigiCommPort.SendChar(chr(RD_Stream)) then
      inc(tester); {64 sets to Stream mode }
    if DigiCommPort.SendChar(chr(RD_IncrementCode)) then
      inc(tester); {Increment mode}
    if DigiCommPort.SendChar((chr(RD_IncrementDef))) then
      inc(tester); {10} {32..127 = 95 }
    StatusBar1.Panels[0].Text := 'Startup sent';
    if (tester < 5) then CannotSendError;
  end;
{   ApdComPort1.PutChar('t');}{Self Test...
                            Holds result until asked to send116=t=116}
 {give Tablet time to respond}
  DigitizerForm2.Caption :=
    'Open File or Register Drawing: [Digitizer][Register]';
  Initialize.Enabled := False;
  Register1.Enabled := True;
{ReRegisterImage.Enabled:=True;}
  OpenFile.Enabled := True;
  Application.ProcessMessages;
end;


// Displays an error box informing the user we can't send data

procedure TDigitizerForm2.CannotSendError;
begin
  if DigiCommPort.CheckLineStatus then
    Application.MessageBox(
      'Could not send data.'#13#10 +
      'No device connected to serial port or device is off.'#13#10 +
      'Please, turn it on.'#13#10 +
      'Try setting Device Check to Off in the settings dialog box.'#13#10 +
      'Also, replace your two wire serial cable with a fully wired cable.',
      'Warning',
      MB_OK or MB_ICONINFORMATION)
  else
    Application.MessageBox(
      'Could not send data.'#13#10 +
      'Please, check connections and try again.'#13#10 +
      'Check that digitizer is on or,'#13#10 +
      'try setting Device Check to On in the settings dialog box.'#13#10 +
      'Also, disable Hardware Flow Control '#13#10 +
      'if you are using a two wires cable.',
      'Warning',
      MB_OK or MB_ICONINFORMATION)
end;


{Save?  Clear or Create a clean bitmap
Restart grabbing pixels into data list for Paint and storage}

procedure TDigitizerForm2.NewFileClick(Sender: TObject);
begin
  ClearForNewFile;
end;

procedure TDigitizerForm2.ClearForNewFile;
var
  ARect: TRect;
begin
  if ((CurrentPoint > 0)
    or (CurrentLine > 0)
    or (CurrentArea > 0)) then
  begin
    if MessageDlg('Save the file?', mtConfirmation, [mbYes, mbNo], 0)
      = mrYes then SaveListAsFile;
  end;
{Clear or Create a clean bitmap, etc...}
  DigiQuit := True; {Turns off boguses mouse}
  DLGEditing:=False;
  FileName := 'NoName.duh';
  CurrentAtt := 0;
  CurrentPoint := 0;
  CurrentLine := 0;
  CurrentArea := 0;
  CurrentDLGArea := 0;
  CurrentMajor := 050;
  CurrentMinor := 200;
 {Frees all its pointered objects too}
  AttriList.Clear;
  PointList.Clear;
  LineList.Clear;
  AreaList.Clear;
  DLGAreaList.Clear;
  {AttriList.Pack;
  PointList.Pack;
  LineList.Pack;
  AreaList.Pack;
  DLGAreaList.Pack;}
  Testing := False;
  Movement := False;
  Zooming := False;
  ScreenRatio := 1.0;
  bAttributesToggled:= False;
  DOResetDefaults;
  StartStreaming := False;
  DODisabler;
  DigitizerForm2.Caption :=
    'Open File or Register Drawing: [Digitizer][Register]';
  Initialize.Enabled := False;
  Register1.Enabled := True;
{ReRegisterImage.Enabled:=True;}
  OpenFile.Enabled := True;
{  TLCoordPnt.X := -1; TLCoordPnt.Y := -1;
  BLCoordPnt.X := -1; BLCoordPnt.Y := -1;
  BRCoordPnt.X := -1; BRCoordPnt.Y := -1;
  TRCoordPnt.X := -1; TRCoordPnt.Y := -1;}

  with Image1.Canvas do
  begin
    CopyMode := cmWhiteness; { copy everything as white }
    ARect := Rect(0, 0, Image1.Width, Image1.Height);
      { get bitmap rectangle }
    CopyRect(ARect, Image1.Canvas, ARect); { copy bitmap over itself }
    CopyMode := cmSrcCopy; { restore normal mode }
  end;

  OldX := 10;
  OldY := 10;
{  SetROP2(Image1.Canvas.handle, R2_NOT);}
  Image1.Canvas.Pen.Mode := pmNotXor;
  Image1.Canvas.moveto(OldX - 1, OldY);
  Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX + 1, OldY);
  Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX, OldY + 1);
  Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
  Image1.Canvas.moveto(OldX, OldY - 1);
  Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);
{DVDORedraw;}
end;

(***********************************************************)
procedure TDigitizerForm2.FormResize(Sender: TObject);
begin
{Make the screen (image1) remain a div of 640 width 480 height}
{Height:= 480;
Width:= 640;
ClientHeight:= 503;
ClientWidth:= 644;     }
{Resize Bitmap}
{Redraw data}

  begin
{  If (ScreenRatio > 1.0) then
  begin
      RX := (RX / Scr eenRatio);
      RY := (RY / ScreenRatio);
  end;}
    PanCentroidX := 0;
    PanCentroidY := 0;
    ScreenRatio := 1.0;
    {If resizing then NOT zooming anymore}
      FitToWindow.Checked := True;
      ZoomImage.Checked := False;
      PanImage.Checked := False;
    Image1.Align := alNone;
    ProScreenHeight := DigitizerForm2.Height;
      {493- 46=Client-Stat 20= 427}
    ProScreenWidth := DigitizerForm2.Width; {644-4=Client=640}
    ScreenHeight := (ProScreenHeight - 66);
    ScreenWidth := (ProScreenWidth - 4);
    {Width is possibly PREDETERMINED   -2 to make it SQUARE 640x480}
    RX := (ScreenWidth / (CurrentRezDPI * (DigitWidth-DigitWidthSQ))); { 0.04;}
MaxDigiWidth:=(CurrentRezDPI * (DigitWidth-DigitWidthSQ));
    ScreenHeight := Round((CurrentRezDPI * DigitHeight) * (RX));
    ProScreenHeight := (ScreenHeight + 66);
    DigitizerForm2.Height := ProScreenHeight;
    RY := (ScreenHeight / (CurrentRezDPI * DigitHeight)); { 0.04;}
    Image1.Height := ScreenHeight;
    Image1.Width := ScreenWidth;
    Image1.Align := alClient;
    Bitmap.Free;
    Bitmap := TBitmap.Create;
    Bitmap.Width := ScreenWidth; {640}
    Bitmap.Height := ScreenHeight; {480}
    Image1.Picture.Graphic := Bitmap;
    {Left, Top, Right, Bottom}
    If BackGroundBitmapLoaded then
    Image1.Canvas.StretchDraw(Rect(0,0,ScreenWidth,ScreenHeight), BackGroundBitmap);

    RX := (RX * ScreenRatio);
    RY := (RY * ScreenRatio);

    Testing := False;
    DVDORedraw; {If (not DigiQuit) then DVDORedraw;}
  end;
end;

{ScreenHeight,ScreenWidth,DigitHeight,DigitWidth,CurrentRezDPI
WorldX,WorldY,WorldDX,WorldDY,}
{CheckHeight:=DigitizerForm.Height:= 546;
CheckWidth:=DigitizerForm.Width; := 648;
Sizeable change height +- size of Status bar?
CheckHeight:=DigitizerForm.ClientHeight-20:= 500;  StatusBar height=20
CheckWidth:=DigitizerForm.ClientWidth:= 640;
Image1 resizes to FIT... 640 x 480... BITMAP MUST FIT
NewBitmapHeight:=Image1.Height;
NewBitmapWidth:=Image1.Width;}
{ Both set to 480/12000 to keep aspect ratio Circles Round
   This makes the right edge of the tablet OFF the screen
   so use it as a menu ...}
{   RX := (640.0 / 18000);     as 1000 dpi : 1000 x 18 = 18000}
{   RY := (480.0 / 12000);      as 1000 dpi: 1000 x 12 = 12000 }
{   RX := (640.0 / 9000);     as 500 dpi : 500 x 18 = 9000}
{   RY := (480.0 / 6000);      as 500 dpi: 500 x 12 = 6000 }
(***********************************************************)

(*
begin
{Set up Digitizer}
ApdComPort1.ComNumber:=1;{CommNumber;}{2}
ApdComPort1.Baud:=9600;{Baud;}{9600}
ApdComPort1.DataBits:=8;{DataBits;}{8}
ApdComPort1.StopBits:=1;{StopBits;}{1}
{ApdComPort1.Parity:=Parity;  }{String;}{pOdd}
ApdComPort1.TriggerLength:=TriggerLength;
{Set up the Port of call manager}
  StatusBar1.Panels[1].Text:='Lets GO further...';
  ApdComPort1.Open:=True; {5460= 300 seconds=5 minutes}
{  TimerHandle := ApdComPort1.AddTimerTrigger;
  ApdComPort1.SetTimerTrigger(TimerHandle, 5460, True);}
                             { =LF the end of data report}
  LFHandle := ApdComPort1.AddDataTrigger(#10, FALSE);
  Application.ProcessMessages;
If ApdComPort1.OutBuffFree > 2 then
   ApdComPort1.PutChar(chr(17{RD_Start}));    {17 Resume Transmission}
 { ApdComPort1.PutChar((chr(RD_Reset)));}   {0 Resets Tablet to defaults }
{Have to wait 10 milliseconds after reset or power up to receive commands}
Sleep(10);
Application.ProcessMessages;
{   ApdComPort1.FlushOutBuffer;}
If ApdComPort1.OutBuffFree > 4 then begin
   ApdComPort1.PutChar(chr(RD_ResolutionDef));    {'j' sets to 1000 DPI }
   ApdComPort1.PutChar(chr(RD_Stream));    {64 sets to Stream mode }
   ApdComPort1.PutChar(chr(RD_IncrementCode)); {Increment mode}
   ApdComPort1.PutChar((chr(RD_IncrementDef)));{10}{32..127 = 95 }
   StatusBar1.Panels[0].Text:='Startup sent';
   end;
{   ApdComPort1.PutChar('t');}{Self Test...
                            Holds result until asked to send116=t=116}
{Create the LISTS}
AttriList:=TList.Create;
{RegList:=TList.Create;    }
PointList:=TList.Create;
LineList:=TList.Create;
AreaList:=TList.Create;
New(aDrawingAreaPnt);
New(aDrawingLnPnt);
New(aDrawingPnt);
{New(aRegPnt);}
New(aAttri);
{New(aRegPnt);aRegPnt.Reg:=1; RegList.Add(aRegPnt);
New(aRegPnt);aRegPnt.Reg:=2; RegList.Add(aRegPnt);
New(aRegPnt);aRegPnt.Reg:=3; RegList.Add(aRegPnt);
New(aRegPnt);aRegPnt.Reg:=4; RegList.Add(aRegPnt);}
 Application.ProcessMessages; {give Tablet time to respond}
end;
*)
(***********************************************************)
(***********************************************************)


(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.Register1Click(Sender: TObject);
begin
  DoPoints.Checked := False; bPointMode := False;
  DoLines.Checked := False; bLineMode := False;
  DoLineStream.Checked := False; bStreamMode := False;
  DoPolygons.Checked := False; bPolyMode := False;
  DoPolygonStream.Checked := False; bPolyStreamMode := False;
  bRegistrationMode := True;
  StartDigitizing;
  RegistrationForm.SHOW;
  RegistrationForm.InitCoordStrings;
end;
(***********************************************************)

(***********************************************************)
(*
  bRegistrationMode := True;
{  TempTLXCoord := TLXCoord;
  TempTRXCoord := TRXCoord;
  TempBLXCoord := BLXCoord;
  TempBRXCoord := BRXCoord; }
  StartDigitizing;

procedure TDigitizerForm2.DoReRegister;
begin
{BEEP WHEN OVER THE REGISTRATION POINTS
OR
Recompute the drawing to FIT the NEW registration from OLD registration
MORPH it to fit... distortion?}
{  DigitizerForm2.Caption := 'Digitizer File: ' + FileName; ;
  DigiQuit := False;}
   {Turns off boguses mouse}
{TempTLCoord:=TLCoord;
TempTRCoord:=TRCoord;
TempBLCoord:=BLCoord;
TempBRCoord:=BRCoord;}
{BEEP WHEN OVER THE REGISTRATION POINTS
OR
Recompute the drawing to FIT the NEW registration from OLD registration
MORPH it to fit... distortion?}
end;
*)
(***********************************************************)
(***********************************************************)

(***********************************************************)
procedure TDigitizerForm2.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Counter:Integer;
begin
  if (Panning and (Shift = [ssAlt])) then
    begin
     PanCentroid.X:=X;
     PanCentroid.Y:= Y;
     {PanCentroidX := Round((X - ScreenWidth) * ScreenRatio);
      PanCentroidY := Round((Y - ScreenHeight) * ScreenRatio);}
     DVDORedraw;
    end else
    {All the editing and finding commands depend on a Boolean Flag}
  if Zooming then
    begin
      if ((Button = mbLeft) and (Shift = [ssAlt])) then
        ScreenRatio := ScreenRatio * 2
      else
        if ((Button = mbRight) and (Shift = [ssAlt])) then
          ScreenRatio := ScreenRatio / 2
      else
          StatusBar1.Panels[0].Text :=
          ('Zoom: Alt + Mouse L or R Button');
       RX:=RX*ScreenRatio;
       RY:=RY*ScreenRatio;
      DVDORedraw;
    end else
  if DLGEditing then
    begin
          if (LineList.Count > 0) then
          begin
            for Counter := (LineList.Count - 1) downto 0 do
            begin
              aDrawingLnPnt := LineList.Items[Counter];
              axDrawingLnPnt.PX := aDrawingLnPnt^.PX;
              axDrawingLnPnt.PY := aDrawingLnPnt^.PY;
             If ((axDrawingLnPnt.PX =X)and
                 (axDrawingLnPnt.PY =Y))
             then
               begin
    {Search lines for the closest point
    Make a NEW DLG AREA  per Line  then call Refresh}
          New(aDrawingDLGArea);
          aDrawingDLGArea^.Layer:= DLGAreaLayer;
          aDrawingDLGArea^.Area:= DLGAreaItem;
          aDrawingDLGArea^.Line:= aDrawingLnPnt^.Line;
          DLGAreaList.Add(aDrawingDLGArea);
          inc(CurrentDLGArea);
    DigitizerForm2.InspectorRedraw(
          DObjectForm.OILayersRG.ItemIndex,4,DLGAreaItem);
               end;
            end;
          end;
    end;
end;
(***********************************************************)


(***********************************************************)
procedure TDigitizerForm2.ZoomImageClick(Sender: TObject);
begin
  Zooming := (not Zooming);
  if Zooming then begin
    FitToWindow.Checked := False;
    ZoomImage.Checked := True;
    Testing := False;
    Zooming := True;
  end else
  begin
    if (ScreenRatio <> 1.0) then
    begin
      FitToWindow.Checked := True;
      ZoomImage.Checked := False;
      PanImage.Checked := False;
      Testing := False;
      Zooming := False;
      Panning := False;
      RX := (RX / ScreenRatio);
      RY := (RY / ScreenRatio);
      ScreenRatio := 1.0;
      PanCentroidX := ScreenWidth div 2;
      PanCentroidY := ScreenHeight div 2;
      DVDORedraw;
    end else
    begin        {Not zoomed}
      FitToWindow.Checked := True;
      ZoomImage.Checked := False;
      PanImage.Checked := False;
      PanCentroidX := ScreenWidth div 2;
      PanCentroidY := ScreenHeight div 2;
      Testing := False;
      Zooming := False;
      Panning := False;
      DVDORedraw;
    end;
  end;
end;

procedure TDigitizerForm2.FitToWindowClick(Sender: TObject);
begin
    FitToWindow.Checked := True;
    ZoomImage.Checked := False;
    PanImage.Checked := False;
    Testing := False;
    Zooming := False;
    Panning := False;
    Cursor := crDefault;
    RX := (RX / ScreenRatio);
    RY := (RY / ScreenRatio);
    ScreenRatio := 1.0;
      PanCentroidX := ScreenWidth div 2;
      PanCentroidY := ScreenHeight div 2;
    DVDORedraw;
end;

procedure TDigitizerForm2.PanImageClick(Sender: TObject);
begin
  Panning := (not Panning);
  if Panning then begin
    Cursor := crDrag;
    PanImage.Checked := True;
  end else
  begin
    PanImage.Checked := False;
    Cursor := crDefault;
  end;
end;

procedure TDigitizerForm2.Resize480wClick(Sender: TObject);
begin
  Resize480w.Checked := True;
  Resize640w.Checked := False;
  Resize800w.Checked := False;
  Resize1024w.Checked := False;
  Resize1280w.Checked := False;
  DigitizerForm2.Width := 484;{488;}
  {Recreate Bitmap, then redraw.. does NOT resize Form}
  FormResize(Sender);
end;

procedure TDigitizerForm2.Resize640wClick(Sender: TObject);
begin
  Resize480w.Checked := False;
  Resize640w.Checked := True;
  Resize800w.Checked := False;
  Resize1024w.Checked := False;
  Resize1280w.Checked := False;
  DigitizerForm2.Width := 644;{648;}
  FormResize(Sender);
end;

procedure TDigitizerForm2.Resize800wClick(Sender: TObject);
begin
  Resize480w.Checked := False;
  Resize640w.Checked := False;
  Resize800w.Checked := True;
  Resize1024w.Checked := False;
  Resize1280w.Checked := False;
  DigitizerForm2.Width := 804;{808;}
  FormResize(Sender);
end;

procedure TDigitizerForm2.Resize1024wClick(Sender: TObject);
begin
  Resize480w.Checked := False;
  Resize640w.Checked := False;
  Resize800w.Checked := False;
  Resize1024w.Checked := True;
  Resize1280w.Checked := False;
  DigitizerForm2.Width := 1028;{1032;}
  FormResize(Sender);
end;

procedure TDigitizerForm2.Resize1280wClick(Sender: TObject);
begin
  Resize480w.Checked := False;
  Resize640w.Checked := False;
  Resize800w.Checked := False;
  Resize1024w.Checked := False;
  Resize1280w.Checked := True;
  DigitizerForm2.Width := 1284;{1288;}
  FormResize(Sender);
end;

procedure TDigitizerForm2.StatusTop1Click(Sender: TObject);
begin
  StatusTop1.Checked := True;
  StatusBottom1.Checked := False;
  Image1.Align := alNone;
  StatusBar1.Align := alTop;
  Image1.Align := alClient;
end;

procedure TDigitizerForm2.StatusBottom1Click(Sender: TObject);
begin
  StatusTop1.Checked := False;
  StatusBottom1.Checked := True;
  Image1.Align := alNone;
  StatusBar1.Align := alBottom;
  Image1.Align := alClient;
end;

procedure TDigitizerForm2.ShowXYDigitizing1Click(Sender: TObject);
begin
  bShowXYDigit := (not bShowXYDigit);
  if bShowXYDigit then ShowXYDigitizing1.Checked := true
  else ShowXYDigitizing1.Checked := false;
end;

procedure TDigitizerForm2.ShowCoords1Click(Sender: TObject);
begin
  bShowCoord := (not bShowCoord);
  if bShowCoord then ShowCoords1.Checked := true
  else ShowCoords1.Checked := false;
end;
(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.MRUFileListMRUItemClick(Sender: TObject;
  AFilename: TFileName);
begin
  FileName := OldFileName0;
  ClearForNewFile;
  DFOpenFiles;
end;
(***********************************************************)
procedure TDigitizerForm2.OpenFileClick(Sender: TObject);
begin
{*.dlg;*.dxf;}
{+'DLG Files ( *.dlg)|*.dlg|'
+'DXF files ( *.dxf)|*.dxf|'}
{Open a saved file}
  OpenDialog.Filter :=
    'All Known files ( *.d??)|*.drf;*.dpf;*.dlf;*.daf;*.daa|'
    + 'List files|*.drf;*.dpf;*.dlf;*.daf;*.daa';
      {Register, Point, Line,Area, Attribute}
  OpenDialog.DefaultExt := 'drf';
  OpenDialog.InitialDir := FilePath;
  OpenDialog.FileName := '*.*';
  if OpenDialog.Execute then
  begin
    if FileExists(OpenDialog.FileName) then
    begin
      ClearForNewFile;
      FileName := OpenDialog.FileName;
      MRUFileList.AddItem(FileName);
      DFOpenFiles {(FileName)};
    end else showmessage('File not there ' + FileName);
  end;
end;

procedure TDigitizerForm2.DFOpenFiles {(OpenFileNamed:String)};
var NameOfFile: string;
begin
  {14748364 Entered in About Box}
 { if (Colorreg <> 14748364)  then
  begin
    if (Started < (Now - 64)) then
    begin
      AboutTracer.ShowModal;
      if(Colorreg <> 14748364) then
      begin
        DoMessages( 30001);
        halt;
      end;
    end;
  end; }
  DODisabler;
  Register1.Enabled := True;
  OpenFile.Enabled := True;
{  FileName:=OpenFileNamed;}
  DigitizerForm2.Caption := 'Digitizer File: ' + FileName; ;
  FilePath := ExtractFilePath(FileName);
  FileTypeExt := Lowercase(ExtractFileExt(FileName));
{  if ((FileTypeExt = '.dlg')) then
  begin
    SaveFile.Caption := 'Save DLG';
    TempName := ExtractFileName(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
    LoadDLG;
  end else  }   (*
    if ((FileTypeExt = '.dxf')) then
    begin                {never happen..not on list}
      SaveFile.Caption := 'Save DXF'; {menu reminder}
      TempName := ExtractFileName(FileName);
      DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
      LoadDXF;
    end else  *)
      if ((FileTypeExt = '.drf'){registration}
       or (FileTypeExt = '.dpf') or {points}
          (FileTypeExt = '.dlf') or {Lines}
          (FileTypeExt = '.daf') or {Areas}
          (FileTypeExt = '.daa')or{Attributes}
          (FileTypeExt = '.dgf')or{DLG Areas}
          (FileTypeExt = '.dhf'){DLG Header}
          ) then
      begin
        SaveFile.Caption := 'Save List';  {menu reminder}
        TempName := ExtractFileName(FileName);
        DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
        NameOfFile := ChangeFileExt(FileName, '.dpf');
        if (FileExists(NameOfFile)) then begin
          AssignFile(aDrawingPntFile, NameOfFile);
          Reset(aDrawingPntFile);
          CurrentPoint := 0;
          while not Eof(aDrawingPntFile) do
          begin
            new(aDrawingPnt);
            Read(aDrawingPntFile, axDrawingPnt);
            aDrawingPnt^.X := axDrawingPnt.X;
            aDrawingPnt^.Y := axDrawingPnt.Y;
            aDrawingPnt^.PX := axDrawingPnt.PX;
            aDrawingPnt^.PY := axDrawingPnt.PY;
            aDrawingPnt^.PointType := axDrawingPnt.PointType;
            aDrawingPnt^.Layer := axDrawingPnt.Layer;
            aDrawingPnt^.color := axDrawingPnt.color;
            PointList.Add(aDrawingPnt);
          end;
          CloseFile(aDrawingPntFile);
        end;
{}
        NameOfFile := ChangeFileExt(FileName, '.dlf');
        if (FileExists(NameOfFile)) then begin
          AssignFile(aDrawingLnPntFile, NameOfFile);
          Reset(aDrawingLnPntFile);
          CurrentLine := 0;
          while not Eof(aDrawingLnPntFile) do
          begin
            inc(CurrentLine);
            new(aDrawingLnPnt);
            Read(aDrawingLnPntFile, axDrawingLnPnt);
            aDrawingLnPnt^.Line := axDrawingLnPnt.Line;
            aDrawingLnPnt^.X := axDrawingLnPnt.X;
            aDrawingLnPnt^.Y := axDrawingLnPnt.Y;
            aDrawingLnPnt^.PX := axDrawingLnPnt.PX;
            aDrawingLnPnt^.PY := axDrawingLnPnt.PY;
            aDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
            aDrawingLnPnt^.color := axDrawingLnPnt.color;
            aDrawingLnPnt^.LineType := axDrawingLnPnt.LineType;
            LineList.Add(aDrawingLnPnt);
          end;
          CloseFile(aDrawingLnPntFile);
        end;
{Showmessage('got to line load 2.2: '+NameOfFile); }
{}
        NameOfFile := ChangeFileExt(FileName, '.drf');
        if (FileExists(NameOfFile)) then begin
          AssignFile(aRegPntFile, NameOfFile);
          Reset(aRegPntFile);
          Read(aRegPntFile, aRegPnt1);
          Read(aRegPntFile, aRegPnt2);
          Read(aRegPntFile, aRegPnt3);
          Read(aRegPntFile, aRegPnt4);
          CloseFile(aRegPntFile);
        end;

{}
        NameOfFile := ChangeFileExt(FileName, '.daf');
        if (FileExists(NameOfFile)) then begin
          AssignFile(aDrawingAreaPntFile, NameOfFile);
          Reset(aDrawingAreaPntFile);
          CurrentArea := 0;
          while not Eof(aDrawingAreaPntFile) do
          begin
            inc(CurrentArea);
            new(aDrawingAreaPnt);
            Read(aDrawingAreaPntFile, axDrawingAreaPnt);
            aDrawingAreaPnt^.Area := axDrawingAreaPnt.Area;
            aDrawingAreaPnt^.X := axDrawingAreaPnt.X;
            aDrawingAreaPnt^.Y := axDrawingAreaPnt.Y;
            aDrawingAreaPnt^.PX := axDrawingAreaPnt.PX;
            aDrawingAreaPnt^.PY := axDrawingAreaPnt.PY;
            aDrawingAreaPnt^.Layer := axDrawingAreaPnt.Layer;
            aDrawingAreaPnt^.Pencolor := axDrawingAreaPnt.Pencolor;
            aDrawingAreaPnt^.Brushcolor := axDrawingAreaPnt.Brushcolor;
            aDrawingAreaPnt^.PolyType := axDrawingAreaPnt.PolyType;
            AreaList.Add(aDrawingAreaPnt);
          end;
          CloseFile(aDrawingAreaPntFile);
        end;

        NameOfFile := ChangeFileExt(FileName, '.daa');
        if (FileExists(NameOfFile)) then begin
          AssignFile(aAttriFile, NameOfFile);
          Reset(aAttriFile);
          CurrentAtt := 0;
          while not Eof(aAttriFile) do
          begin
            inc(CurrentAtt);
            new(aAttri);
            Read(aAttriFile, axAttri);
            aAttri^.Layer := axAttri.Layer;
            aAttri^.ObjectType := axAttri.ObjectType;
            aAttri^.Count := axAttri.Count;
            aAttri^.Major := axAttri.Major;
            aAttri^.Minor := axAttri.Minor;
            aAttri^.Descriptive := axAttri.Descriptive;
            aAttri^.ParameterMajor := axAttri.ParameterMajor;
            aAttri^.ParameterMinor := axAttri.ParameterMinor;
            AttriList.Add(aAttri);
          end;
          CloseFile(aAttriFile);
        end;
{}
        NameOfFile := ChangeFileExt(FileName, '.dgf');
        if (FileExists(NameOfFile)) then begin
          AssignFile(aDrawingDLGAreaFile, NameOfFile);
          Reset(aDrawingDLGAreaFile);
          CurrentDLGArea := 0;
          while not Eof(aDrawingDLGAreaFile) do
          begin
            inc(CurrentDLGArea);
            new(aDrawingDLGArea);
            Read(aDrawingDLGAreaFile, axDrawingDLGArea);
            aDrawingDLGArea^.Layer := axDrawingDLGArea.Layer;
            aDrawingDLGArea^.Area := axDrawingDLGArea.Area;
            aDrawingDLGArea^.Line := axDrawingDLGArea.Line;
            DLGAreaList.Add(aDrawingDLGArea);
          end;
          CloseFile(aDrawingDLGAreaFile);
        end;
        NameOfFile := ChangeFileExt(FileName, '.dhf');
        if (FileExists(NameOfFile)) then
        begin
        RegistrationForm.LoadDlgHeader(NameOfFile);

        NameOfFile := ChangeFileExt(FileName, '.dsf');
        if (FileExists(NameOfFile)) then
        begin
        RegistrationForm.Loaddsf(NameOfFile);
        RegistrationForm.LSCalculateBtnClick(Self);
        RegistrationForm.DLGDoneBtnClick(Self);
        end;
{}      end;
      end;   {List files}
  DVDORedraw;
  Movement := False;
  Testing := False;
end;

(***********************************************************)
(***********************************************************)
{SAVE file... if saved already then save as current file type
else save as Tracer list file type}
procedure TDigitizerForm2.SaveAsDLGClick(Sender: TObject);
begin {}
  if (FileName <> 'NoName.duh') then
  begin
    TempName := ExtractFileExt(FileName);
    FileName := ChangeFileExt(FileName, '.dgf');
    SaveFile.Caption := 'Save DLG List';
    TempName := ExtractFileName(FileName);
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
  end;
  SaveListAsFile;
end;
(*
begin
  SaveDialog.Filter := 'DLG files (*.dlg)|*.dlg';
  SaveDialog.DefaultExt := 'dlg';
  SaveDialog.InitialDir := FilePath;
  if (FileName = 'NoName.duh') then begin
    SaveDialog.FileName := '*.*';
  end else
  begin
    FileName := ChangeFileExt(FileName, '.dlg');
    SaveDialog.FileName := FileName;
  end;

  if SaveDialog.Execute then
  begin
    FileName := SaveDialog.FileName;
    FilePath := ExtractFilePath(SaveDialog.FileName);
    OldFileName4 := OldFileName3;
    OldFileName3 := OldFileName2;
    OldFileName2 := OldFileName1;
    OldFileName1 := OldFileName0;
    OldFileName0 := SaveDialog.FileName;
    ResetFileMenu;

    SaveFile.Caption := 'Save DLG';
    TempName := ExtractFileName(FileName);
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
    SaveDLG;
    Movement := False;
    Testing := False;
  end;
end;
*)

procedure TDigitizerForm2.SaveFileClick(Sender: TObject);
begin
  SaveListAsFile;
end;

procedure TDigitizerForm2.SaveAsListClick(Sender: TObject);
begin {}
  if (FileName <> 'NoName.duh') then
  begin
    TempName := ExtractFileExt(FileName);
    FileName := ChangeFileExt(FileName, '.dlf');
    SaveFile.Caption := 'Save List';
    TempName := ExtractFileName(FileName);
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
  end;
  SaveListAsFile;
end;

procedure TDigitizerForm2.SaveListAsFile;
var
Counter: Integer;
NameOfFile: string;
begin {Allows saving file without Dialog}
  if (FileName = 'NoName.duh') then begin
    SaveDialog.Filter :=
      'Digitizer files (*.dlf)|*.drf;*.dpf;*.dlf;*.daf;*.daa';
    SaveDialog.DefaultExt := 'drf';
    SaveDialog.InitialDir := FilePath;
    SaveDialog.FileName := '*.drf';
    if SaveDialog.Execute then begin
      FileName := SaveDialog.FileName;
      FilePath := ExtractFilePath(SaveDialog.FileName);
      SaveFile.Caption := 'Save List';
      TempName := ExtractFileName(FileName);
      FileTypeExt := ExtractFileExt(FileName);
      DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
    end;
  end;
  DigitizerForm2.Caption := 'Digitizer File: ' + FileName; ;
  FileTypeExt := Uppercase(ExtractFileExt(FileName));
  if (FileTypeExt = '.dxf') then SaveDXF else
{    if (FileTypeExt = '.dlg') then SaveDLG else}
      if (FileTypeExt = '.txt') then SaveAsciiListAsFile else
        if (FileTypeExt = '.bmp') then
          Image1.Picture.SaveToFile(FileName) else
        begin {Save as Tracer List files}
          begin
            NameOfFile := ChangeFileExt(FileName, '.drf');
            AssignFile(aRegPntFile, NameOfFile);
            Rewrite(aRegPntFile);
            Write(aRegPntFile, aRegPnt1);
            Write(aRegPntFile, aRegPnt2);
            Write(aRegPntFile, aRegPnt3);
            Write(aRegPntFile, aRegPnt4);
            CloseFile(aRegPntFile);
          end;
          if (PointList.Count > 0) then begin
{   new(asDrawingPnt);}
            NameOfFile := ChangeFileExt(FileName, '.dpf');
            AssignFile(aDrawingPntFile, NameOfFile);
            Rewrite(aDrawingPntFile);
            for Counter := 0 to (PointList.Count - 1) do begin
              aDrawingPnt := PointList.Items[Counter];
              axDrawingPnt.X := aDrawingPnt^.X;
              axDrawingPnt.Y := aDrawingPnt^.Y;
              axDrawingPnt.PX := aDrawingPnt^.PX;
              axDrawingPnt.PY := aDrawingPnt^.PY;
              axDrawingPnt.PointType := aDrawingPnt^.PointType;
              axDrawingPnt.Layer := aDrawingPnt^.Layer;
              axDrawingPnt.color := aDrawingPnt^.color;
              Write(aDrawingPntFile, axDrawingPnt);
            end;
{        Dispose(asDrawingPnt);}
            CloseFile(aDrawingPntFile);
          end;
          if (LineList.Count > 0) then begin
            NameOfFile := ChangeFileExt(FileName, '.dlf');
            AssignFile(aDrawingLnPntFile, NameOfFile);
            Rewrite(aDrawingLnPntFile);
{   new(asDrawingLnPnt);  }
            for Counter := 0 to (LineList.Count - 1) do begin
              aDrawingLnPnt := LineList.Items[Counter];
              axDrawingLnPnt.Line := aDrawingLnPnt^.Line;
              axDrawingLnPnt.X := aDrawingLnPnt^.X;
              axDrawingLnPnt.Y := aDrawingLnPnt^.Y;
              axDrawingLnPnt.PX := aDrawingLnPnt^.PX;
              axDrawingLnPnt.PY := aDrawingLnPnt^.PY;
              axDrawingLnPnt.Layer := aDrawingLnPnt^.Layer;
              axDrawingLnPnt.color := aDrawingLnPnt^.color;
              axDrawingLnPnt.LineType := aDrawingLnPnt^.LineType;
              Write(aDrawingLnPntFile, axDrawingLnPnt);
            end;
{        Dispose(asDrawingLnPnt);}
            CloseFile(aDrawingLnPntFile);
          end;
          if (AreaList.Count > 0) then begin
            NameOfFile := ChangeFileExt(FileName, '.daf');
            AssignFile(aDrawingAreaPntFile, NameOfFile);
            Rewrite(aDrawingAreaPntFile);
{   new(asDrawingAreaPnt);      }
            for Counter := 0 to (AreaList.Count - 1) do begin
              aDrawingAreaPnt := AreaList.Items[Counter];
              axDrawingAreaPnt.Area := aDrawingAreaPnt^.Area;
              axDrawingAreaPnt.X := aDrawingAreaPnt^.X;
              axDrawingAreaPnt.Y := aDrawingAreaPnt^.Y;
              axDrawingAreaPnt.PX := aDrawingAreaPnt^.PX;
              axDrawingAreaPnt.PY := aDrawingAreaPnt^.PY;
              axDrawingAreaPnt.Layer := aDrawingAreaPnt^.Layer;
              axDrawingAreaPnt.Pencolor := aDrawingAreaPnt^.Pencolor;
              axDrawingAreaPnt.Brushcolor := aDrawingAreaPnt^.Brushcolor;
              axDrawingAreaPnt.PolyType := aDrawingAreaPnt^.PolyType;
              Write(aDrawingAreaPntFile, axDrawingAreaPnt);
            end;
            CloseFile(aDrawingAreaPntFile);
          end;

          if (DLGAreaList.Count > 0) then begin
            NameOfFile := ChangeFileExt(FileName, '.dgf');
            AssignFile(aDrawingDLGAreaFile, NameOfFile);
            Rewrite(aDrawingDLGAreaFile);
            for Counter := 0 to (DLGAreaList.Count - 1) do begin
              aDrawingDLGArea := DLGAreaList.Items[Counter];
              axDrawingDLGArea.Layer := aDrawingDLGArea^.Layer;
              axDrawingDLGArea.Area := aDrawingDLGArea^.Area;
              axDrawingDLGArea.Line := aDrawingDLGArea^.Line;
              Write(aDrawingDLGAreaFile, axDrawingDLGArea);
            end;
            CloseFile(aDrawingDLGAreaFile);
          end;

          if (AttriList.Count > 0) then begin
            NameOfFile := ChangeFileExt(FileName, '.daa');
            AssignFile(aAttriFile, NameOfFile);
            Rewrite(aAttriFile);
{   new(asAttri); }
            for Counter := 0 to (AttriList.Count - 1) do begin
              aAttri := AttriList.Items[Counter];
              axAttri.Layer := aAttri^.Layer;
              axAttri.ObjectType := aAttri^.ObjectType;
              axAttri.Count := aAttri^.Count;
              axAttri.Major := aAttri^.Major;
              axAttri.Minor := aAttri^.Minor;
              axAttri.Descriptive := aAttri^.Descriptive;
              axAttri.ParameterMajor := aAttri^.ParameterMajor;
              axAttri.ParameterMinor := aAttri^.ParameterMinor;
              Write(aAttriFile, axAttri);
            end;
{        Dispose(asAttri);}
            CloseFile(aAttriFile);
          end;
          NameOfFile := ChangeFileExt(FileName, '.dhf');
          RegistrationForm.SaveDlgHeader(NameOfFile);
          NameOfFile := ChangeFileExt(FileName, '.dsf');
          RegistrationForm.SavedsfHeader(NameOfFile);
        end;
  Movement := False;
  Testing := False;
end;
(***********************************************************)
procedure TDigitizerForm2.SaveAsBMPListClick(Sender: TObject);
begin
{Create a List and Sort the Poly data and save as a file
to use in HTMLs for Image location links }
  DoMessages(201);
end;

{Save as a Shape File(s)  Poly, Line, Point WITH ATTRIBUTES!
 so TDBF DB needed}
procedure TDigitizerForm2.SaveAsSHPClick(Sender: TObject);
var NameOfFile: string;
begin
  if (FileName = 'NoName.duh') then
  begin
    SaveDialog.Filter := 'SHP files (*.shp)|*.shp';
    SaveDialog.DefaultExt := 'shp';
    SaveDialog.InitialDir := FilePath;
    SaveDialog.FileName := '*.shp';
  end else begin
    SaveDialog.Filter := 'SHP files (*.shp)|*.shp';
    SaveDialog.DefaultExt := 'shp';
    SaveDialog.InitialDir := FilePath;
    SaveDialog.FileName := ChangeFileExt(FileName, '.shp');
  end;
  if SaveDialog.Execute then
  begin
    FileName := SaveDialog.FileName;
    FilePath := ExtractFilePath(SaveDialog.FileName);
    FileName := ChangeFileExt(FileName, '.shp');

    SaveFile.Caption := 'Save SHP';
    TempName := ExtractFileName(FileName);
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
    {SaveSHP;}
    ShpSaveForm.Show;
    Movement := False;
    Testing := False;
    NameOfFile := ChangeFileExt(FileName, '.dhf');
    RegistrationForm.SaveDlgHeader(NameOfFile);
    NameOfFile := ChangeFileExt(FileName, '.dsf');
    RegistrationForm.SavedsfHeader(NameOfFile);
  end;
end;

procedure TDigitizerForm2.SaveAsDXFClick(Sender: TObject);
begin
  if (FileName = 'NoName.duh') then
  begin
    SaveDialog.Filter := 'DXF files (*.dxf)|*.dxf';
    SaveDialog.DefaultExt := 'dxf';
    SaveDialog.InitialDir := FilePath;
    SaveDialog.FileName := '*.dxf';
  end;
    if SaveDialog.Execute then
    begin
      FileName := SaveDialog.FileName;
      FilePath := ExtractFilePath(SaveDialog.FileName);

    FileName := ChangeFileExt(FileName, '.dxf');

  SaveFile.Caption := 'Save DXF';
  TempName := ExtractFileName(FileName);
  FileTypeExt := ExtractFileExt(FileName);
  DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
  SaveDXF;
  Movement := False;
  Testing := False;
    end;
end;

procedure TDigitizerForm2.SaveAsBMPClick(Sender: TObject);
begin {Save the Bitmap}
  SaveDialog.Filter := 'BMP files (*.bmp)|*.bmp';
  SaveDialog.DefaultExt := 'bmp';
  SaveDialog.InitialDir := FilePath;
    SaveDialog.FileName := ChangeFileExt(FileName, '.bmp');
  if SaveDialog.Execute then begin
    FileName := SaveDialog.FileName;
    FilePath := ExtractFilePath(SaveDialog.FileName);
    TempName := FileName;
    TempName := ChangeFileExt(TempName, '.bmp');
    Image1.Picture.SaveToFile(TempName);
    Movement := False;
    Testing := False;
    SaveFile.Caption := 'Save BMP';
    TempName := ExtractFileName(FileName);
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
  end;
end;
(***********************************************************)

procedure TDigitizerForm2.SaveAsciiListAsFile;
var
  Dubious: Boolean;
  CurrentCount, Counter: Integer;
  NameOfFile: string;
  AsciiTextFile: TextFile;
begin {0..1000's}
  if AsciiDigiz.Checked then Dubious := True
  else Dubious := False; {0..640x480  GX PX}

  AssignFile(AsciiTextFile, FileName);
  Rewrite(AsciiTextFile);

  Writeln(AsciiTextFile, 'Registration');
  Writeln(AsciiTextFile, IntToStr(aRegPnt1.Reg));
  Writeln(AsciiTextFile, IntToStr(aRegPnt1.X));
  Writeln(AsciiTextFile, IntToStr(aRegPnt1.Y));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt1.LocoX));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt1.LocoY));
  Writeln(AsciiTextFile, IntToStr(aRegPnt2.Reg));
  Writeln(AsciiTextFile, IntToStr(aRegPnt2.X));
  Writeln(AsciiTextFile, IntToStr(aRegPnt2.Y));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt2.LocoX));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt2.LocoY));
  Writeln(AsciiTextFile, IntToStr(aRegPnt3.Reg));
  Writeln(AsciiTextFile, IntToStr(aRegPnt3.X));
  Writeln(AsciiTextFile, IntToStr(aRegPnt3.Y));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt3.LocoX));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt3.LocoY));
  Writeln(AsciiTextFile, IntToStr(aRegPnt4.Reg));
  Writeln(AsciiTextFile, IntToStr(aRegPnt4.X));
  Writeln(AsciiTextFile, IntToStr(aRegPnt4.Y));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt4.LocoX));
  Writeln(AsciiTextFile, FloatToStr(aRegPnt4.LocoY));

  if (PointList.Count > 0) then begin
    Writeln(AsciiTextFile, 'Nodes');
       {   new(asDrawingPnt);}
    for Counter := 0 to (PointList.Count - 1) do begin
      aDrawingPnt := PointList.Items[Counter];
      if Dubious then
      begin
        axDrawingPnt.X := aDrawingPnt^.X;
        axDrawingPnt.Y := aDrawingPnt^.Y;
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.X));
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.Y));
      end else
      begin
        axDrawingPnt.PX := aDrawingPnt^.PX;
        axDrawingPnt.PY := aDrawingPnt^.PY;
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.PX));
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.PY));
      end;
    end; {        Dispose(asDrawingLnPnt);}
  end;

  if (LineList.Count > 0) then begin
    Writeln(AsciiTextFile, 'Lines');
{   new(asDrawingLnPnt);  }
    CurrentCount := 0;
    for Counter := 0 to (LineList.Count - 1) do begin
      aDrawingLnPnt := LineList.Items[Counter];
      axDrawingLnPnt.Line := aDrawingLnPnt^.Line;
      axDrawingLnPnt.X := aDrawingLnPnt^.X;
      axDrawingLnPnt.Y := aDrawingLnPnt^.Y;
      axDrawingLnPnt.PX := aDrawingLnPnt^.PX;
      axDrawingLnPnt.PY := aDrawingLnPnt^.PY;
      axDrawingLnPnt.color := aDrawingLnPnt^.color;
      axDrawingLnPnt.LineType := aDrawingLnPnt^.LineType;
      if (axDrawingLnPnt.Line <> CurrentCount) then {Make a new line}
      begin
        Writeln(AsciiTextFile, 'Line ' +
          IntToStr(axDrawingLnPnt.Line));
        CurrentCount := axDrawingLnPnt.Line;
      end;
      if Dubious then
      begin
        axDrawingPnt.X := aDrawingPnt^.X;
        axDrawingPnt.Y := aDrawingPnt^.Y;
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.X));
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.Y));
      end else
      begin
        axDrawingPnt.PX := aDrawingPnt^.PX;
        axDrawingPnt.PY := aDrawingPnt^.PY;
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.PX));
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.PY));
      end;
    end; { Dispose(asDrawingLnPnt);}
  end;

  if (AreaList.Count > 0) then begin
    Writeln(AsciiTextFile, 'Polygons');
{   new(asDrawingAreaPnt);      }
    CurrentCount := 0;
    for Counter := 0 to (AreaList.Count - 1) do begin
      aDrawingAreaPnt := AreaList.Items[Counter];
      axDrawingAreaPnt.Area := aDrawingAreaPnt^.Area;
      axDrawingAreaPnt.X := aDrawingAreaPnt^.X;
      axDrawingAreaPnt.Y := aDrawingAreaPnt^.Y;
      axDrawingAreaPnt.PX := aDrawingAreaPnt^.PX;
      axDrawingAreaPnt.PY := aDrawingAreaPnt^.PY;
      axDrawingAreaPnt.Pencolor := aDrawingAreaPnt^.Pencolor;
      axDrawingAreaPnt.Brushcolor := aDrawingAreaPnt^.Brushcolor;
      axDrawingAreaPnt.PolyType := aDrawingAreaPnt^.PolyType;
      if (axDrawingAreaPnt.Area <> CurrentCount) then
        {Make a new line}
      begin
        Writeln(AsciiTextFile, 'Polygon ' +
          IntToStr(axDrawingAreaPnt.Area));
        CurrentCount := axDrawingLnPnt.Line;
      end;
      if Dubious then
      begin
        axDrawingPnt.X := aDrawingPnt^.X;
        axDrawingPnt.Y := aDrawingPnt^.Y;
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.X));
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.Y));
      end else
      begin
        axDrawingPnt.PX := aDrawingPnt^.PX;
        axDrawingPnt.PY := aDrawingPnt^.PY;
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.PX));
        Writeln(AsciiTextFile, IntToStr(axDrawingPnt.PY));
      end;
    end;
{        Dispose(asDrawingAreaPnt); }
  end;
  CloseFile(AsciiTextFile);

  if (AttriList.Count > 0) then begin
    NameOfFile := ChangeFileExt(FileName, '.aaa');
    AssignFile(AsciiTextFile, NameOfFile);
    Rewrite(AsciiTextFile);
{   new(asAttri); }
    for Counter := 0 to (AttriList.Count - 1) do begin
      aAttri := AttriList.Items[Counter];
      axAttri.Count := aAttri^.Count;
      axAttri.Major := aAttri^.Major;
      axAttri.Minor := aAttri^.Minor;
      Writeln(AsciiTextFile, IntToStr(axAttri.Count));
      Writeln(AsciiTextFile, IntToStr(axAttri.Major));
      Writeln(AsciiTextFile, IntToStr(axAttri.Minor));
    end;
{        Dispose(asAttri);}
    CloseFile(AsciiTextFile);
  end;

  Movement := False;
  Testing := False;
end;

(***********************************************************)

procedure TDigitizerForm2.AsciiDigizClick(Sender: TObject);
begin
  SaveDialog.Filter := 'Digitizer files (*.txt)|*.txt';
  SaveDialog.DefaultExt := 'txt';
  SaveDialog.InitialDir := FilePath;
  if (FileName = 'NoName.duh') then
    SaveDialog.FileName := '*.txt'
  else SaveDialog.FileName := ChangeFileExt(FileName, '.txt');
  if SaveDialog.Execute then begin
    FileName := SaveDialog.FileName;
    FilePath := ExtractFilePath(SaveDialog.FileName);
    SaveFile.Caption := 'Save Ascii Digiz';
    TempName := ExtractFileName(FileName);
    AsciiDigiz.Checked := True;
    AsciiImage.Checked := False;
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
    Application.ProcessMessages;
    SaveAsciiListAsFile;
  end;
end;

procedure TDigitizerForm2.AsciiImageClick(Sender: TObject);
begin
  SaveDialog.Filter := 'Digitizer files (*.txt)|*.txt';
  SaveDialog.DefaultExt := 'txt';
  SaveDialog.InitialDir := FilePath;
  if (FileName = 'NoName.duh') then
    SaveDialog.FileName := '*.txt'
  else SaveDialog.FileName := ChangeFileExt(FileName, '.txt');
  if SaveDialog.Execute then begin
    FileName := SaveDialog.FileName;
    FilePath := ExtractFilePath(SaveDialog.FileName);
    SaveFile.Caption := 'Save Ascii Image';
    TempName := ExtractFileName(FileName);
    AsciiDigiz.Checked := False;
    AsciiImage.Checked := True;
    FileTypeExt := ExtractFileExt(FileName);
    DigitizerForm2.Caption := 'Digitizer:  ' + TempName;
    Application.ProcessMessages;
    SaveAsciiListAsFile;
  end;
end;
(*******************************************************************)
procedure TDigitizerForm2.SaveDXF;
var
  DxfOutFile: TextFile;
  OutString1, OutString2, OutString3,
    OutString, DXFLayerEditText, NameOfFile: string;
    DxfColor,
  LineListCount, Counter, DXFLineWidth: integer;
begin
  DigitizerForm2.Cursor := crHourglass;
  DXFLineWidth := 0;
  DXFLayerEditText := 'DIGITAL';
  AssignFile(DxfOutFile, CurrentFile);
  Rewrite(DxfOutFile);
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'SECTION');
  Writeln(DxfOutFile, 2);
  Writeln(DxfOutFile, 'TABLES');
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'TABLE');
  Writeln(DxfOutFile, 2);
  Writeln(DxfOutFile, 'LAYER');
  Writeln(DxfOutFile, 70);
  Writeln(DxfOutFile, 25);
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'LAYER');
  Writeln(DxfOutFile, 2);
  Writeln(DxfOutFile, DXFLayerEditText);
  Writeln(DxfOutFile, 70);
  Writeln(DxfOutFile, 2);
  Writeln(DxfOutFile, 6);
  Writeln(DxfOutFile, 'CONTINUOUS');
  Writeln(DxfOutFile, 62);
  Writeln(DxfOutFile, 1);
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'ENDTAB');
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'ENDSEC');
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'SECTION');
  Writeln(DxfOutFile, 2);
  Writeln(DxfOutFile, 'ENTITIES');
{ write Lines}
{NEED to save the COLOR!!!!}
  if CurrentColor =clRed then DxfColor :=1  else
  if CurrentColor = clYellow then DxfColor :=2  else
  if CurrentColor = clGreen then DxfColor :=3  else
  if CurrentColor =clAqua then DxfColor:=4  else
  if CurrentColor =clBlue then DxfColor :=5  else
  if CurrentColor =clMaroon then DxfColor :=6  else
  begin
  DxfColor :=7 {White.. clBlack}
  end;
  If DxfColor > 4 then ;
  LineListCount := LineList.Count;
  if (LineList.Count > 0) then
  begin
    CurrentLine := 0;
    for Counter := 0 to (LineList.Count - 1) do
    begin
      aDrawingLnPnt := LineList.Items[Counter];
      if (Counter = 0) then
      begin //  Write out Line header  First one to start
        Writeln(DxfOutFile, 0);
        Writeln(DxfOutFile, 'POLYLINE');
        Writeln(DxfOutFile, 8);
        Writeln(DxfOutFile, DXFLayerEditText);
        Writeln(DxfOutFile, 66);
        Writeln(DxfOutFile, 1);
        Writeln(DxfOutFile, 40);
        Writeln(DxfOutFile, DXFLineWidth);
        Writeln(DxfOutFile, 41);
        Writeln(DxfOutFile, DXFLineWidth);
  {Process the points into a line}
        Writeln(DxfOutFile, 0);
        Writeln(DxfOutFile, 'VERTEX');
        Writeln(DxfOutFile, 8);
        Writeln(DxfOutFile, DXFLayerEditText);
        Writeln(DxfOutFile, 10);
        str(aDrawingLnPnt^.X, OutString);
        Writeln(DxfOutFile, OutString);
        Writeln(DxfOutFile, 20);
        str(aDrawingLnPnt^.Y, OutString);
        Writeln(DxfOutFile, OutString);
        inc(CurrentLine);
      end else
        if (aDrawingLnPnt.Line <> CurrentLine) then
        begin
          DigitizerForm2.StatusBar1.Panels[0].Text :=
            MakeItAString(Round(Counter / LineListCount) * 100);
          Application.ProcessMessages;
{Write out last Lines ender and next ones - this start}
          Writeln(DxfOutFile, 0);
          Writeln(DxfOutFile, 'SEQEND');
          Writeln(DxfOutFile, 8);
          Writeln(DxfOutFile, DXFLayerEditText);

          Writeln(DxfOutFile, 0);
          Writeln(DxfOutFile, 'POLYLINE');
          Writeln(DxfOutFile, 8);
          Writeln(DxfOutFile, DXFLayerEditText);
          Writeln(DxfOutFile, 66);
          Writeln(DxfOutFile, 1);
          Writeln(DxfOutFile, 40);
          Writeln(DxfOutFile, DXFLineWidth);
          Writeln(DxfOutFile, 41);
          Writeln(DxfOutFile, DXFLineWidth);
  {Process the points into a line}
          Writeln(DxfOutFile, 0);
          Writeln(DxfOutFile, 'VERTEX');
          Writeln(DxfOutFile, 8);
          Writeln(DxfOutFile, DXFLayerEditText);
          Writeln(DxfOutFile, 10);
          str(aDrawingLnPnt^.X, OutString);
          Writeln(DxfOutFile, OutString);
          Writeln(DxfOutFile, 20);
          str(aDrawingLnPnt^.Y, OutString);
          Writeln(DxfOutFile, OutString);
          inc(CurrentLine);
        end else
        begin
  {Process the points into a line}
          Writeln(DxfOutFile, 0);
          Writeln(DxfOutFile, 'VERTEX');
          Writeln(DxfOutFile, 8);
          Writeln(DxfOutFile, DXFLayerEditText);
          Writeln(DxfOutFile, 10);
          str(aDrawingLnPnt^.X, OutString);
          Writeln(DxfOutFile, OutString);
          Writeln(DxfOutFile, 20);
          str(aDrawingLnPnt^.Y, OutString);
          Writeln(DxfOutFile, OutString);
        end;
    end;
  end;
{Write out Last Line }
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'SEQEND');
  Writeln(DxfOutFile, 8);
  Writeln(DxfOutFile, DXFLayerEditText);
{Of all Lines}
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'ENDSEC');
  Writeln(DxfOutFile, 0);
  Writeln(DxfOutFile, 'EOF');
  CloseFile(DxfOutFile);
  Application.ProcessMessages;
  begin
    NameOfFile := ChangeFileExt(CurrentFile, '.drf');
    AssignFile(aRegPntFile, NameOfFile);
    Rewrite(aRegPntFile);
    Write(aRegPntFile, aRegPnt1);
    Write(aRegPntFile, aRegPnt2);
    Write(aRegPntFile, aRegPnt3);
    Write(aRegPntFile, aRegPnt4);
    CloseFile(aRegPntFile);
  end;

  str(CurrentLine, DXFLayerEditText);
  DigitizerForm2.StatusBar1.Panels[0].Text :=
    'Number of Lines Written ' + DXFLayerEditText;
  Application.ProcessMessages;
  if (AttriList.Count > 0) then begin
    NameOfFile := ChangeFileExt(CurrentFile, '.daa');
    AssignFile(aAttriFile, NameOfFile);
    Rewrite(aAttriFile);
{    new(asAttri);}
    for Counter := 0 to (AttriList.Count - 1) do begin
      aAttri := AttriList.Items[Counter];
      axAttri.Count := aAttri^.Count;
      axAttri.Major := aAttri^.Major;
      axAttri.Minor := aAttri^.Minor;
      Write(aAttriFile, axAttri);
    end;
    CloseFile(aAttriFile);
    NameOfFile := ChangeFileExt(CurrentFile, '.att');
    AssignFile(DxfOutFile, NameOfFile);
    Rewrite(DxfOutFile);
    for Counter := 0 to (AttriList.Count - 1) do begin
      aAttri := AttriList.Items[Counter];
      axAttri.Count := aAttri^.Count;
      str(axAttri.Count, OutString1);
      axAttri.Major := aAttri^.Major;
      str(axAttri.Major, OutString2);
      axAttri.Minor := aAttri^.Minor;
      str(axAttri.Minor, OutString3);
      OutString := OutString1 + '|' + OutString2 + '|' + OutString3;
      Writeln(DxfOutFile, OutString);
    end;
{        Dispose(asAttri);}
    CloseFile(DxfOutFile);
  end;
  DigitizerForm2.Cursor := crDefault;
  Application.ProcessMessages;
end;
(*******************************************************************)

(***********************************************************)
(***********************************************************)



(***********************************************************)
(***********************************************************)

procedure TDigitizerForm2.PrintScreenClick(Sender: TObject);
var
  PrintRect: TRect;
begin
  with Printer do
  begin
    BeginDoc;
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
    if ((PageWidth > (Image1.Picture.Bitmap.Width * 2)) and
      (PageHeight > (Image1.Picture.Bitmap.Height * 2))) then
    begin
        {Rect(0, 0, Image.Width, Image.Height);}
      PrintRect := Rect(
        (PageWidth - (Image1.Picture.Bitmap.Width * 2)) div 2,
        (PageHeight - (Image1.Picture.Bitmap.Height * 2)) div 2,
        (((PageWidth - (Image1.Picture.Bitmap.Width * 2)) div 2)
        + (Image1.Picture.Bitmap.Width * 2)),
        (((PageHeight - (Image1.Picture.Bitmap.Height * 2)) div 2)
        + (Image1.Picture.Bitmap.Height * 2)));
      Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);
    end else
      if (((PageWidth - Image1.Picture.Bitmap.Width) > 0) and
        ((PageHeight - Image1.Picture.Bitmap.Height) > 0))
        then
        Canvas.Draw((PageWidth - Image1.Picture.Bitmap.Width) div 2,
          (PageHeight - Image1.Picture.Bitmap.Height) div 2,
          Image1.Picture.Bitmap)
      else
      begin
        PrintRect := Rect(
          (PageWidth - (Image1.Picture.Bitmap.Width div 2)) div 2,
          (PageHeight - (Image1.Picture.Bitmap.Height div 2)) div 2,
          (((PageWidth - (Image1.Picture.Bitmap.Width div 2)) div 2)
          + (Image1.Picture.Bitmap.Width div 2)),
          (((PageHeight - (Image1.Picture.Bitmap.Height div 2)) div 2)
          + (Image1.Picture.Bitmap.Height div 2)));
        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);
      end;
    EndDoc;
  end;
end;

procedure TDigitizerForm2.SetupPrinterClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute; {}
end;
(***********************************************************)

(***********************************************************)

procedure TDigitizerForm2.DOEnabler;
begin {}
{Initialize.Enabled:=True;
 SetDigitizerPort.Enabled:=True;}
{RestartDigitizer.Enabled:=True;Stop <> Restart}
  OpenFile.Enabled := True;
{ReRegisterImage.Enabled:=True;}
  Register1.Enabled := True;
  Increment0.Enabled := True;
  Increment1.Enabled := True;
  Increment2.Enabled := True;
  Increment3.Enabled := True;
  Increment4.Enabled := True;
  Increment5.Enabled := True;
  Increment10.Enabled := True;
  Increment15.Enabled := True;
  Increment25.Enabled := True;
  Increment35.Enabled := True;
  Increment55.Enabled := True;
  Increment95.Enabled := True;
  IncrementA.Enabled := True;
  IncrementB.Enabled := True;
  IncrementC.Enabled := True;
  RN40mm.Enabled := True;
  RN20mm.Enabled := True;
  RN10mm.Enabled := True;
  RN500.Enabled := True;
  RN1000.Enabled := True;
  RN400.Enabled := True;
  RN200.Enabled := True;
  RN100.Enabled := True;
  RN4.Enabled := True;
  RN2.Enabled := True;
  RN1.Enabled := True;
  DERR2.Enabled := True;
  DERR50.Enabled := True;
  DERR10.Enabled := True;
  DERR110.Enabled := True;
{  TestDigitizer.Enabled := True;}
  StopDigitizer.Enabled := True;
  ResetDigDefaults.Enabled := True;
  SaveAsSHP.Enabled := True;
  SaveAsBMPList.Enabled := True;
  NewFile.Enabled := True;
  SaveFile.Enabled := True;
  SaveAsBMP.Enabled := True;
  SaveAsList.Enabled := True;
  SaveAsDXF.Enabled := True;
  AsciiImage.Enabled := True;
  AsciiDigiz.Enabled := True;
  {SaveAsDLG.Enabled:=True;}
  DoLineStream.Enabled := True;
  DoPolygonStream.Enabled := True;
  DoPoints.Enabled := True;
  DoPolygons.Enabled := True;
  DoLines.Enabled := True;
  DigiDraw.Enabled := True;
  RefreshDrawing.Enabled := True;
{leave off til they work}
{ViewMenuHeader.Enabled:=True;}
ZoomImage.Enabled:=True;
FitToWindow.Enabled:=True;
PanImage.Enabled:=True;{}
  SetupPrinter.Enabled := True;
  PrintScreen.Enabled := True;
{ToolsMenuHeader.Enabled:=True;}
  DLGAttribute.Enabled := True;
  DLGHeader.Enabled := True;
ObjectInspector1.Enabled := True;
{leave off til they work
DV_ObjectToolbox.Enabled:=True;
DV_ColorToolbox.Enabled:=True;
DV_LineToolbox.Enabled:=True;
DV_SnapToolbox.Enabled:=True;
DP__Points.Enabled:=True;
DP_SnapGrid.Enabled:=True;
DP_Snapto.Enabled:=True;
DP_Gravity.Enabled:=True;
DP_LineSnap.Enabled:=True;
DP_Intersection.Enabled:=True;
DP_LineEndSnap.Enabled:=True;
DV_ShapeToolbox.Enabled:=True;
DD_Box.Enabled:=True;
DD_Arc.Enabled:=True;
DD_Circle.Enabled:=True;
Shape1.Enabled:=True;
DV_TextureToolbox.Enabled:=True;
DV_3DViewToolbox.Enabled:=True;
DV_AnnotateToolbox.Enabled:=True;
DV_DimensionToolbox.Enabled:=True;}
If myTestImage then  Vrgis24Bit1.Enabled:=True;
end;

procedure TDigitizerForm2.DODisabler;
begin
{ SetDigitizerPort.Enabled:=True;}{Always on}
  RestartDigitizer.Enabled := False; {Stop <> Restart}
  Initialize.Enabled := False;
  OpenFile.Enabled := False;
{ReRegisterImage.Enabled:=False;}
  Register1.Enabled := False;
  Increment0.Enabled := False;
  Increment1.Enabled := False;
  Increment2.Enabled := False;
  Increment3.Enabled := False;
  Increment4.Enabled := False;
  Increment5.Enabled := False;
  Increment10.Enabled := False;
  Increment15.Enabled := False;
  Increment25.Enabled := False;
  Increment35.Enabled := False;
  Increment55.Enabled := False;
  Increment95.Enabled := False;
  IncrementA.Enabled := False;
  IncrementB.Enabled := False;
  IncrementC.Enabled := False;
  RN40mm.Enabled := False;
  RN20mm.Enabled := False;
  RN10mm.Enabled := False;
  RN500.Enabled := False;
  RN1000.Enabled := False;
  RN400.Enabled := False;
  RN200.Enabled := False;
  RN100.Enabled := False;
  RN4.Enabled := False;
  RN2.Enabled := False;
  RN1.Enabled := False;
  DERR2.Enabled := False;
  DERR50.Enabled := False;
  DERR10.Enabled := False;
  DERR110.Enabled := False;
  TestDigitizer.Enabled := False;
  StopDigitizer.Enabled := False;
  ResetDigDefaults.Enabled := False;
  NewFile.Enabled := False;
  SaveAsSHP.Enabled := False;
  SaveAsBMPList.Enabled := False;
  SaveFile.Enabled := False;
  SaveAsBMP.Enabled := False;
  SaveAsList.Enabled := False;
  SaveAsDXF.Enabled := False;
AsciiImage.Enabled := False;
AsciiDigiz.Enabled := False;
  SaveAsDLG.Enabled := False;
  DoLineStream.Enabled := False;
  DoPolygonStream.Enabled := False;
  DoPoints.Enabled := False;
  DoPolygons.Enabled := False;
  DoLines.Enabled := False;
DigiDraw.Enabled := False;
  RefreshDrawing.Enabled := False;
{leave off til they work}
{ViewMenuHeader.Enabled:=False;}
  ZoomImage.Enabled := False;
  FitToWindow.Enabled := False;
  PanImage.Enabled := False;
  SetupPrinter.Enabled := False;
  PrintScreen.Enabled := False;
{ToolsMenuHeader.Enabled:=False;}
  DLGAttribute.Enabled := False;
  DLGHeader.Enabled := False;
ObjectInspector1.Enabled := False;
{leave off til they work  or exist...
DV_ObjectToolbox.Enabled:=True;
DV_ColorToolbox.Enabled:=True;
DV_LineToolbox.Enabled:=True;
DV_SnapToolbox.Enabled:=True;
DP__Points.Enabled:=True;
DP_SnapGrid.Enabled:=True;
DP_Snapto.Enabled:=True;
DP_Gravity.Enabled:=True;
DP_LineSnap.Enabled:=True;
DP_Intersection.Enabled:=True;
DP_LineEndSnap.Enabled:=True;
DV_ShapeToolbox.Enabled:=True;
DD_Box.Enabled:=True;
DD_Arc.Enabled:=True;
DD_Circle.Enabled:=True;
Shape1.Enabled:=True;
DV_TextureToolbox.Enabled:=True;
DV_3DViewToolbox.Enabled:=True;
DV_AnnotateToolbox.Enabled:=True;
DV_DimensionToolbox.Enabled:=True;}
Vrgis24Bit1.Enabled:= False;
end;

(***********************************************************)

(***********************************************************)

procedure TDigitizerForm2.DODIncrement;
begin
  Increment0.Checked := False;
  Increment1.Checked := False;
  Increment2.Checked := False;
  Increment3.Checked := False;
  Increment4.Checked := False;
  Increment5.Checked := False;
  Increment10.Checked := False;
  Increment15.Checked := False;
  Increment25.Checked := False;
  Increment35.Checked := False;
  Increment55.Checked := False;
  Increment95.Checked := False;
  IncrementA.Checked := False;
  IncrementB.Checked := False;
  IncrementC.Checked := False;
end;
(***********************************************************)

(***********************************************************)

procedure TDigitizerForm2.Increment0Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then  }
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment0)); {(0 to 95) 1 + 32 = 33 }
end;

procedure TDigitizerForm2.Increment1Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then}
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment1)); {(0 to 95) 1 + 32 = 33 }
end;

procedure TDigitizerForm2.Increment2Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then }
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment2)); {(0 to 95) 1 + 32 = 33 }
end;

procedure TDigitizerForm2.Increment5Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then }
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment5)); {(0 to 95) 5 + 32 = 37 }
end;

procedure TDigitizerForm2.Increment10Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then}
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment10)); {(0 to 95) 1 + 32 = 33 }
end;

procedure TDigitizerForm2.Increment25Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then  }
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment25)); {(0 to 95) 1 + 32 = 33 }
end;

procedure TDigitizerForm2.Increment55Click(Sender: TObject);
begin
{  If ApdComPort1.OutBuffFree >= 2 then}
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment55)); {(0 to 95) 1 + 32 = 33 }
end;

procedure TDigitizerForm2.Increment95Click(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then}
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_Increment95));
    {(0 to 95) 95 + 32 = 127 }
end;

procedure TDigitizerForm2.IncrementAClick(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then }
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_IncrementA));
    {(0 to 95) 95 + 32 = 127 }
end;

procedure TDigitizerForm2.IncrementBClick(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then   }
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_IncrementB));
    {(0 to 95) 95 + 32 = 127 }
end;

procedure TDigitizerForm2.IncrementCClick(Sender: TObject);
begin
{   If ApdComPort1.OutBuffFree >= 2 then}
  DigiCommPort.SendChar(chr(RD_IncrementCode));
    { 73 = I = Increment mode}
  DigiCommPort.SendChar(chr(RD_IncrementC));
    {(0 to 95) 95 + 32 = 127 }
end;
(***********************************************************)

procedure TDigitizerForm2.RN1000Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution1000));
  ChangeRez(1000);
end;

procedure TDigitizerForm2.RN500Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution500));
  ChangeRez(500);
end;

procedure TDigitizerForm2.RN400Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution400));
  ChangeRez(400);
end;

procedure TDigitizerForm2.RN200Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution200));
  ChangeRez(200);
end;

procedure TDigitizerForm2.RN100Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then }
  DigiCommPort.SendChar(chr(RD_Resolution100));
  ChangeRez(100);
end;

procedure TDigitizerForm2.RN4Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution4));
  ChangeRez(4);
end;

procedure TDigitizerForm2.RN2Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution2));
  ChangeRez(2);
end;

procedure TDigitizerForm2.RN1Click(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution1));
  ChangeRez(1);
end;

procedure TDigitizerForm2.RN40mmClick(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution40lpmm));
  ChangeRez(40);
end;

procedure TDigitizerForm2.RN20mmClick(Sender: TObject);
begin
 { l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then }
  DigiCommPort.SendChar(chr(RD_Resolution20lpmm));
  ChangeRez(20);
end;

procedure TDigitizerForm2.RN10mmClick(Sender: TObject);
begin
 {10mm f,20mm i,40mm q, l-1,n-2,p-4,d-100,e-200,g-400,h-500,j-1000 are the options }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Resolution10lpmm));
  ChangeRez(10);
end;
(***********************************************************)

procedure TDigitizerForm2.DERR2Click(Sender: TObject);
begin
{Report rates :	Q 110	R 50	S 10	T 2 }
{If ApdComPort1.OutBuffFree >= 1 then  }
  DigiCommPort.SendChar(chr(RD_ReportRate2));
end;

procedure TDigitizerForm2.DERR10Click(Sender: TObject);
begin
{Report rates :	Q 110	R 50	S 10	T 2 }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_ReportRate10));
end;

procedure TDigitizerForm2.DERR50Click(Sender: TObject);
begin
{Report rates :	Q 110	R 50	S 10	T 2 }
{ If ApdComPort1.OutBuffFree >= 1 then }
  DigiCommPort.SendChar(chr(RD_ReportRate50));
end;

procedure TDigitizerForm2.DERR110Click(Sender: TObject);
begin {Report rates :	Q 110	R 50	S 10	T 2 }
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_ReportRate110));
end;
(***********************************************************)

procedure TDigitizerForm2.ResetDigDefaultsClick(Sender: TObject);
begin
{ ApdComPort1.OutPut := 'ATZ'^M;}
{ If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Start {RD_Reset}));
{Have to wait 10 milliseconds after reset or power up to receive commands}
  Sleep(10);
  Application.ProcessMessages;
{Actually need to get the DEFAULTS to reset to}
{ If ApdComPort1.OutBuffFree >= 5 then}
  begin
    DigiCommPort.SendChar((chr(RD_ReportRateDef)));
    DigiCommPort.SendChar(chr(RD_Stream)); {Stream mode}
    DigiCommPort.SendChar((chr(RD_ResolutionDef)));
      {Default... sets to 1000 DPI }
    DigiCommPort.SendChar((chr(RD_IncrementCode)));
    DigiCommPort.SendChar((chr(RD_IncrementDef)));
  end {else ShowMessage('Missed a beat... reset')};
  DOResetDefaults;
                         {5460= 300 seconds=5 minutes}
{  ApdComPort1.SetTimerTrigger(TimerHandle, 5460, True);}
end;

procedure TDigitizerForm2.DOResetDefaults;
begin
  DoPoints.Checked := False; bPointMode := False;
  DoLines.Checked := False; bLineMode := False;
  DoLineStream.Checked := True; bStreamMode := True;
  DoPolygons.Checked := False; bPolyMode := False;
  DoPolygonStream.Checked := False; bPolyStreamMode := False;
  RD_ResolutionMute := RD_ResolutionDef;
  RD_ReportRateMute := RD_ReportRateDef;
  RD_IncrementMute := RD_IncrementDef;
  DODIncrement;
  DODRN;
  DODRR;
{NEED a IF THEN to RESET the MENU}

  case RD_IncrementDef of
    32: Increment0.Checked := true; {32}
    33: Increment1.Checked := true; {33}
    34: Increment2.Checked := true; {34}
    35: Increment3.Checked := true; {35}
    36: Increment4.Checked := true; {36}
    37: Increment5.Checked := true; {37}
    42: Increment10.Checked := true; {42}
    47: Increment15.Checked := true; {47}
    52: IncrementB.Checked := true; {52}
    57: Increment25.Checked := true; {57}
    62: IncrementC.Checked := true; {62}
    67: Increment35.Checked := true; {67}
    87: Increment55.Checked := true; {87}
    127: Increment95.Checked := true; {127}
  else
    begin
      RD_IncrementA := RD_IncrementDef;
      IncrementA.Checked := true; {39... changed to whatever...}
    end;
  end; {case}
  case RD_ResolutionDef of
    100: RN100.Checked := true; {100}
    101: RN200.Checked := true; {101}
    102: RN10mm.Checked := true; {102}
    103: RN400.Checked := true; {103}
    104: RN500.Checked := true; {104}
    105: RN20mm.Checked := true; {105}
    106: RN1000.Checked := true; {106}
    108: RN1.Checked := true; {108}
    110: RN2.Checked := true; {110}
    112: RN4.Checked := true; {112}
    113: RN40mm.Checked := true; {113}
  end; {Case}
  case RD_ReportRateDef of
    81: DERR110.Checked := true; {81}
    82: DERR50.Checked := true; {82}
    83: DERR10.Checked := true; {83}
    84: DERR2.Checked := true; {84}
  end; {Case}

end;

(***********************************************************)

procedure TDigitizerForm2.DODRN;
begin
  RN1000.Checked := False;
  RN500.Checked := False;
  RN400.Checked := False;
  RN200.Checked := False;
  RN100.Checked := False;
  RN4.Checked := False;
  RN2.Checked := False;
  RN1.Checked := False;
  RN40mm.Checked := False;
  RN20mm.Checked := False;
  RN10mm.Checked := False;
end;

procedure TDigitizerForm2.DODRR;
begin
  DERR2.Checked := False;
  DERR10.Checked := False;
  DERR50.Checked := False;
  DERR110.Checked := False;
end;
(***********************************************************)
(***********************************************************)
{Change the Trigger Length,
           The SCALE Gx GY ratio,
              And
                Whatever else there is to Change}

procedure TDigitizerForm2.ChangeRez(NewRez: Integer);
begin {}
  case NewRez of
    1: CurrentRezDPI := 1;
    2: CurrentRezDPI := 2;
    4: CurrentRezDPI := 4;
    10: CurrentRezDPI := 256; {mm}
    20: CurrentRezDPI := 512; {mm}
    40: CurrentRezDPI := 1016; {mm}
    100: CurrentRezDPI := 100;
    200: CurrentRezDPI := 200;
    400: CurrentRezDPI := 400;
    500: CurrentRezDPI := 500;
    1000: CurrentRezDPI := 1000;
  end;
end;
(***********************************************************)
(***********************************************************)

(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.DigiPolyStopper;
Begin
          New(aDrawingAreaPnt);
          aDrawingAreaPnt^.Area := CurrentArea;
          aDrawingAreaPnt^.X := DigitEndX;
          aDrawingAreaPnt^.Y := DigitEndY;
          aDrawingAreaPnt^.PX := DigitEndPX;
          aDrawingAreaPnt^.PY := DigitEndPY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
          AreaList.Add(aDrawingAreaPnt);
          DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
          DigitStartX := DigitEndY; DigitStartY := DigitEndY;
          StartStreaming := False;
          bPreStarted := False;
          OnGoing := False;
          StopDigitizing;
          if (bAttributesToggled) then
             AttributesForm.Show;
End;

procedure TDigitizerForm2.DigiDrawClick(Sender: TObject);
begin
  IsDigiDrawn := (not IsDigiDrawn);
  if IsDigiDrawn then
    DigiDraw.Checked := True
  else DigiDraw.Checked := False;
end;
(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.DoPointsClick(Sender: TObject);
begin
{bPointMode bLineMode bStreamMode}
If (bPolyMode or bPolyStreamMode) then
Begin
DigiPolyStopper;
End; {End the Polygon}
  bPointMode := (not bPointMode);
  if bPointMode then begin
    DoPoints.Checked := True; bPointMode := True;
    DoLines.Checked := False; bLineMode := False;
    DoLineStream.Checked := False; bStreamMode := False;
    DoPolygons.Checked := False; bPolyMode := False;
    DoPolygonStream.Checked := False; bPolyStreamMode := False;
    StopDigitizing;
    bPreStarted := False;
    StatusBar1.Panels[1].Text :='Points';
  end else DoPoints.Checked := False;
end;

procedure TDigitizerForm2.DoLinesClick(Sender: TObject);
begin
{bPointMode bLineMode bStreamMode}
If (bPolyMode or bPolyStreamMode) then
Begin
DigiPolyStopper;
End; {End the Polygon}
  bLineMode := (not bLineMode);
  if bLineMode then begin
    DoPoints.Checked := False; bPointMode := False;
    DoLines.Checked := True; bLineMode := True;
    DoLineStream.Checked := False; bStreamMode := False;
    DoPolygons.Checked := False; bPolyMode := False;
    DoPolygonStream.Checked := False; bPolyStreamMode := False;
    StopDigitizing;
    bPreStarted := False;
    StatusBar1.Panels[1].Text :='Lines';
  end else DoLines.Checked := False;
end;

procedure TDigitizerForm2.DoLineStreamClick(Sender: TObject);
begin {Stream a line segment}
{bPointMode bLineMode bStreamMode}
If (bPolyMode or bPolyStreamMode) then
Begin
DigiPolyStopper;
End; {End the Polygon}
  bStreamMode := (not bStreamMode);
  if bStreamMode then begin
    DoPoints.Checked := False; bPointMode := False;
    DoLines.Checked := False; bLineMode := False;
    DoLineStream.Checked := True; bStreamMode := True;
    DoPolygons.Checked := False; bPolyMode := False;
    DoPolygonStream.Checked := False; bPolyStreamMode := False;
    StopDigitizing;
    bPreStarted := False;
    StatusBar1.Panels[1].Text :='Lines';
  end else DoLineStream.Checked := False;
end;

procedure TDigitizerForm2.DoPolygonsClick(Sender: TObject);
begin
If (bPolyMode or bPolyStreamMode) then
Begin
DigiPolyStopper;
End; {End the Polygon}
  bPolyMode := (not bPolyMode);
  if bPolyMode then begin
    DoPoints.Checked := False; bPointMode := False;
    DoLines.Checked := False; bLineMode := False;
    DoLineStream.Checked := False; bStreamMode := False;
    DoPolygons.Checked := True; bPolyMode := True;
    DoPolygonStream.Checked := False; bPolyStreamMode := False;
    StopDigitizing;
    bPreStarted := False;
    StatusBar1.Panels[1].Text :='Polygon';
  end else DoPolygons.Checked := False;
end;

procedure TDigitizerForm2.DoPolygonStreamClick(Sender: TObject);
begin
If (bPolyMode or bPolyStreamMode) then
Begin
DigiPolyStopper;
End; {End the Polygon}
  bPolyStreamMode := (not bPolyStreamMode);
  if bPolyStreamMode then begin
    DoPoints.Checked := False; bPointMode := False;
    DoLines.Checked := False; bLineMode := False;
    DoLineStream.Checked := False; bStreamMode := False;
    DoPolygons.Checked := False; bPolyMode := False;
    DoPolygonStream.Checked := True; bPolyStreamMode := True;
    StopDigitizing;
    bPreStarted := False;
    StatusBar1.Panels[1].Text :='Polygon';
  end else DoPolygonStream.Checked := False;
end;
(***********************************************************)
(***********************************************************)


(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.PointSmear;
Begin
  Dot0.Checked := False;          {0}
  Box1.Checked := False;          {1}
  XBox2.Checked := False;         {2}
  Circle3.Checked := False;       {3}
  DotCircle4.Checked := False;    {4}
  PointX5.Checked := False;       {5}
  PointPlus6.Checked := False;    {6}
End;
procedure TDigitizerForm2.Dot0Click(Sender: TObject);
begin
  PointSmear;
  Dot0.Checked := True;
  CurrentPointType := 0;
end;

procedure TDigitizerForm2.Box1Click(Sender: TObject);
begin
  PointSmear;
  Box1.Checked := True;
  CurrentPointType := 1;
end;

procedure TDigitizerForm2.XBox2Click(Sender: TObject);
begin
  PointSmear;
  XBox2.Checked := True;
  CurrentPointType := 2;
end;

procedure TDigitizerForm2.Circle3Click(Sender: TObject);
begin
  PointSmear;
  Circle3.Checked := True;
  CurrentPointType := 3;
end;

procedure TDigitizerForm2.DotCircle4Click(Sender: TObject);
begin
  PointSmear;
  DotCircle4.Checked := True;
  CurrentPointType := 4;
end;

procedure TDigitizerForm2.PointX5Click(Sender: TObject);
begin
  PointSmear;
  PointX5.Checked := True;
  CurrentPointType := 5;
end;

procedure TDigitizerForm2.PointPlus6Click(Sender: TObject);
begin
  PointSmear;
  PointPlus6.Checked := True;
  CurrentPointType := 6;
end;
(***********************************************************)
(***********************************************************)



(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.LineSmear;
Begin
  SolidLine0.Checked := False;
  Dashline1.Checked := False;
  DotLine2.Checked := False;
  DashDotLine3.Checked := False;
  DashDotDotLine4.Checked := False;
  {psSolid  psDash  psDot psDashDot psDashDotDot}
End;

procedure TDigitizerForm2.SetLineType;
Begin  {psSolid  psDash  psDot psDashDot psDashDotDot}
  case CurrentLineType of
    0: Image1.Canvas.Pen.Style := psSolid;
    1: Image1.Canvas.Pen.Style := psDash;
    2: Image1.Canvas.Pen.Style := psDot;
    3: Image1.Canvas.Pen.Style := psDashDot;
    4: Image1.Canvas.Pen.Style := psDashDotDot;
  End;
End;

procedure TDigitizerForm2.SolidLine0Click(Sender: TObject);
begin
{psSolid	A solid line.
psDash	A line made up of a series of dashes
psDot	A line made up of a series of dots
psDashDot	A line made up of alternating dashes and dots
psDashDotDot	A line made up of a serious of dash-dot-dot combinations }
  LineSmear;
  SolidLine0.Checked := True;
  CurrentLineType := 0;
  SetLineType;
end;

procedure TDigitizerForm2.Dashline1Click(Sender: TObject);
begin
  LineSmear;
  Dashline1.Checked := True;
  CurrentLineType := 1;
  SetLineType;
end;

procedure TDigitizerForm2.DotLine2Click(Sender: TObject);
begin
  LineSmear;
  DotLine2.Checked := True;
  CurrentLineType := 2;
  SetLineType;
end;

procedure TDigitizerForm2.DashDotLine3Click(Sender: TObject);
begin
  LineSmear;
  DashDotLine3.Checked := True;
  CurrentLineType := 3;
  SetLineType;
end;

procedure TDigitizerForm2.DashDotDotLine4Click(Sender: TObject);
begin
  LineSmear;
  DashDotDotLine4.Checked := True;
  CurrentLineType := 4;
  SetLineType;
end;
(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.PolySmear;
Begin
  PolySolid.Checked := False;
  PolyBDiagonal.Checked := False;
  PolyFDiagonal.Checked := False;
  PolyCross.Checked := False;
  PolyDiagCross.Checked := False;
  PolyHorizonalLine.Checked := False;
  PolyVerticalLine.Checked := False;
  PolyClear.Checked := False;
  {  PolySolid PolyBDiagonal PolyFDiagonal
  PolyCross PolyDiagCross
  PolyHorizonalLine PolyVerticalLine
  PolyClear}
End;

{type TBrushStyle = (bsSolid, bsClear,
bsHorizontal, bsVertical, bsFDiagonal, bsBDiagonal,
 bsCross, bsDiagCross);}

procedure TDigitizerForm2.SetPolyType;
Begin  {psSolid  psDash  psDot psDashDot psDashDotDot}
  case CurrentLineType of
    0: Image1.Canvas.Brush.Style := bsSolid;
    1: Image1.Canvas.Brush.Style := bsBDiagonal;
    2: Image1.Canvas.Brush.Style := bsFDiagonal;
    3: Image1.Canvas.Brush.Style := bsCross;
    4: Image1.Canvas.Brush.Style := bsDiagCross;
    5: Image1.Canvas.Brush.Style := bsHorizontal;
    6: Image1.Canvas.Brush.Style := bsVertical;
    7: Image1.Canvas.Brush.Style := bsClear;
  End;
 Canvas.Brush.Color := CurrentBrushColor;
End;
{  PolySolid PolyBDiagonal PolyFDiagonal
  PolyCross PolyDiagCross
  PolyHorizonalLine PolyVerticalLine
  PolyClear
    CurrentColor := ColorBlack;}
procedure TDigitizerForm2.PolySolidClick(Sender: TObject);
begin
  PolySmear;
  PolySolid.Checked := True;
  CurrentPolyType := 0;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyBDiagonalClick(Sender: TObject);
begin
  PolySmear;
  PolyBDiagonal.Checked := True;
  CurrentPolyType := 1;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyFDiagonalClick(Sender: TObject);
begin
  PolySmear;
  PolyFDiagonal.Checked := True;
  CurrentPolyType := 2;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyCrossClick(Sender: TObject);
begin
  PolySmear;
  PolyCross.Checked := True;
  CurrentPolyType := 3;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyDiagCrossClick(Sender: TObject);
begin
  PolySmear;
  PolyDiagCross.Checked := True;
  CurrentPolyType := 4;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyHorizonalLineClick(Sender: TObject);
begin
  PolySmear;
  PolyHorizonalLine.Checked := True;
  CurrentPolyType := 5;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyVerticalLineClick(Sender: TObject);
begin
  PolySmear;
  PolyVerticalLine.Checked := True;
  CurrentPolyType := 6;
  SetPolyType;
end;

procedure TDigitizerForm2.PolyClearClick(Sender: TObject);
begin
  PolySmear;
  PolyClear.Checked := True;
  CurrentPolyType := 7;
  SetPolyType;
end;

(***********************************************************)
{  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Pen.Color := CurrentColor;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := CurrentBrushColor;}
(***********************************************************)
(*// Default AutoCad layer colours (1..7) - (8..user defined)
///////////////////////////////////////////////////////////////////////////////
const
  BYLAYER = 256;
const
  def_cols = 12;
  DXF_Layer_Colours : array[0..def_cols] of TColor =
    (clBlack, // zero - not used
    clRed,    clYellow, clLime,   clAqua,   clBlue,   clPurple,
    {clWhite}clBlack,
    clOlive,  clFuchsia,clTeal,   clGray,   clDkGray);    *)
procedure TDigitizerForm2.PolyColorUnclick;
begin
  PolyFillRed1.Checked := False;
  PolyFillYellow2.Checked := False;
  PolyFillLimeGreen3.Checked := False;
  PolyFillAqua4.Checked := False;
  PolyFillBlue5.Checked := False;
  PolyFillPurple6.Checked := False;
  PolyFillBlackW7.Checked := False;
end;

procedure TDigitizerForm2.PolyFillBlackW7Click(Sender: TObject);
begin
  PolyColorUnclick;
  CurrentBrushColor := clBlack;
  PolyFillBlackW7.Checked := True;
end;

procedure TDigitizerForm2.PolyFillBlue5Click(Sender: TObject);
begin   {PolyFillBlue2}
  PolyColorUnclick;
  CurrentBrushColor := clBlue;
  PolyFillBlue5.Checked := True;
end;

procedure TDigitizerForm2.PolyFillAqua4Click(Sender: TObject);
begin   {PolyFillCyan2}
  PolyColorUnclick;
  CurrentBrushColor := clAqua;
  PolyFillAqua4.Checked := True;
end;

procedure TDigitizerForm2.PolyFillLimeGreen3Click(Sender: TObject);
begin       {PolyFillGreen2}
  PolyColorUnclick;
  CurrentBrushColor := clLime;
  PolyFillLimeGreen3.Checked := True;
end;

procedure TDigitizerForm2.PolyFillRed1Click(Sender: TObject);
begin             {PolyFillRed2}
  PolyColorUnclick;
  CurrentBrushColor := clRed;
  PolyFillRed1.Checked := True;
end;

procedure TDigitizerForm2.PolyFillYellow2Click(Sender: TObject);
begin       {PolyFillYellow2}
  PolyColorUnclick;
  CurrentBrushColor := clYellow;
  PolyFillYellow2.Checked := True;
end;

procedure TDigitizerForm2.PolyFillPurple6Click(Sender: TObject);
begin
  PolyColorUnclick;
  CurrentBrushColor := clPurple;
  PolyFillPurple6.Checked := True;
end;
(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.ColorUnclick;
begin {}
  DDColorBlack.Checked := False;
  DDColorYellow.Checked := False;
  DDColorPurple.Checked := False;
  DDColor1.Checked := False;
  DDColor2.Checked := False;
  DDColor3.Checked := False;
  DDColor4.Checked := False;
  DDColor5.Checked := False;
  DDColor6.Checked := False;
  DDColor7.Checked := False;
  DDColor8.Checked := False;
  DDColor9.Checked := False;
  Black1.Checked := False;
  Green1.Checked := False;
  Red1.Checked := False;
  Yellow1.Checked := False;
  Blue1.Checked := False;
end;

procedure TDigitizerForm2.DDColorBlackClick(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := ColorBlack;
  DDColorBlack.Checked := True;
end;

procedure TDigitizerForm2.DDColor1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color1;     {Blue}
  DDColor1.Checked := True;
end;

procedure TDigitizerForm2.DDColor2Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color2;   {Cyan}
  DDColor2.Checked := True;
end;

procedure TDigitizerForm2.DDColor3Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color3;   {Green}
  DDColor3.Checked := True;
end;

procedure TDigitizerForm2.DDColor4Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color4;   {Tan Agriculture}
  DDColor4.Checked := True;
end;

procedure TDigitizerForm2.DDColor5Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color5;
  DDColor5.Checked := True;
end;

procedure TDigitizerForm2.DDColor6Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color6;
  DDColor6.Checked := True;
end;

procedure TDigitizerForm2.DDColor7Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color7;
  DDColor7.Checked := True;
end;

procedure TDigitizerForm2.DDColor8Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color8;
  DDColor8.Checked := True;
end;

procedure TDigitizerForm2.DDColor9Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := Color9;
  DDColor9.Checked := True;
end;

procedure TDigitizerForm2.DDColorYellowClick(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := ColorYELLOW;
  DDColorYellow.Checked := True;
end;

procedure TDigitizerForm2.DDColorPurpleClick(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := ColorPURPLE;
  DDColorPurple.Checked := True;
end;



procedure TDigitizerForm2.Black1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clBlack;
  Black1.Checked := True;
end;

procedure TDigitizerForm2.Magenta1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clMaroon;
  Magenta1.Checked := True;
end;

procedure TDigitizerForm2.Green1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clGreen;
  Green1.Checked := True;
end;

procedure TDigitizerForm2.Cyan1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clAqua;
  Cyan1.Checked := True;
end;

procedure TDigitizerForm2.Red1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clRed;
  Red1.Checked := True;
end;

procedure TDigitizerForm2.Yellow1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clYellow;
  Yellow1.Checked := True;
end;

procedure TDigitizerForm2.Blue1Click(Sender: TObject);
begin
  ColorUnclick;
  CurrentColor := clBlue;
  Blue1.Checked := True;
end;
(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.ClearLayers;
Begin
  N0020HY.Checked:=False;
  N1050HY.Checked:=False;
  N2070SC.Checked:=False;
  N3080NV.Checked:=False;
  N4090BD.Checked:=False;
  N5150SM.Checked:=False;
  N6170RD.Checked:=False;
  N7180RR.Checked:=False;
  N8190MT.Checked:=False;
  N9200MS.Checked:=False;
  N10300PL.Checked:=False;
  N11600PS.Checked:=False;
  AttributesForm.SetMajorAttribute;{CurrentLayer is set}
End;
procedure TDigitizerForm2.N0020HYClick(Sender: TObject);
begin
  CurrentLayer:=0;
  ClearLayers;
  N0020HY.Checked:=True;
end;
procedure TDigitizerForm2.N1050HYClick(Sender: TObject);
begin
  CurrentLayer:=1;
  ClearLayers;
  N1050HY.Checked:=True;
end;
procedure TDigitizerForm2.N2070SCClick(Sender: TObject);
begin
  CurrentLayer:=2;
  ClearLayers;
  N2070SC.Checked:=True;
end;
procedure TDigitizerForm2.N3080NVClick(Sender: TObject);
begin
  CurrentLayer:=3;
  ClearLayers;
  N3080NV.Checked:=True;
end;
procedure TDigitizerForm2.N4090BDClick(Sender: TObject);
begin
  CurrentLayer:=4;
  ClearLayers;
  N4090BD.Checked:=True;
end;
procedure TDigitizerForm2.N5150SMClick(Sender: TObject);
begin
  CurrentLayer:=5;
  ClearLayers;
  N5150SM.Checked:=True;
end;
procedure TDigitizerForm2.N6170RDClick(Sender: TObject);
begin
  CurrentLayer:=6;
  ClearLayers;
  N6170RD.Checked:=True;
end;
procedure TDigitizerForm2.N7180RRClick(Sender: TObject);
begin
  CurrentLayer:=7;
  ClearLayers;
  N7180RR.Checked:=True;
end;
procedure TDigitizerForm2.N8190MTClick(Sender: TObject);
begin
  CurrentLayer:=8;
  ClearLayers;
  N8190MT.Checked:=True;
end;
procedure TDigitizerForm2.N9200MSClick(Sender: TObject);
begin
  CurrentLayer:=9;
  ClearLayers;
  N9200MS.Checked:=True;
end;
procedure TDigitizerForm2.N10300PLClick(Sender: TObject);
begin
  CurrentLayer:=10;
  ClearLayers;
  N10300PL.Checked:=True;
end;
procedure TDigitizerForm2.N11600PSClick(Sender: TObject);
begin
 CurrentLayer:=11;
 ClearLayers;
  N11600PS.Checked:=True;
end;
(***********************************************************)
(***********************************************************)
procedure TDigitizerForm2.DH_HelpContentsClick(Sender: TObject);
begin
  Application.HelpContext(0);
end;
procedure TDigitizerForm2.OnHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;
procedure TDigitizerForm2.DH_HowDoIHelpClick(Sender: TObject);
begin
  Application.HelpContext(1);
end;
procedure TDigitizerForm2.AboutClick(Sender: TObject);
begin
  AboutTracer.ShowModal;
end;

procedure TDigitizerForm2.DLGAttributeClick(Sender: TObject);
begin
  AttributesForm.Show;
end;

procedure TDigitizerForm2.DLGHeaderClick(Sender: TObject);
begin
  RegistrationForm.Show;
{  RegistrationForm.InitCoordStrings;   }
end;

procedure TDigitizerForm2.ObjectInspector1Click(Sender: TObject);
begin
  DObjectForm.Show;
  {Search object - Mouse it or Drag a circle:
  Circle expands the search radius}
end;

procedure TDigitizerForm2.DataList1Click(Sender: TObject);
begin
  DataForm.Show;
end;

procedure TDigitizerForm2.SerialPortSettingsClick(Sender: TObject);
begin
  DigitizerSettingsForm.Show;
end;
(***********************************************************)
(***********************************************************)
(***********************************************************)
(***********************************************************)
(*
procedure TDigitizerForm2.ApdComPort1TriggerData(CP: TObject;
 TriggerHandle: Word);
var TooLong:Integer;
begin{}
If (TriggerHandle = LFHandle) then begin{DO all the stuff with sInput }
TooLong:=Length(sInput);
{If (TooLong >13) then begin TooLong:=TooLong-13; Delete(sInput,1,TooLong);end;
TooLong:=Length(sInput);}
   If ((TooLong=13) or (TooLong=11)) then begin
{   StatusBar1.Panels[0].Text:= sInput;}
{   SXY:='';SXY:=sInput;}
   If TooLong =13 then ChangeUp13
   Else If TooLong =11 then ChangeUp11
   ;{else  MessageDlg(sInput,mtInformation,[mbOk], 0);}
   Number;
   sInput := '';
   end else sInput := '';
{
end else If TriggerHandle =TesterHandle then begin
{DO all the Test stuff with sInput... WHAT Calls this?
Menu RESETS this trigger}
  sInput := '';
end else If TriggerHandle =ModelIDHandle then begin
{    Menu RESETS this trigger}
{    Keep the string to verify and then get the next 4 Char( X.X)}
      sInput := '';
ApdComPort1.RemoveTrigger(ModelIDHandle);
}
end else If TriggerHandle =TimerHandle then begin
{DO all the Timer Reset or Stop stuff with sInput }
 {If any movement then RESET Trigger else STOP}
   If Testing = False then begin {Start last minute}
    Movement := False;Testing := True;     {1092=1 minute}
{    ApdComPort1.SetTimerTrigger(TimerHandle, 1092, True);}
    end else  If Testing = True then begin {Check last minute}
      If Movement = True then begin {Reset to 5 minutes}
{      ApdComPort1.SetTimerTrigger(TimerHandle, 5460, True);}
      end else begin SavedbyTimer;Close;end;{time is UP: Close}
    end;
end;
end;
*)
(*
procedure TDigitizerForm2.ApdComPort1TriggerAvail(CP: TObject; Count: Word);
var
  I : Word;  C : Char;
  sConfig,  sCode,  sModel:String;
begin

{sInput := '';}
  for I := 1 to Count do begin
{      C := ApdComPort1.GetChar;}
      Case C of
           #0..#43: ;{Skip all to ,}
           else sInput := sInput + C;
      end;
    end;
If TestDigitizer.Checked then begin
C:= sInput[1];
If (C <> 'O') then MessageDlg('Digitizer Error !'+C, mtError,[mbOk], 0);
sConfig:=Copy(sInput,2,13);
sCode:=Copy(sInput,15,5);
sModel:=Copy(sInput,20,45);
MessageDlg(
    'Digitizer OK = O: '+C+#13+
    'X Rez,Y Rez,Button:'+sConfig+#13+
    'Check code: Always the same per digitizer: '+sCode+#13+
    sModel, mtInformation,[mbOk], 0);
sInput :='';
TestDigitizer.Checked := False;
{LFHandle := ApdComPort1.AddDataTrigger(#10, FALSE);}
{ApdComPort1.TriggerLength:=TriggerLength;}
end;
end;
*)
(***********************************************************)
{[1]Test: O  a oh (O) means all ok
[13]Config: Tablet ID Button values Axis resolution: X,Y,Button
Config: 18000,12000,0
[5]code check: .FC74
[53]Model ID: MM1812... 1.1
xy xy xy xy xy xy xy button}
(***********************************************************)
(***********************************************************)
    {Send 'w' Receive 'O' if passed all tests}
 { TesterHandle := ApdComPort1.AddDataTrigger('O', False);}
  {Self Test t  6-3   Send Test w  6-4}
{ If ApdComPort1.OutBuffFree >= 1 then Send Configuration a   3-26}
{Checking := True;  Add data triggers for OK..other bad signs...
 do message, remove trigger }
{ENQ Send Model ID ENQ 6-8  RD_ModelID }
{  ModelIDHandle := ApdComPort1.AddDataTrigger(ModelID, True);}
{ If ApdComPort1.OutBuffFree >= 1 then Echo k  RD_Echo}
{Set a boolean that is checked inside the_Avail for sending to Statusbar Only}
(***********************************************************)

procedure TDigitizerForm2.TestDigitizerClick(Sender: TObject);
begin
  if TestDigitizer.Checked then begin
    TestDigitizer.Checked := False;
{LFHandle := ApdComPort1.AddDataTrigger(#10, FALSE);
ApdComPort1.TriggerLength:=TriggerLength;}
{ApdComPort1.AddTrigger(LFHandle)}
  end else begin
    TestDigitizer.Checked := True;
{ApdComPort1.RemoveTrigger(LFHandle);}
{Set triggerlength to ...80}
(*
ApdComPort1.TriggerLength:=80;
If ApdComPort1.OutBuffFree >= 6 then begin
    ApdComPort1.PutChar(chr(RD_SendTest));{'w'Sends request for result of setup...}
    ApdComPort1.PutChar(chr(RD_CheckConfig));{Send Configuration a   3-26}
    ApdComPort1.PutChar(chr(RD_CodeCheck));   { 120 = x = Code Check }
    ApdComPort1.PutChar(chr(RD_ModelID));
    ApdComPort1.PutChar(chr(RD_Test)); {'t'test request for next time}
    end;
*)
  end;
end;
(**********************************************************)
(**********************************************************)

procedure TDigitizerForm2.StopDigitizerClick(Sender: TObject);
begin
{If ApdComPort1.OutBuffFree >= 1 then}
  DigiCommPort.SendChar(chr(RD_Stop)); {XOFFCHAR #19 XONCHAR #17}
end;

procedure TDigitizerForm2.RestartDigitizerClick(Sender: TObject);
begin
{ If ApdComPort1.OutBuffFree >= 1 then }
  DigiCommPort.SendChar(chr(RD_Start)); {Restart data transmission}
                         {5460= 300 seconds=5 minutes}
  DigiCommPort.SendChar(chr(RD_Stream)); { sets to Stream mode }
{  ApdComPort1.SetTimerTrigger(TimerHandle, 5460, True); }
  DoEnabler;
  Testing := false;
  RestartDigitizer.Enabled := False;
end;

(***********************************************************)
{These switch on and off the FINE-CLOSE mode
digitizing - just Moving}

procedure TDigitizerForm2.StartDigitizing;
begin {}
{If ApdComPort1.OutBuffFree > 5 then begin}
  DigiCommPort.SendChar((chr(RD_ReportRateDigit)));
  DigiCommPort.SendChar(chr(RD_ResolutionDigit));
    {'j' sets to 1000 DPI }
  DigiCommPort.SendChar(chr(RD_Stream)); {64 sets to Stream mode }
  DigiCommPort.SendChar(chr(RD_IncrementCode)); {Increment mode}
  DigiCommPort.SendChar((chr(RD_IncrementDigit))); {1} {32..127 = 95 }
{ApdComPort1.PutChar
   end else ShowMessage('Missed a beat... reset');}
   {clBtnFace}
{  StatusBar1.Color := clActiveCaption;
  StatusBar1.Font.Color :=clCaptionText;}
  {clActiveCaption clCaptionText
   clInactiveCaption clInactiveCaptionText
 clBtnFace  clWindowText }
end;

procedure TDigitizerForm2.StopDigitizing;
begin {}
{If ApdComPort1.OutBuffFree > 5 then begin}
  DigiCommPort.SendChar((chr(RD_ReportRateMute)));
  DigiCommPort.SendChar(chr(RD_ResolutionMute));
    {'j' sets to 1000 DPI }
  DigiCommPort.SendChar(chr(RD_Stream)); {64 sets to Stream mode }
  DigiCommPort.SendChar(chr(RD_IncrementCode)); {Increment mode}
  DigiCommPort.SendChar((chr(RD_IncrementMute))); {55} {32..127 = 95 }
{   end else ShowMessage('Missed a beat... reset');}
{  StatusBar1.Color :=clInactiveCaption;
  StatusBar1.Font.Color :=clInactiveCaptionText; }
  {clActiveCaption clCaptionText
   clInactiveCaption clInactiveCaptionText
 clBtnFace  clWindowText }
end;
(***********************************************************)

procedure TDigitizerForm2.DigiCommPortReceiveData(Sender: TObject;
  DataPtr: Pointer; DataSize: Cardinal);
var
  I: Word; C: Char; {  sConfig,  sCode,  sModel:String; }
  TooLong: Integer;
  s: string; {DigitString:='';}
begin
{Capture data into s then chew on it until it is gone}
  // Convert incoming data into a string
  s := StringOfChar(' ', DataSize);
  move(DataPtr^, pchar(s)^, DataSize);
  // Exit if s is empty.
  //This usually occurs when one or more
  //NULL characters (chr(0)) are received.
  while pos(#0, s) > 0 do
    delete(s, pos(#0, s), 1);
  if s = '' then
    exit;
{DigitString:=DigitString+s;}
{sInput := '';}
  for I := 1 to DataSize {Count} do begin
    C := {DigitString} s[I];
{      delete( DigitString, 1, 1 ); }
    case C of
      #0..#12: ;
      #13: {CR is 13  10 is LFHandle}
        begin {XXXXX,YYYYY,F<CR><LF>}
            {too Long to handle}
{If (TriggerHandle = LFHandle) then}
          begin
{DO all the stuff with sInput }
            TooLong := Length(sInput);
      {If (TooLong >13) then
      begin
      TooLong:=TooLong-13;
      Delete(sInput,1,TooLong);
      end;
      TooLong:=Length(sInput);}
            if ((TooLong = 13) or (TooLong = 11)) then
            begin
       {StatusBar1.Panels[0].Text:= sInput;}
       {SXY:='';SXY:=sInput;}
              if TooLong = 13 then ChangeUp13
              else if TooLong = 11 then ChangeUp11
                ; {else  MessageDlg(sInput,mtInformation,[mbOk], 0);}
              Number;
              sInput := '';
            end
            else sInput := '';
          end; {Trigger}

        end;
      #14..#43: ; {Skip all to ,}
           {#10 Gets Line Feeds?
           and this gets all numbers, letters}
    else sInput := sInput + C;
    end; {Case}
  end;
end;
(**********************************************************)
(************* START of DIGITIZER translation *************)
(**********************************************************)

procedure TDigitizerForm2.ChangeUp13;
var
  Check: Integer;
{1} begin
  FillChar(XS, SizeOf(XS), '0');
  XS[0] := Char(Pred(Sizeof(XS)));
  FillChar(YS, SizeOf(YS), '0');
  YS[0] := Char(Pred(Sizeof(YS)));
  Button := 0;
{1000 lpi}{XXXXX,YYYYY,F}
             {13} Val(sInput[13], Button, Check);
             {11} YS[5] := sInput[11];
             {10} YS[4] := sInput[10];
             {9} YS[3] := sInput[9];
             {8} YS[2] := sInput[8];
           {7,6} YS[1] := sInput[7];
             {5} XS[5] := sInput[5];
             {4} XS[4] := sInput[4];
             {3} XS[3] := sInput[3];
             {2} XS[2] := sInput[2];
             {1} XS[1] := sInput[1];
end;
(********************************************)
(********************************************)

procedure TDigitizerForm2.ChangeUp11;
var
  Check: Integer;
{1} begin
  FillChar(XS, SizeOf(XS), '0');
  XS[0] := Char(Pred(Sizeof(XS))); {Move?}
  FillChar(YS, SizeOf(YS), '0');
  YS[0] := Char(Pred(Sizeof(YS))); {move?}
  Button := 0;
{500 lpi}{XXXX,YYYY,F}
             {13} Val(sInput[11], Button, Check);
             { 0} YS[4] := sInput[9];
             {9} YS[3] := sInput[8];
             {8} YS[2] := sInput[7];
           {7,6} YS[1] := sInput[6];
             {4} XS[4] := sInput[4];
             {3} XS[3] := sInput[3];
             {2} XS[2] := sInput[2];
             {1} XS[1] := sInput[1];
end; { of ChangeUp  ... to X Y }
(*******************************************************)

(********************************************************)
{ ConvertLLtoXY(LSRegPntArray[9].LongXDD, LSRegPntArray[9].LatYDD,
               LSRegPntArray[9].LongXx, LSRegPntArray[9].LatYy);
DXdtemp:=LongXCoord;
DYdtemp:=LatYCoord;
            dXTemp:=DXdtemp*UnitFactorLL;
            dYTemp:=DYdtemp*UnitFactorLL;
          DoLLtoXY( dXTemp,dYTemp,
                    DXdtemp,DYdtemp);
          DXtemp:=ToDDegreeFactorLL*dXdTemp;
          DYtemp:=ToDDegreeFactorLL*dYdTemp;
          XCoord:=DXtemp;
          YCoord:=DYtemp;                                               }
Function TDigitizerForm2.DoXScaleRatio(InX:Integer):Double;
{var
  Term : Integer;
  Temp:Double;}
Begin
{  Temp:=0;
  for Term := 1 to NumTerms do
      Temp := Temp+ (InX*LSRegPntArray[Term].SolutionX);
DoXScaleRatio:=(Temp+XOrigin);}
DoXScaleRatio:=(InX* XScaleRatio)+XOrigin;
End;
Function TDigitizerForm2.DoYScaleRatio(InY:Integer):Double;
{var
  Term : Integer;
  Temp:Double;}
Begin
{  Temp:=0;
  for Term := 1 to NumTerms do
      Temp := Temp+ (InY*LSRegPntArray[Term].SolutionY);
DoYScaleRatio:=(Temp+YOrigin);}
DoYScaleRatio:=(InY* YScaleRatio)+YOrigin;
End;
procedure TDigitizerForm2.Number;
var
 CheckX, CheckY: Integer;
 XString, YString:String;
var
  DXtemp,DYtemp, DXdtemp,DYdtemp:Double;
begin
  Val(XS, InX, CheckX);
  if CheckX = 0 then GX := (Round(InX * RX)); {Halt;}
  Val(YS, InY, CheckY); { to fix Up<>Down }
  if CheckY = 0 then GY := (ScreenHeight - (Round(InY * RY))); {Halt;}
  if ((CheckY + CheckX) = 0) then
  begin
    if ((InX < MaxDigiWidth) and (bShowXYDigit)) then
    begin
      StatusBar1.Panels[1].Text := 'X: ' + XS + '  Y: ' + YS;
        Str(GX, XS);
        Str(GY, YS);
      StatusBar1.Panels[2].Text :=
                        'X: ' + XS +',Y: ' + YS;
    end;
    If (bShowCoord) then
      begin
        If (bLatLonSet)then
        begin        {SHP Transform to Valid data}
        {XString:=Floattostrf( DoXScaleRatio(InX-LowerDigiLocoX)
                              ,ffFixed	,15,6 );
        YString:=Floattostrf( DoYScaleRatio(InY-LowerDigiLocoY)
                              ,ffFixed	,15,6 );}
DXdtemp:=(((InX-LowerDigiLocoX)* XScaleRatio)+XOrigin);
DYdtemp:=(((InY-LowerDigiLocoY)* YScaleRatio)+YOrigin);
            dXTemp:=DXdtemp*UnitFactorLL;
            dYTemp:=DYdtemp*UnitFactorLL;
          DoLLtoXY( dXTemp,dYTemp,
                    DXdtemp,DYdtemp);
          DXtemp:=ToDDegreeFactorLL*dXdTemp;
          DYtemp:=ToDDegreeFactorLL*dYdTemp;     {Display decimal level 2= 0.xx}
        XString:=Floattostrf( DXtemp,ffFixed	,15,2 );
        YString:=Floattostrf( DYtemp,ffFixed	,15,2 );
        end else
        If (bDxfSet)then
        begin        {DXF Transform }
        XString:=Floattostrf(((InX-LowerDigiLocoX)* DXFXScaleRatio)+DXFXOrigin,ffFixed{ffNumber}	,15,2 );
        YString:=Floattostrf(((InY-LowerDigiLocoY)* DXFXScaleRatio)+DXFYOrigin,ffFixed{ffNumber}	,15,2 );
        end else
        begin        {Raw Ratioed Coords}
        Str(GX, XString);
        Str(GY, YString);
        end;
        Str(Button, sInput); {Pixeled Coords}
        StatusBar1.Panels[0].Text :=
                        'X: ' + XString +
                        ' Y: ' + YString +
                        ' Button:' + sInput;
      end;

    if ((bStreamMode and IsDigiDrawn)
       or(bPolyStreamMode and IsDigiDrawn)) then
    begin
      DoPixel; {Skip the cursor display}
    end
    else begin
      XYMove;
    end;
  end else showmessage('Bad Coord sent ' + XS + ' ' + YS);
end; { of XYPixel   ... Cursor Graph Depict }
(********************************************************)

procedure TDigitizerForm2.XYMove; {  Cursor depiction }
{ Set OldX and OldY to 10 at start of program... as a variable }
begin
  Image1.Canvas.Pen.Mode := pmNotXor;
  Image1.Canvas.moveto(OldX - 1, OldY);
  Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX + 1, OldY);
  Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX, OldY + 1);
  Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
  Image1.Canvas.moveto(OldX, OldY - 1);
  Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);
  Image1.Canvas.Pen.Mode := pmCopy;
{  SetROP2(Image1.Canvas.handle, R2_COPYPEN);}
  DoPixel;
  If CursorSizeChanged=True then
  begin
    CurrentCursorSize:= TempCursorSize;
    CursorSizeChanged:=False;
  end;
  Image1.Canvas.Pen.Mode := pmNotXor;
{  SetROP2(Image1.Canvas.handle, R2_NOT);}
  Image1.Canvas.moveto(GX - 1, GY);
  Image1.Canvas.lineto(GX - CurrentCursorSize, GY);
  Image1.Canvas.moveto(GX + 1, GY);
  Image1.Canvas.lineto(GX + CurrentCursorSize, GY);
  Image1.Canvas.moveto(GX, GY + 1);
  Image1.Canvas.lineto(GX, GY + CurrentCursorSize);
  Image1.Canvas.moveto(GX, GY - 1);
  Image1.Canvas.lineto(GX, GY - CurrentCursorSize);
  OldX := GX;
  OldY := GY;
end; { of XYShow   ... Cursor Graph Depict }
(**************************************************************)

procedure TDigitizerForm2.DoPixel;
{ This is where the Data structure MUST get its input and
  SAVE the Chosen Pixels}
                                 {Buttons}{1}
                             {2   4}
begin {3}
  If InX>MaxDigiWidth then {GX > 640 SO... Get MENU item}
  Begin  {Turn into Procedure DoDigiMenu(InY:Integer);}
        Case InY of
          0..250: Begin  StatusBar1.Panels[1].Text :='POINTS';
                  Case Button of 1..4:DoPointsClick(Self);end;end;
          251..500: Begin  StatusBar1.Panels[1].Text :='Dot Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); Dot0Click(Self); End;end;end;
          501..750: Begin  StatusBar1.Panels[1].Text :='Box Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); Box1Click(Self); End;end;end;
          751..1000: Begin  StatusBar1.Panels[1].Text :='XBox Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); XBox2Click(Self); End;end;end;
          1001..1250: Begin  StatusBar1.Panels[1].Text :='Circle Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); Circle3Click(Self); End;end;end;
          1251..1500: Begin  StatusBar1.Panels[1].Text :='Dot Circle Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); DotCircle4Click(Self); End;end;end;
          1501..1750: Begin  StatusBar1.Panels[1].Text :='X Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); PointX5Click(Self); End;end;end;
          1751..2000: Begin  StatusBar1.Panels[1].Text :='Plus sign Point';
                    Case Button of 1..4:Begin DoPointsClick(Self); PointPlus6Click(Self); End;end;end;

          2001..2250: Begin  StatusBar1.Panels[1].Text :='LINES';
                  Case Button of 1..4:DoLinesClick(Self);end;end;
          2251..2500: Begin  StatusBar1.Panels[1].Text :='Line Stream';
                  Case Button of 1..4:DoLineStreamClick(Self);end;end;
          2501..2750: Begin  StatusBar1.Panels[1].Text :='Invisible Stream';
                  Case Button of 1..4:DigiDrawClick(Self);end;end;

          2751..3000: Begin  StatusBar1.Panels[1].Text :='Plus sign Point';
                    Case Button of 1..4:Begin SolidLine0Click(Self); End;end;end;
          3001..3250: Begin  StatusBar1.Panels[1].Text :='Plus sign Point';
                    Case Button of 1..4:Begin Dashline1Click(Self); End;end;end;
          3251..3500: Begin  StatusBar1.Panels[1].Text :='Plus sign Point';
                    Case Button of 1..4:Begin  DotLine2Click(Self); End;end;end;
          3501..3750: Begin  StatusBar1.Panels[1].Text :='Plus sign Point';
                    Case Button of 1..4:Begin  DashDotLine3Click(Self); End;end;end;
          3751..4000: Begin  StatusBar1.Panels[1].Text :='Plus sign Point';
                    Case Button of 1..4:Begin  DashDotDotLine4Click(Self); End;end;end;

          4001..4250: Begin  StatusBar1.Panels[1].Text :='POLYGONS';
                    Case Button of 1..4:Begin DoPolygonsClick(Self);End;end;end;
          4251..4500: Begin  StatusBar1.Panels[1].Text :='POLYGON STREAM';
                    Case Button of 1..4:Begin DoPolygonStreamClick(Self);End;end;end;
          4501..4750: Begin  StatusBar1.Panels[1].Text :='Solid POLYGON';
                    Case Button of 1..4:Begin PolySolidClick(Self);End;end;end;
          4751..5000: Begin  StatusBar1.Panels[1].Text :='/ Diagonal POLYGON';
                    Case Button of 1..4:Begin PolyBDiagonalClick(Self);End;end;end;
          5001..5250: Begin  StatusBar1.Panels[1].Text :='\ Diagonal POLYGON';
                    Case Button of 1..4:Begin PolyFDiagonalClick(Self);End;end;end;
          5251..5500: Begin  StatusBar1.Panels[1].Text :='Crosshatch POLYGON';
                    Case Button of 1..4:Begin PolyCrossClick(Self);End;end;end;
          5501..5750: Begin  StatusBar1.Panels[1].Text :='Diagonal Cross POLYGON';
                    Case Button of 1..4:Begin PolyDiagCrossClick(Self);End;end;end;
          5751..6000: Begin  StatusBar1.Panels[1].Text :='Horizonal Line POLYGON';
                    Case Button of 1..4:Begin PolyHorizonalLineClick(Self);End;end;end;
          6001..6250: Begin  StatusBar1.Panels[1].Text :='POLYGON';
                    Case Button of 1..4:Begin PolyVerticalLineClick(Self);End;end;end;
          6251..6500: Begin  StatusBar1.Panels[1].Text :='Vertical Line POLYGON';
                    Case Button of 1..4:Begin PolyClearClick(Self);End;end;end;

          6501..6750: Begin  StatusBar1.Panels[1].Text :='Refresh Drawing';
                    Case Button of 1..4:Begin RefreshDrawingClick(Self);End;end;end;
          6751..7000: Begin  StatusBar1.Panels[1].Text :='Black Color';
                    Case Button of 1..4:Begin DDColorBlackClick(Self);End;end;end;
          7001..7250: Begin  StatusBar1.Panels[1].Text :='Blue Color';
                    Case Button of 1..4:Begin DDColor1Click(Self);End;end;end;
          7251..7500: Begin  StatusBar1.Panels[1].Text :='Cyan Color';
                    Case Button of 1..4:Begin DDColor2Click(Self);End;end;end;
          7501..7750: Begin  StatusBar1.Panels[1].Text :='Green Color';
                    Case Button of 1..4:Begin DDColor3Click(Self);End;end;end;
          7751..8000: Begin  StatusBar1.Panels[1].Text :='Tan Ag [Light Green]  Color';
                    Case Button of 1..4:Begin DDColor4Click(Self);End;end;end;
          8001..8250: Begin  StatusBar1.Panels[1].Text :='Orange Rangeland [Tan] Color';
                    Case Button of 1..4:Begin DDColor5Click(Self);End;end;end;
          8251..8500: Begin  StatusBar1.Panels[1].Text :='Light Green Tundra [Tan2]Color';
                    Case Button of 1..4:Begin DDColor6Click(Self);End;end;end;
          8501..8750: Begin  StatusBar1.Panels[1].Text :='Tan2 Barren [Orange]Color';
                    Case Button of 1..4:Begin DDColor7Click(Self);End;end;end;
          8751..9000: Begin  StatusBar1.Panels[1].Text :='Red Color';
                    Case Button of 1..4:Begin DDColor8Click(Self);End;end;end;
          9001..9250: Begin  StatusBar1.Panels[1].Text :='Gray Color';
                    Case Button of 1..4:Begin DDColor9Click(Self);End;end;end;
          9251..9500: Begin  StatusBar1.Panels[1].Text :='Yellow Color';
                    Case Button of 1..4:Begin DDColorYellowClick(Self);End;end;end;
          9501..9750: Begin  StatusBar1.Panels[1].Text :='Purple Color';
                    Case Button of 1..4:Begin DDColorPurpleClick(Self);End;end;end;

          9751..10000: Begin  StatusBar1.Panels[1].Text :='Red Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillRed1Click(Self);End;end;end;
          10001..10250:  Begin  StatusBar1.Panels[1].Text :='Yellow Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillYellow2Click(Self);End;end;end;
          10251..10500: Begin  StatusBar1.Panels[1].Text :='LimeGreen Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillLimeGreen3Click(Self);End;end;end;
          10501..10750: Begin  StatusBar1.Panels[1].Text :='Aqua Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillAqua4Click(Self);End;end;end;
          10751..11000: Begin  StatusBar1.Panels[1].Text :='Blue Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillBlue5Click(Self);End;end;end;
          11001..11250: Begin  StatusBar1.Panels[1].Text :='Purple Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillPurple6Click(Self);End;end;end;
          11251..11500: Begin  StatusBar1.Panels[1].Text :='Black Poly Fill Color';
                    Case Button of 1..4:Begin PolyFillBlackW7Click(Self);End;end;end;


          11501..11750: Begin  StatusBar1.Panels[1].Text :='Show XY Values';
                    Case Button of 1..4:Begin ShowXYDigitizing1Click(Self);End;end;end;
          11751..12000: Begin  StatusBar1.Panels[1].Text :='Show Coords';
                    Case Button of 1..4:Begin ShowCoords1Click(Self);End;end;end;
          else Begin BEEP; StatusBar1.Panels[1].Text :='MENU ITEM Error';End;
      Application.ProcessMessages;
    end;{Case}
  end else
  Begin
  Application.ProcessMessages;

  if bPointMode then begin
    case Button of
      1..2: begin
          case CurrentPointType of
            0: {PntDot} Image1.Canvas.Pixels[GX, GY] := CurrentColor;
            1: {PntBox X1, Y1, X2, Y2}
              begin
                Image1.Canvas.Pen.Color := CurrentColor;
                Image1.Canvas.Rectangle(GX - 5, GY - 5, GX + 5, GY +
                  5);
              end;
            2: {PntXBox}
              begin
                Image1.Canvas.Pen.Color := CurrentColor;
                Image1.Canvas.Rectangle(GX - 5, GY - 5, GX + 5, GY +
                  5);
                Image1.Canvas.moveto(GX - 5, GY - 5);
                Image1.Canvas.lineto(GX + 5, GY + 5);
                Image1.Canvas.moveto(GX - 5, GY + 5);
                Image1.Canvas.lineto(GX + 5, GY - 5);
              end;
            3: {PntCircle}
              begin
                Image1.Canvas.Pen.Color := CurrentColor;
                Image1.Canvas.Ellipse(GX - 5, GY - 5, GX + 5, GY +
                  5);
              end;
            4: {PntDotCircle}
              begin
                Image1.Canvas.Pen.Color := CurrentColor;
                Image1.Canvas.Pixels[GX, GY] := CurrentColor;
                Image1.Canvas.Ellipse(GX - 5, GY - 5, GX + 5, GY +
                  5);
              end;
            5: {PntX}
              begin
                Image1.Canvas.Pen.Color := CurrentColor;
                Image1.Canvas.moveto(GX - 5, GY - 5);
                Image1.Canvas.lineto(GX + 5, GY + 5);
                Image1.Canvas.moveto(GX - 5, GY + 5);
                Image1.Canvas.lineto(GX + 5, GY - 5);
              end;
            6: {PntCross}
              begin
                Image1.Canvas.Pen.Color := CurrentColor;
                Image1.Canvas.moveto(GX - 5, GY);
                Image1.Canvas.lineto(GX + 5, GY);
                Image1.Canvas.moveto(GX, GY + 5);
                Image1.Canvas.lineto(GX, GY - 5);
              end;
          end; {Case}
          inc(CurrentPoint);
          New(aDrawingPnt);
          aDrawingPnt^.X := InX;
          aDrawingPnt^.Y := InY;
          aDrawingPnt^.PX := GX;
          aDrawingPnt^.PY := GY;
          aDrawingPnt^.PointType := CurrentPointType;
          aDrawingPnt^.Layer := CurrentLayer;
          aDrawingPnt^.color := CurrentColor;
          PointList.Add(aDrawingPnt);
          StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
        end;
      {2: StopDigitizing;}
      3..4: StopDigitizing;      {4: StartDigitizing;}
    end; {Case Button}
  end else if bLineMode then begin
{Single LINE by Line}
    case Button of
      1: {Start a Line}
        begin
          if OnGoing then
          begin {intermediate lines}
            Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
            Image1.Canvas.lineto(GX, GY);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
            {Record the Lines point}
            New(aDrawingLnPnt);
            aDrawingLnPnt^.Line := CurrentLine;
            aDrawingLnPnt^.X := InX;
            aDrawingLnPnt^.Y := InY;
            aDrawingLnPnt^.PX := GX;
            aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
            aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
            LineList.Add(aDrawingLnPnt);
          end else begin
            if (not bPreStarted) then StartDigitizing;
            OnGoing := True;
            bPreStarted := True;
            inc(CurrentLine);
            Image1.Canvas.Pen.Color := CurrentColor;
        {psSolid  psDash  psDot psDashDot psDashDotDot}
           case CurrentLineType of
    0: Image1.Canvas.Pen.Style := psSolid;
    1: Image1.Canvas.Pen.Style := psDash;
    2: Image1.Canvas.Pen.Style := psDot;
    3: Image1.Canvas.Pen.Style := psDashDot;
    4: Image1.Canvas.Pen.Style := psDashDotDot;
           End;
            Image1.Canvas.moveto(GX, GY);
            Image1.Canvas.lineto(GX, GY);
            DigitStartPX := GX; DigitStartPY := GY;
            DigitStartX := InX; DigitStartY := InY;
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
            {Record the Lines point}
            New(aDrawingLnPnt);
            aDrawingLnPnt^.Line := CurrentLine;
            aDrawingLnPnt^.X := InX;
            aDrawingLnPnt^.Y := InY;
            aDrawingLnPnt^.PX := GX;
            aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
            aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
            LineList.Add(aDrawingLnPnt);
          end; end;
      2: {Start at End of Last Line}
        begin
          if (not bPreStarted) then StartDigitizing;
          OnGoing := True;
          bPreStarted := True;
          inc(CurrentLine);
          Image1.Canvas.Pen.Color := CurrentColor;
        {psSolid  psDash  psDot psDashDot psDashDotDot}
           case CurrentLineType of
    0: Image1.Canvas.Pen.Style := psSolid;
    1: Image1.Canvas.Pen.Style := psDash;
    2: Image1.Canvas.Pen.Style := psDot;
    3: Image1.Canvas.Pen.Style := psDashDot;
    4: Image1.Canvas.Pen.Style := psDashDotDot;
           End;
          Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
          Image1.Canvas.lineto(GX, GY);
            {Record the Lines point}
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := DigitEndX;
          aDrawingLnPnt^.Y := DigitEndY;
          aDrawingLnPnt^.PX := DigitEndPX;
          aDrawingLnPnt^.PY := DigitEndPY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
          DigitStartX := DigitEndX; DigitStartY := DigitEndY;

          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := InX;
          aDrawingLnPnt^.Y := InY;
          aDrawingLnPnt^.PX := GX;
          aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          DigitEndPX := GX; DigitEndPY := GY;
          DigitEndX := InX; DigitEndY := InY;
        end;
      3: {FINISH at Beginning of THIS line}
        begin
          {Image1.Canvas.moveto(DigitEndPX, DigitEndPY);}
          Image1.Canvas.lineto(GX, GY);
          Image1.Canvas.lineto(DigitStartPX, DigitStartPY);
            {Record the Lines point}
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := InX;
          aDrawingLnPnt^.Y := InY;
          aDrawingLnPnt^.PX := GX;
          aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := DigitStartX;
          aDrawingLnPnt^.Y := DigitStartY;
          aDrawingLnPnt^.PX := DigitStartPX;
          aDrawingLnPnt^.PY := DigitStartPY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          DigitStartPX := DigitStartPX; DigitStartPY := DigitStartPY;
          DigitStartX := DigitStartX; DigitStartY := DigitStartY;
          DigitEndPX := DigitStartPX; DigitEndPY := DigitStartPY;
          DigitEndX := DigitStartPX; DigitEndY := DigitStartPY;
          OnGoing := False;
          bPreStarted := False;
          StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
        end;
      4: {Finish}
        begin
          if (bPreStarted) then begin
            Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
            Image1.Canvas.lineto(GX, GY);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
            {Record the Lines point}
            New(aDrawingLnPnt);
            aDrawingLnPnt^.Line := CurrentLine;
            aDrawingLnPnt^.X := InX;
            aDrawingLnPnt^.Y := InY;
            aDrawingLnPnt^.PX := GX;
            aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
            aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
            LineList.Add(aDrawingLnPnt);
            OnGoing := False;
            bPreStarted := False;
            StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
          end else begin
            StartDigitizing;
            bPreStarted := True;
          end; end;
    end; {Case Button}
  end else if bStreamMode then begin
{Streaming LINE... NO intermediate lines... continuous line}
    if StartStreaming then begin
      Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
      Image1.Canvas.lineto(GX, GY);
      DigitEndPX := GX; DigitEndPY := GY;
            {Record the Lines point}
      New(aDrawingLnPnt);
      aDrawingLnPnt^.Line := CurrentLine;
      aDrawingLnPnt^.X := InX;
      aDrawingLnPnt^.Y := InY;
      aDrawingLnPnt^.PX := GX;
      aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
      aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
      LineList.Add(aDrawingLnPnt);
    end;
    case Button of
      1: {Start a Line}
        begin
          if (not bPreStarted) then StartDigitizing;
          inc(CurrentLine);
          Image1.Canvas.Pen.Color := CurrentColor;
          Image1.Canvas.moveto(GX, GY);
          DigitEndPX := GX; DigitEndPY := GY;
          DigitEndX := InX; DigitEndY := InX;
          DigitStartPX := GX; DigitStartPY := GY;
          DigitStartX := InX; DigitStartY := InY;
          StartStreaming := TRUE;
          bPreStarted := True;
            {Record the Lines point  AS a Line START}
        {psSolid  psDash  psDot psDashDot psDashDotDot}
           case CurrentLineType of
    0: Image1.Canvas.Pen.Style := psSolid;
    1: Image1.Canvas.Pen.Style := psDash;
    2: Image1.Canvas.Pen.Style := psDot;
    3: Image1.Canvas.Pen.Style := psDashDot;
    4: Image1.Canvas.Pen.Style := psDashDotDot;
           End;
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := InX;
          aDrawingLnPnt^.Y := InY;
          aDrawingLnPnt^.PX := GX;
          aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
        end;
      2: {Start at End of Last Line}
        begin
          if (not bPreStarted) then StartDigitizing;
          inc(CurrentLine);
          Image1.Canvas.Pen.Color := CurrentColor;
          Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
          Image1.Canvas.lineto(GX, GY);
            {Record the Lines point AS a Line START}
        {psSolid  psDash  psDot psDashDot psDashDotDot}
           case CurrentLineType of
    0: Image1.Canvas.Pen.Style := psSolid;
    1: Image1.Canvas.Pen.Style := psDash;
    2: Image1.Canvas.Pen.Style := psDot;
    3: Image1.Canvas.Pen.Style := psDashDot;
    4: Image1.Canvas.Pen.Style := psDashDotDot;
           End;
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := DigitEndX;
          aDrawingLnPnt^.Y := DigitEndY;
          aDrawingLnPnt^.PX := DigitEndPX;
          aDrawingLnPnt^.PY := DigitEndPY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := InX;
          aDrawingLnPnt^.Y := InY;
          aDrawingLnPnt^.PX := GX;
          aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
          DigitStartX := DigitEndX; DigitStartY := DigitEndY;
          DigitEndPX := GX; DigitEndPY := GY;
          DigitEndX := InX; DigitEndY := InX;
          bPreStarted := True;
          StartStreaming := TRUE;
        end;
      3: {FINISH at Beginning of THIS line}
        begin Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
          Image1.Canvas.lineto(GX, GY);
          Image1.Canvas.moveto(GX, GY);
          Image1.Canvas.lineto(DigitStartPX, DigitStartPY);
            {Record the Lines point AS A LINE}
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := InX;
          aDrawingLnPnt^.Y := InY;
          aDrawingLnPnt^.PX := GX;
          aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          New(aDrawingLnPnt);
          aDrawingLnPnt^.Line := CurrentLine;
          aDrawingLnPnt^.X := DigitStartX;
          aDrawingLnPnt^.Y := DigitStartY;
          aDrawingLnPnt^.PX := DigitStartPX;
          aDrawingLnPnt^.PY := DigitStartPY;
          aDrawingLnPnt^.Layer := CurrentLayer;
          aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
          LineList.Add(aDrawingLnPnt);
          DigitEndPX := DigitStartPY; DigitEndPY := DigitStartPY;
          DigitEndX := DigitStartY; DigitEndY := DigitStartY;
          StartStreaming := False;
          bPreStarted := False;
          StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
        end;
      4: {Finish}
        begin
          if (bPreStarted) then begin
            Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
            Image1.Canvas.lineto(GX, GY);
            DigitEndPX := GX; DigitEndPY := GY; {Store for maybe}
            DigitEndX := InX; DigitEndY := InY;
            {Record the Lines point AS A LINE }
            New(aDrawingLnPnt);
            aDrawingLnPnt^.Line := CurrentLine;
            aDrawingLnPnt^.X := InX;
            aDrawingLnPnt^.Y := InY;
            aDrawingLnPnt^.PX := GX;
            aDrawingLnPnt^.PY := GY;
          aDrawingLnPnt^.Layer := CurrentLayer;
            aDrawingLnPnt^.color := CurrentColor;
          aDrawingLnPnt^.LineType := CurrentLineType;
            LineList.Add(aDrawingLnPnt);
            StartStreaming := False;
            bPreStarted := False;
            StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
          end else begin
            StartDigitizing;
            bPreStarted := True;
          end; end;
    end; {Case Button}
  end else if bPolyMode then begin
  {Way to Finish if changed from Poly BEFORE finishing}
{Polygon Line by Line}
    case Button of
      1: {Start a Polygon CurrentArea}
        begin
          if OnGoing then begin {intermediate Polygon point}
            Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
            Image1.Canvas.lineto(GX, GY);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
            {Record the Polygon point}
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := InX;
            aDrawingAreaPnt^.Y := InY;
            aDrawingAreaPnt^.PX := GX;
            aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
          end else begin
            if (not bPreStarted) then StartDigitizing;
            inc(CurrentArea);
            OnGoing := True;
            bPreStarted := True;
            Image1.Canvas.Pen.Color := CurrentColor;
            Image1.Canvas.moveto(GX, GY);
            Image1.Canvas.lineto(GX, GY);            
            DigitStartPX := GX; DigitStartPY := GY;
            DigitStartX := InX; DigitStartY := InY;
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
            {Record the Polygon point}
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := InX;
            aDrawingAreaPnt^.Y := InY;
            aDrawingAreaPnt^.PX := GX;
            aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
          end; end;
      2: {Start at End of Last Polygon}
        begin
          if (not bPreStarted) then StartDigitizing;
          if (not OnGoing) then begin
            OnGoing := True;
            inc(CurrentArea);
            bPreStarted := True;
            Image1.Canvas.Pen.Color := CurrentColor;
            Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
            Image1.Canvas.lineto(GX, GY);
            DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
            DigitStartX := DigitEndY; DigitStartY := DigitEndY;
            {Record the Polygon point}
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := DigitEndX;
            aDrawingAreaPnt^.Y := DigitEndY;
            aDrawingAreaPnt^.PX := DigitEndPX;
            aDrawingAreaPnt^.PY := DigitEndPY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := InX;
            aDrawingAreaPnt^.Y := InY;
            aDrawingAreaPnt^.PX := GX;
            aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
          end;
        end;
      3..4: {FINISH at Beginning of THIS Polygon}
        begin
          Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
          Image1.Canvas.lineto(GX, GY);
          Image1.Canvas.moveto(GX, GY);
          Image1.Canvas.lineto(DigitStartPX, DigitStartPY);
            {Record the Polygon point}
          New(aDrawingAreaPnt);
          aDrawingAreaPnt^.Area := CurrentArea;
          aDrawingAreaPnt^.X := InX;
          aDrawingAreaPnt^.Y := InY;
          aDrawingAreaPnt^.PX := GX;
          aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
          aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
          AreaList.Add(aDrawingAreaPnt);
          New(aDrawingAreaPnt);
          aDrawingAreaPnt^.Area := CurrentArea;
          aDrawingAreaPnt^.X := DigitStartX;
          aDrawingAreaPnt^.Y := DigitStartY;
          aDrawingAreaPnt^.PX := DigitStartPX;
          aDrawingAreaPnt^.PY := DigitStartPY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
          aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
          AreaList.Add(aDrawingAreaPnt);

          DigitEndPX := DigitStartPY; DigitEndPY := DigitStartPY;
          DigitEndX := DigitStartX; DigitEndY := DigitStartY;
          bPreStarted := False;
          OnGoing := False;
          bPreStarted := False;
          StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
        end;
(*      4: {Finish Polygon... so same as 3... connected}
        begin
          if (bPreStarted) then begin
            Image1.Canvas.moveto(iOX, iOY);
            Image1.Canvas.lineto(GX, GY);
{           Image1.Canvas.moveto(GX, GY);}
            Image1.Canvas.lineto(KeepiOX, KeepiOY);
            {Record the Polygon point}
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := InX;
            aDrawingAreaPnt^.Y := InY;
            aDrawingAreaPnt^.PX := GX;
            aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := KeeperiOX;
            aDrawingAreaPnt^.Y := KeeperiOY;
            aDrawingAreaPnt^.PX := KeepiOX;
            aDrawingAreaPnt^.PY := KeepiOY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            iOX := GX; iOY := GY;
            KeepiOX := GX; KeepiOY := GY;
            KeeperiOX := InX; KeeperiOY := InY;
            OnGoing := False;
            bPreStarted := False;
            StopDigitizing;
            if (bAttributesToggled) then AttributesForm.Show;
          end else begin
            StartDigitizing;
            bPreStarted := True;
          end;
        end;*)
    end; {Case Button}
  end else if bPolyStreamMode then begin
{Streaming Polygon... NO intermediate lines... continuous Polygon}
    if StartStreaming then begin
      Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
      Image1.Canvas.lineto(GX, GY);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
            {Record the Polygon point}
      New(aDrawingAreaPnt);
      aDrawingAreaPnt^.Area := CurrentArea;
      aDrawingAreaPnt^.X := InX;
      aDrawingAreaPnt^.Y := InY;
      aDrawingAreaPnt^.PX := GX;
      aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
      AreaList.Add(aDrawingAreaPnt);
    end;
    case Button of
      1: {Start a Polygon}
        begin
          if (not bPreStarted) then StartDigitizing;
          OnGoing := True;
          inc(CurrentArea);
          Image1.Canvas.Pen.Color := CurrentColor;
          Image1.Canvas.moveto(GX, GY);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
          DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
          DigitStartX := DigitEndX; DigitStartY := DigitEndY;
          StartStreaming := TRUE;
          bPreStarted := True;
            {Record the Polygon point  AS a Polygon START}
          New(aDrawingAreaPnt);
          aDrawingAreaPnt^.Area := CurrentArea;
          aDrawingAreaPnt^.X := InX;
          aDrawingAreaPnt^.Y := InY;
          aDrawingAreaPnt^.PX := GX;
          aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
          AreaList.Add(aDrawingAreaPnt);
        end;
      2: {Start at End of Last Polygon }
        begin
          if (not bPreStarted) then StartDigitizing;
          if (not OnGoing) then begin
            OnGoing := True;
            inc(CurrentArea);
            Image1.Canvas.Pen.Color := CurrentColor;
            Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
            Image1.Canvas.lineto(GX, GY);
          DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
          DigitStartX := DigitEndX; DigitStartY := DigitEndY;
            StartStreaming := TRUE;
            bPreStarted := True;
            {Record the Polygon point AS a Polygon START}
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := DigitEndX;
            aDrawingAreaPnt^.Y := DigitEndY;
            aDrawingAreaPnt^.PX := DigitEndPX;
            aDrawingAreaPnt^.PY := DigitEndPY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := InX;
            aDrawingAreaPnt^.Y := InY;
            aDrawingAreaPnt^.PX := GX;
            aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            DigitEndPX := GX; DigitEndPY := GY;
            DigitEndX := InX; DigitEndY := InY;
          end;
        end;
      3..4: {FINISH at Beginning of THIS Polygon}
        begin
          Image1.Canvas.moveto(DigitEndPX, DigitEndPY);
          Image1.Canvas.lineto(GX, GY);
          Image1.Canvas.moveto(GX, GY);
          Image1.Canvas.lineto(DigitStartPX, DigitStartPY);
            {Record the Polygon point AS A Polygon }
          New(aDrawingAreaPnt);
          aDrawingAreaPnt^.Area := CurrentArea;
          aDrawingAreaPnt^.X := InX;
          aDrawingAreaPnt^.Y := InY;
          aDrawingAreaPnt^.PX := GX;
          aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
          AreaList.Add(aDrawingAreaPnt);
          New(aDrawingAreaPnt);
          aDrawingAreaPnt^.Area := CurrentArea;
          aDrawingAreaPnt^.X := DigitStartX;
          aDrawingAreaPnt^.Y := DigitStartY;
          aDrawingAreaPnt^.PX := DigitStartPX;
          aDrawingAreaPnt^.PY := DigitStartPY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
          AreaList.Add(aDrawingAreaPnt);
          {DigitStartPX := DigitEndPX; DigitStartPY := DigitEndPY;
          DigitStartX := DigitEndX; DigitStartY := DigitEndY;}
          DigitEndPX := DigitStartPX; DigitEndPY := DigitStartPY;
          DigitEndX := DigitStartX; DigitEndY := DigitStartY;
          StartStreaming := False;
          bPreStarted := False;
          OnGoing := False;
          StopDigitizing;
          if (bAttributesToggled) then AttributesForm.SetAttribute else
             AttributesForm.Show;
        end;
(*      4: {Finish Polygon.. so same as 3... connected}
        begin
          if (bPreStarted) then begin
            Image1.Canvas.moveto(iOX, iOY);
            Image1.Canvas.lineto(GX, GY);
{           Image1.Canvas.moveto(GX, GY);}
            Image1.Canvas.lineto(KeepiOX, KeepiOY);
            {Record the Polygon point AS A Polygon}
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := InX;
            aDrawingAreaPnt^.Y := InY;
            aDrawingAreaPnt^.PX := GX;
            aDrawingAreaPnt^.PY := GY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            New(aDrawingAreaPnt);
            aDrawingAreaPnt^.Area := CurrentArea;
            aDrawingAreaPnt^.X := KeeperiOX;
            aDrawingAreaPnt^.Y := KeeperiOY;
            aDrawingAreaPnt^.PX := KeepiOX;
            aDrawingAreaPnt^.PY := KeepiOY;
          aDrawingAreaPnt^.Layer := CurrentLayer;
            aDrawingAreaPnt^.Pencolor := CurrentColor;
            aDrawingAreaPnt^.Brushcolor := CurrentBrushColor;
            aDrawingAreaPnt^.PolyType := CurrentPolyType;
            AreaList.Add(aDrawingAreaPnt);
            iOX := GX; iOY := GY;
            KeepiOX := GX; KeepiOY := GY; {Store for maybe}
            KeeperiOX := InX; KeeperiOY := InY;
            StartStreaming := False;
            bPreStarted := False;
            OnGoing := False;
            StopDigitizing;
            if (bAttributesToggled) then AttributesForm.Show;
          end else begin
            StartDigitizing;
            bPreStarted := True;
          end;
        end;*)
    end; {Case Button}
  end else if bRegistrationMode then
  begin
  {REMOVE the standard x cursor}
{  Image1.Canvas.Pen.Mode := pmNotXor;
  Image1.Canvas.moveto(OldX - 1, OldY);
  Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX + 1, OldY);
  Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX, OldY + 1);
  Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
  Image1.Canvas.moveto(OldX, OldY - 1);
  Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);
  Image1.Canvas.Pen.Mode := pmCopy;}
    Image1.Canvas.Pen.Color := clRed;
    case Button of 1..4: Begin
    case Registering of
      1: begin
{      Image1.Canvas.Pixels[GX,GY]:=CurrentColor; }
          Image1.Canvas.Rectangle(GX - 5, GY - 5,
            GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY - 5);
          Image1.Canvas.lineto(GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY + 5);
          Image1.Canvas.lineto(GX + 5, GY - 5);
          {TLCoordPnt.X := InX;
          TLCoordPnt.Y := InY;}
          aRegPnt1.X := InX;
          aRegPnt1.Y := InY;
          aRegPnt1.PX := GX;
          aRegPnt1.PY := GY;
        end;
      2: begin
{     Image1.Canvas.Pixels[GX,GY]:=CurrentColor;}
          Image1.Canvas.Rectangle(GX - 5, GY - 5,
            GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY - 5);
          Image1.Canvas.lineto(GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY + 5);
          Image1.Canvas.lineto(GX + 5, GY - 5);
          {BLCoordPnt.X := InX;
          BLCoordPnt.Y := InY;}
          aRegPnt2.X := InX;
          aRegPnt2.Y := InY;
          aRegPnt2.PX := GX;
          aRegPnt2.PY := GY;
        end;
      3: begin
{      Image1.Canvas.Pixels[GX,GY]:=CurrentColor;}
          Image1.Canvas.Rectangle(GX - 5, GY - 5,
            GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY - 5);
          Image1.Canvas.lineto(GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY + 5);
          Image1.Canvas.lineto(GX + 5, GY - 5);
          {BRCoordPnt.X := InX;
          BRCoordPnt.Y := InY;}
          aRegPnt3.X := InX;
          aRegPnt3.Y := InY;
          aRegPnt3.PX := GX;
          aRegPnt3.PY := GY;
        end;
      4: begin
{     Image1.Canvas.Pixels[GX,GY]:=CurrentColor;}
          Image1.Canvas.Rectangle(GX - 5, GY - 5,
            GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY - 5);
          Image1.Canvas.lineto(GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY + 5);
          Image1.Canvas.lineto(GX + 5, GY - 5);
          {TRCoordPnt.X := InX;
          TRCoordPnt.Y := InY;}
          aRegPnt4.X := InX;
          aRegPnt4.Y := InY;
          aRegPnt4.PX := GX;
          aRegPnt4.PY := GY;
        end;
      5..8: begin
          Image1.Canvas.Rectangle(GX - 5, GY - 5,
            GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY - 5);
          Image1.Canvas.lineto(GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY + 5);
          Image1.Canvas.lineto(GX + 5, GY - 5);
        end;
      9: begin
          Image1.Canvas.Rectangle(GX - 5, GY - 5,
            GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY - 5);
          Image1.Canvas.lineto(GX + 5, GY + 5);
          Image1.Canvas.moveto(GX - 5, GY + 5);
          Image1.Canvas.lineto(GX + 5, GY - 5);
          LSRegPntArray[9].Reg := 9;
          LSRegPntArray[9].X := InX;
          LSRegPntArray[9].Y := InY;
          LSRegPntArray[9].PX := GX;
          LSRegPntArray[9].PY := GY;
        end;
    end; {case Registering}
    If bRegistrationModeLatLon then
    Begin
          LSRegPntArray[Registering].Reg := Registering;
          LSRegPntArray[Registering].X := InX;
          LSRegPntArray[Registering].Y := InY;
          LSRegPntArray[Registering].PX := GX;
          LSRegPntArray[Registering].PY := GY;
             {LocoX LocoY LongX LatY Residual  }
          {Set the Data into Wherever}

    End;{bRegistrationModeLatLon}
    End;{Case Button}
    End;{bRegistrationMode}
    Image1.Canvas.Pen.Color := CurrentColor;
      {REDRAW the standard x cursor}
{  Image1.Canvas.Pen.Mode := pmNotXor;
  Image1.Canvas.moveto(OldX - 1, OldY);
  Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX + 1, OldY);
  Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX, OldY + 1);
  Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
  Image1.Canvas.moveto(OldX, OldY - 1);
  Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);
  Image1.Canvas.Pen.Mode := pmCopy;}
  end; {bRegistrationMode}
  End;{Off to side MENU}
end; {Procedure}
(**********************************************************)
(**********************************************************)
procedure TDigitizerForm2.RefreshDrawingClick(Sender: TObject);
begin
  DVDORedraw; {Redraw is with the digitizing commands}
end;
(**********************************************************)
(**********************************************************)
procedure TDigitizerForm2.DVDORedraw;
var
  PolyStarted:Boolean;
  PolyArrayCounter,
  Counter: Integer;
  ARect: TRect;
var
  PolyArray: Array of TPoint;{Image1.Canvas.Polygon(PolyArray);}
  {Use the Slice function to pass a portion of an
  array of points to the Polygon method.
  For example, to form a polygon from the first ten points
  from an array of 100 points, use the Slice function as follows:
  Canvas.Polygon(Slice(PolyArray, 10));
  Image1.Canvas.Polygon(Slice(PolyArray, PolyArrayCounter));}
begin
{ProgressGauge.Progress:=10;}
  Cursor := crHourglass;
  Application.ProcessMessages;
{Clear Bitmap}
{     Image1.Picture.Graphic.Clear;}{Graphic := Bitmap;}
{  Copy1Click(Sender);  }{ copy picture to Clipboard }
  with Image1.Canvas do
  begin
    If BackGroundBitmapLoaded then
      Image1.Canvas.StretchDraw(Rect(0,0,ScreenWidth,ScreenHeight), BackGroundBitmap)
    else begin
    CopyMode := cmWhiteness; { copy everything as white }
    ARect := Rect(0, 0, Image1.Width, Image1.Height);
      { get bitmap rectangle }
    CopyRect(ARect, Image1.Canvas, ARect); { copy bitmap over itself }
    CopyMode := cmSrcCopy; { restore normal mode }
    end;
  end;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.Pen.Style := psSolid;{for POINTS}

{Application.ProcessMessages;}
{Redraw using the Lists}
{Redo in case view changed}
If (not bNoWorld) then
begin  {Draw registration points}
  aRegPnt1.PX := (Round(aRegPnt1.X * RX));
  aRegPnt1.PY := (ScreenHeight - (Round(aRegPnt1.Y * RY)));
{      Image1.Canvas.Pixels[aRegPnt1.PX,aRegPnt1.PY]:=CurrentColor;}
  Image1.Canvas.Pen.Color := clRed;
  Image1.Canvas.Rectangle(aRegPnt1.PX - 5, aRegPnt1.PY - 5,
    aRegPnt1.PX + 5, aRegPnt1.PY + 5);
  Image1.Canvas.moveto(aRegPnt1.PX - 5, aRegPnt1.PY - 5);
  Image1.Canvas.lineto(aRegPnt1.PX + 5, aRegPnt1.PY + 5);
  Image1.Canvas.moveto(aRegPnt1.PX - 5, aRegPnt1.PY + 5);
  Image1.Canvas.lineto(aRegPnt1.PX + 5, aRegPnt1.PY - 5);
  aRegPnt2.PX := (Round(aRegPnt2.X * RX));
  aRegPnt2.PY := (ScreenHeight - (Round(aRegPnt2.Y * RY)));
{      Image1.Canvas.Pixels[aRegPnt2.PX,aRegPnt2.PY]:=CurrentColor;}
  Image1.Canvas.Rectangle(aRegPnt2.PX - 5, aRegPnt2.PY - 5,
    aRegPnt2.PX + 5, aRegPnt2.PY + 5);
  Image1.Canvas.moveto(aRegPnt2.PX - 5, aRegPnt2.PY - 5);
  Image1.Canvas.lineto(aRegPnt2.PX + 5, aRegPnt2.PY + 5);
  Image1.Canvas.moveto(aRegPnt2.PX - 5, aRegPnt2.PY + 5);
  Image1.Canvas.lineto(aRegPnt2.PX + 5, aRegPnt2.PY - 5);
  aRegPnt3.PX := (Round(aRegPnt3.X * RX));
  aRegPnt3.PY := (ScreenHeight - (Round(aRegPnt3.Y * RY)));
{      Image1.Canvas.Pixels[aRegPnt3.PX,aRegPnt3.PY]:=CurrentColor;}
  Image1.Canvas.Rectangle(aRegPnt3.PX - 5, aRegPnt3.PY - 5,
    aRegPnt3.PX + 5, aRegPnt3.PY + 5);
  Image1.Canvas.moveto(aRegPnt3.PX - 5, aRegPnt3.PY - 5);
  Image1.Canvas.lineto(aRegPnt3.PX + 5, aRegPnt3.PY + 5);
  Image1.Canvas.moveto(aRegPnt3.PX - 5, aRegPnt3.PY + 5);
  Image1.Canvas.lineto(aRegPnt3.PX + 5, aRegPnt3.PY - 5);
  aRegPnt4.PX := (Round(aRegPnt4.X * RX));
  aRegPnt4.PY := (ScreenHeight - (Round(aRegPnt4.Y * RY)));
{      Image1.Canvas.Pixels[aRegPnt4.PX,aRegPnt4.PY]:=CurrentColor;}
  Image1.Canvas.Rectangle(aRegPnt4.PX - 5, aRegPnt4.PY - 5,
    aRegPnt4.PX + 5, aRegPnt4.PY + 5);
  Image1.Canvas.moveto(aRegPnt4.PX - 5, aRegPnt4.PY - 5);
  Image1.Canvas.lineto(aRegPnt4.PX + 5, aRegPnt4.PY + 5);
  Image1.Canvas.moveto(aRegPnt4.PX - 5, aRegPnt4.PY + 5);
  Image1.Canvas.lineto(aRegPnt4.PX + 5, aRegPnt4.PY - 5);
End;
{ProgressGauge.Progress:=20;}
{Application.ProcessMessages;}
  if (CurrentPoint > 0 {PointList.Count > 0}) then
  begin
    CurrentPoint := 0;
{    new(aDrawingPnt);}
    for Counter := 0 to (PointList.Count - 1) do
    begin
      inc(CurrentPoint);
      asDrawingPnt := PointList.Items[Counter];
      axDrawingPnt.X := asDrawingPnt^.X;
      axDrawingPnt.Y := asDrawingPnt^.Y;
      axDrawingPnt.PX := asDrawingPnt^.PX;
      axDrawingPnt.PY := asDrawingPnt^.PY;
      axDrawingPnt.Layer := asDrawingPnt^.Layer;
      axDrawingPnt.color := asDrawingPnt^.color;
      axDrawingPnt.PX := (Round(axDrawingPnt.X * RX));
      axDrawingPnt.PY := (ScreenHeight - (Round(axDrawingPnt.Y *
        RY)));
{      Image1.Canvas.Pixels[axDrawingPnt.PX,axDrawingPnt.PY]:=axDrawingPnt.Color;}
      case CurrentPointType of
        0: {PntDot} Image1.Canvas.Pixels[axDrawingPnt.PX,
          axDrawingPnt.PY] := axDrawingPnt.Color;
        1: {PntBox X1, Y1, X2, Y2}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Rectangle(axDrawingPnt.PX - 5,
              axDrawingPnt.PY - 5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY + 5);
          end;
        2: {PntXBox}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Rectangle(axDrawingPnt.PX - 5,
              axDrawingPnt.PY - 5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY + 5);
            Image1.Canvas.moveto(axDrawingPnt.PX - 5, axDrawingPnt.PY
              - 5);
            Image1.Canvas.lineto(axDrawingPnt.PX + 5, axDrawingPnt.PY
              + 5);
            Image1.Canvas.moveto(axDrawingPnt.PX - 5, axDrawingPnt.PY
              + 5);
            Image1.Canvas.lineto(axDrawingPnt.PX + 5, axDrawingPnt.PY
              - 5);
          end;
        3: {PntCircle}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Ellipse(axDrawingPnt.PX - 5, axDrawingPnt.PY
              - 5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY + 5);
          end;
        4: {PntDotCircle}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Pixels[axDrawingPnt.PX, axDrawingPnt.PY] :=
              axDrawingPnt.Color;
            Image1.Canvas.Ellipse(axDrawingPnt.PX - 5, axDrawingPnt.PY
              - 5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY + 5);
          end;
        5: {PntX}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.moveto(axDrawingPnt.PX - 5, axDrawingPnt.PY
              - 5);
            Image1.Canvas.lineto(axDrawingPnt.PX + 5, axDrawingPnt.PY
              + 5);
            Image1.Canvas.moveto(axDrawingPnt.PX - 5, axDrawingPnt.PY
              + 5);
            Image1.Canvas.lineto(axDrawingPnt.PX + 5, axDrawingPnt.PY
              - 5);
          end;
        6: {PntCross}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.moveto(axDrawingPnt.PX - 5,
              axDrawingPnt.PY);
            Image1.Canvas.lineto(axDrawingPnt.PX + 5,
              axDrawingPnt.PY);
            Image1.Canvas.moveto(axDrawingPnt.PX, axDrawingPnt.PY +
              5);
            Image1.Canvas.lineto(axDrawingPnt.PX, axDrawingPnt.PY -
              5);
          end;
      end; {Case}

      asDrawingPnt^.X := axDrawingPnt.X;
      asDrawingPnt^.Y := axDrawingPnt.Y;
      asDrawingPnt^.PX := axDrawingPnt.PX;
      asDrawingPnt^.PY := axDrawingPnt.PY;
      asDrawingPnt^.Layer := axDrawingPnt.Layer;
      asDrawingPnt^.color := axDrawingPnt.color;
{      aDrawingPnt := PointList.Items[Counter];
           aDrawingPnt^.PX:=(Round( aDrawingPnt^.X * RX ));
           aDrawingPnt^.PY:=(ScreenHeight-(Round( aDrawingPnt^.Y * RY )));
      Image1.Canvas.Pixels[aDrawingPnt^.PX,aDrawingPnt^.PY]:=aDrawingPnt^.Color;}
    end;
  end;
{    Dispose(aDrawingPnt);}
{ProgressGauge.Progress:=40;}
{Application.ProcessMessages;}
  if (CurrentLine > 0 {LineList.Count > 0}) then
  begin
    CurrentLine := 0;
{LineList.first;}
    for Counter := 0 to (LineList.Count - 1) do
    begin
{    new(asDrawingLnPnt);}
      asDrawingLnPnt := LineList.Items[Counter];
      if (asDrawingLnPnt^.Line <> CurrentLine) then
      begin
        axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
  CurrentLine :=axDrawingLnPnt.Line;
        axDrawingLnPnt.X := asDrawingLnPnt^.X;
        axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
        axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
        axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
        axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
        axDrawingLnPnt.color := asDrawingLnPnt^.color;
        axDrawingLnPnt.LineType := asDrawingLnPnt^.LineType;
        {Image1.Canvas.Pen.Style := axDrawingLnPnt.LineType; }
        {psSolid  psDash  psDot psDashDot psDashDotDot}
           case axDrawingLnPnt.LineType of
    0: Image1.Canvas.Pen.Style := psSolid;
    1: Image1.Canvas.Pen.Style := psDash;
    2: Image1.Canvas.Pen.Style := psDot;
    3: Image1.Canvas.Pen.Style := psDashDot;
    4: Image1.Canvas.Pen.Style := psDashDotDot;
           End;
        Image1.Canvas.Pen.Color := axDrawingLnPnt.color;
        axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
        axDrawingLnPnt.PY :=
        (ScreenHeight - (Round(axDrawingLnPnt.Y * RY)));
        Image1.Canvas.moveto(axDrawingLnPnt.PX + PanCentroidX,
          axDrawingLnPnt.PY + PanCentroidY);
        asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
        asDrawingLnPnt^.X := axDrawingLnPnt.X;
        asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
        asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
        asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
        asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
        asDrawingLnPnt^.color := axDrawingLnPnt.color;
        asDrawingLnPnt^.LineType := axDrawingLnPnt.LineType;
{  LineList.Add(asDrawingLnPnt);
  LineList.Exchange(Counter,LineList.IndexOf(LineList.Last));
  LineList.Remove(LineList.Last);}
{        Image1.Canvas.Pen.Color:=aDrawingLnPnt^.color;
        aDrawingLnPnt^.PX:=(Round( aDrawingLnPnt^.X * RX ));
        aDrawingLnPnt^.PY:=(ScreenHeight-(Round( aDrawingLnPnt^.Y * RY )));
        Image1.Canvas.moveto(aDrawingLnPnt^.PX, aDrawingLnPnt^.PY);}
{        inc(CurrentLine);}
      end else
      begin
        axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
        axDrawingLnPnt.X := asDrawingLnPnt^.X;
        axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
        axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
        axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
        axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
        axDrawingLnPnt.color := asDrawingLnPnt^.color;
        axDrawingLnPnt.LineType := asDrawingLnPnt^.LineType;
        axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
        axDrawingLnPnt.PY :=
        (ScreenHeight - (Round(axDrawingLnPnt.Y  * RY)));
        Image1.Canvas.lineto(axDrawingLnPnt.PX + PanCentroidX,
          axDrawingLnPnt.PY + PanCentroidY);
        asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
        asDrawingLnPnt^.X := axDrawingLnPnt.X;
        asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
        asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
        asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
        asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
        asDrawingLnPnt^.color := axDrawingLnPnt.color;
        asDrawingLnPnt^.LineType := axDrawingLnPnt.LineType;
{  LineList.Add(asDrawingLnPnt);
  LineList.Exchange(Counter,LineList.Indexof(LineList.Last));
  LineList.Remove(LineList.Last);}
{           aDrawingLnPnt^.PX:=(Round( aDrawingLnPnt^.X * RX ));
           aDrawingLnPnt^.PY:=(ScreenHeight-(Round( aDrawingLnPnt^.Y * RY )));}
{           Image1.Canvas.lineto(aDrawingLnPnt^.PX, aDrawingLnPnt^.PY);}
      end;
    end;
  end;
{ProgressGauge.Progress:=60;}
{Application.ProcessMessages;}
  if (CurrentArea > 0 {AreaList.Count > 0}) then
  begin
    CurrentArea := -10;
    PolyArrayCounter:=0;
    PolyStarted:=False;
{    new(aDrawingAreaPnt);  }
    for Counter := 0 to (AreaList.Count - 1) do
    begin
      asDrawingAreaPnt := AreaList.Items[Counter];
      if (asDrawingAreaPnt^.Area <> CurrentArea) then
      begin
      {Draw the Polygon, skip the first Start-empty Polygon}
      If PolyStarted then
      begin
        Image1.Canvas.Polygon(PolyArray);
        PolyArrayCounter:=0; {PolyStarted:=False;}
      end;
       PolyStarted:=True;
        axDrawingAreaPnt.Area := asDrawingAreaPnt^.Area;
        axDrawingAreaPnt.X := asDrawingAreaPnt^.X;
        axDrawingAreaPnt.Y := asDrawingAreaPnt^.Y;
        axDrawingAreaPnt.PX := asDrawingAreaPnt^.PX;
        axDrawingAreaPnt.PY := asDrawingAreaPnt^.PY;
        axDrawingAreaPnt.Layer := asDrawingAreaPnt^.Layer;
        axDrawingAreaPnt.Pencolor := asDrawingAreaPnt^.Pencolor;
        axDrawingAreaPnt.Brushcolor := asDrawingAreaPnt^.Brushcolor;
        axDrawingAreaPnt.PolyType := asDrawingAreaPnt^.PolyType;
   CurrentArea := axDrawingAreaPnt.Area;
        Image1.Canvas.Pen.Color := axDrawingAreaPnt.Pencolor;
  case axDrawingAreaPnt.PolyType of
    0: Image1.Canvas.Brush.Style := bsSolid;
    1: Image1.Canvas.Brush.Style := bsBDiagonal;
    2: Image1.Canvas.Brush.Style := bsFDiagonal;
    3: Image1.Canvas.Brush.Style := bsCross;
    4: Image1.Canvas.Brush.Style := bsDiagCross;
    5: Image1.Canvas.Brush.Style := bsHorizontal;
    6: Image1.Canvas.Brush.Style := bsVertical;
    7: Image1.Canvas.Brush.Style := bsClear;
  End;
 Image1.Canvas.Brush.Color := axDrawingAreaPnt.Brushcolor;
        axDrawingAreaPnt.PX := (Round(axDrawingAreaPnt.X * RX));
        axDrawingAreaPnt.PY := (ScreenHeight -
          (Round(axDrawingAreaPnt.Y * RY)));
        Image1.Canvas.moveto(axDrawingAreaPnt.PX,
          axDrawingAreaPnt.PY);
        asDrawingAreaPnt^.Area := axDrawingAreaPnt.Area;
        asDrawingAreaPnt^.X := axDrawingAreaPnt.X;
        asDrawingAreaPnt^.Y := axDrawingAreaPnt.Y;
        asDrawingAreaPnt^.PX := axDrawingAreaPnt.PX;
        asDrawingAreaPnt^.PY := axDrawingAreaPnt.PY;
      asDrawingAreaPnt^.Layer := axDrawingAreaPnt.Layer;
        asDrawingAreaPnt^.Pencolor := axDrawingAreaPnt.Pencolor;
        asDrawingAreaPnt^.Brushcolor := axDrawingAreaPnt.Brushcolor;
        asDrawingAreaPnt^.PolyType := axDrawingAreaPnt.PolyType;

   SetLength(PolyArray,PolyArrayCounter+1);
   PolyArray[PolyArrayCounter].X:=axDrawingAreaPnt.PX;
   PolyArray[PolyArrayCounter].Y:=axDrawingAreaPnt.PY;
   inc(PolyArrayCounter);
{        Image1.Canvas.Pen.Color:=aDrawingAreaPnt^.color;
           aDrawingAreaPnt^.PX:=(Round( aDrawingAreaPnt^.X * RX ));
           aDrawingAreaPnt^.PY:=(ScreenHeight-(Round( aDrawingAreaPnt^.Y * RY )));
        Image1.Canvas.moveto(aDrawingAreaPnt^.PX, aDrawingAreaPnt^.PY);}
{        inc(CurrentArea);}
      end else
      begin
        axDrawingAreaPnt.Area := asDrawingAreaPnt^.Area;
        axDrawingAreaPnt.X := asDrawingAreaPnt^.X;
        axDrawingAreaPnt.Y := asDrawingAreaPnt^.Y;
        axDrawingAreaPnt.PX := asDrawingAreaPnt^.PX;
        axDrawingAreaPnt.PY := asDrawingAreaPnt^.PY;
      axDrawingAreaPnt.Layer := asDrawingAreaPnt^.Layer;
        axDrawingAreaPnt.Pencolor := asDrawingAreaPnt^.Pencolor;
        axDrawingAreaPnt.Brushcolor := asDrawingAreaPnt^.Brushcolor;
        axDrawingAreaPnt.PolyType := asDrawingAreaPnt^.PolyType;
        axDrawingAreaPnt.PX := (Round(axDrawingAreaPnt.X * RX));
        axDrawingAreaPnt.PY := (ScreenHeight -
          (Round(axDrawingAreaPnt.Y * RY)));
        Image1.Canvas.lineto(axDrawingAreaPnt.PX,
          axDrawingAreaPnt.PY);
        asDrawingAreaPnt^.Area := axDrawingAreaPnt.Area;
        asDrawingAreaPnt^.X := axDrawingAreaPnt.X;
        asDrawingAreaPnt^.Y := axDrawingAreaPnt.Y;
        asDrawingAreaPnt^.PX := axDrawingAreaPnt.PX;
        asDrawingAreaPnt^.PY := axDrawingAreaPnt.PY;
      asDrawingAreaPnt^.Layer := axDrawingAreaPnt.Layer;
        asDrawingAreaPnt^.Pencolor := axDrawingAreaPnt.Pencolor;
        asDrawingAreaPnt^.Brushcolor := axDrawingAreaPnt.Brushcolor;
        asDrawingAreaPnt^.PolyType := axDrawingAreaPnt.PolyType;
{       aDrawingAreaPnt^.PX:=(Round( aDrawingAreaPnt^.X * RX ));
       aDrawingAreaPnt^.PY:=(ScreenHeight-(Round( aDrawingAreaPnt^.Y * RY )));
       Image1.Canvas.lineto(aDrawingAreaPnt^.PX, aDrawingAreaPnt^.PY);}

   SetLength(PolyArray,PolyArrayCounter+1);
   PolyArray[PolyArrayCounter].X:=axDrawingAreaPnt.PX;
   PolyArray[PolyArrayCounter].Y:=axDrawingAreaPnt.PY;
   inc(PolyArrayCounter);
      If (Counter = (AreaList.Count - 1)) then
      begin {Draw the LAST POLYGON}
        {Image1.Canvas.Polygon(PolyArray);}
        Image1.Canvas.Polygon(PolyArray);
      end;
      end;
    end;
  end;
  SetLength(PolyArray,0);
{ProgressGauge.Progress:=0;}
  OldX := 10;
  OldY := 10;
{  SetROP2(Image1.Canvas.handle, R2_NOT);}
  Image1.Canvas.Pen.Mode := pmNotXor;
  Image1.Canvas.moveto(OldX - 1, OldY);
  Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX + 1, OldY);
  Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
  Image1.Canvas.moveto(OldX, OldY + 1);
  Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
  Image1.Canvas.moveto(OldX, OldY - 1);
  Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);
  Cursor := crDefault;
{Application.ProcessMessages;}
end;
(**********************************************************)
(**********************************************************)
(*************END of DIGITIZER translation ****************)
(**********************************************************)



(***********************************************************)
{A Layer is #,0,0
An item is #,(point 0, Line 1, Area 2, DLG Area 4),item#
Collation starts as Layer: #,0,0
  then internally the line colors are changed}
procedure TDigitizerForm2.InspectorRedraw(Layered,
                                          DLGOType,
                                          DLGOItem:Integer);
{Also used for Line Collation by Color Coding actions
Lines are stored in TempAreaLineList until finished?
  then the line points are
  re-organized and stored in the Area point list}
var
  DoLayers:Boolean;
  ARect: TRect;
  DLGCounter,  DLGDLGOItem,
  ICount, Counter: Integer;
  DlgPointsXY:XYPolygon;
begin
  Cursor := crHourglass;
  Application.ProcessMessages;
  If DLGOType<4 then
  begin
    with Image1.Canvas do
    begin
      CopyMode := cmWhiteness; { copy everything as white }
      ARect := Rect(0, 0, Image1.Width, Image1.Height);
      CopyRect(ARect, Image1.Canvas, ARect); { copy bitmap over itself }
      CopyMode := cmSrcCopy; { restore normal mode }
    end;
    Image1.Canvas.Pen.Mode := pmCopy;
  end else if DLGOType=5 then
  begin
    with Image1.Canvas do
    begin
      ARect := Rect(0, 0, Image1.Width, Image1.Height);
      Brush.Style := bsSolid;
      Brush.Color:=clAqua;
      FillRect(ARect);
      {CopyRect(ARect, Image1.Canvas, ARect);}{ copy bitmap over itself }
    end;
  end;
  If ( (Layered>-1) and (DLGOType <0)and (DLGOItem<0) )then
  DoLayers := True else DoLayers :=False;

  If ((DLGOType=0)or(DoLayers)) then
  begin
    if (CurrentPoint > 0 ) then
    begin
      CurrentPoint := 0;
      {new(aDrawingPnt);}
      for Counter := 0 to (PointList.Count - 1) do
      begin
        inc(CurrentPoint);
        asDrawingPnt := PointList.Items[Counter];
        axDrawingPnt.X := asDrawingPnt^.X;
        axDrawingPnt.Y := asDrawingPnt^.Y;
        axDrawingPnt.PX := asDrawingPnt^.PX;
        axDrawingPnt.PY := asDrawingPnt^.PY;
        axDrawingPnt.Layer := asDrawingPnt^.Layer;
        axDrawingPnt.color := asDrawingPnt^.color;
        axDrawingPnt.PX := (Round(axDrawingPnt.X * RX));
        axDrawingPnt.PY :=
        (ScreenHeight - (Round(axDrawingPnt.Y *  RY)));
        If (  ((axDrawingPnt.Layer = Layered)and
             (Counter =DLGOItem))  {?? -1 ?}
        or ((DoLayers)and(axDrawingPnt.Layer = Layered)) ) then
        begin
          {Image1.Canvas.Pixels[axDrawingPnt.PX,axDrawingPnt.PY]:=axDrawingPnt.Color;}
          case CurrentPointType of
          0: {PntDot} Image1.Canvas.Pixels[axDrawingPnt.PX,
            axDrawingPnt.PY] := axDrawingPnt.Color;
          1: {PntBox X1, Y1, X2, Y2}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Rectangle(axDrawingPnt.PX - 5,
              axDrawingPnt.PY - 5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY + 5);
          end;
          2: {PntXBox}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Rectangle(axDrawingPnt.PX - 5,
              axDrawingPnt.PY - 5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY +5);
            Image1.Canvas.moveto(axDrawingPnt.PX -5, axDrawingPnt.PY-5);
            Image1.Canvas.lineto(axDrawingPnt.PX +5, axDrawingPnt.PY+5);
            Image1.Canvas.moveto(axDrawingPnt.PX -5, axDrawingPnt.PY+5);
            Image1.Canvas.lineto(axDrawingPnt.PX +5, axDrawingPnt.PY-5);
          end;
          3: {PntCircle}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Ellipse(axDrawingPnt.PX-5, axDrawingPnt.PY-5,
                                  axDrawingPnt.PX+5, axDrawingPnt.PY+5);
          end;
          4: {PntDotCircle}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.Pixels[axDrawingPnt.PX, axDrawingPnt.PY] :=
              axDrawingPnt.Color;
            Image1.Canvas.Ellipse(axDrawingPnt.PX-5, axDrawingPnt.PY-5,
              axDrawingPnt.PX + 5, axDrawingPnt.PY + 5);
          end;
          5: {PntX}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.moveto(axDrawingPnt.PX-5, axDrawingPnt.PY-5);
            Image1.Canvas.lineto(axDrawingPnt.PX+5, axDrawingPnt.PY+5);
            Image1.Canvas.moveto(axDrawingPnt.PX-5, axDrawingPnt.PY+5);
            Image1.Canvas.lineto(axDrawingPnt.PX+5, axDrawingPnt.PY-5);
          end;
          6: {PntCross}
          begin
            Image1.Canvas.Pen.Color := axDrawingPnt.Color;
            Image1.Canvas.moveto(axDrawingPnt.PX-5,axDrawingPnt.PY);
            Image1.Canvas.lineto(axDrawingPnt.PX+5,axDrawingPnt.PY);
            Image1.Canvas.moveto(axDrawingPnt.PX, axDrawingPnt.PY+5);
            Image1.Canvas.lineto(axDrawingPnt.PX, axDrawingPnt.PY-5);
          end;
          end; {Case}
        end;
        asDrawingPnt^.X := axDrawingPnt.X;
        asDrawingPnt^.Y := axDrawingPnt.Y;
        asDrawingPnt^.PX := axDrawingPnt.PX;
        asDrawingPnt^.PY := axDrawingPnt.PY;
        asDrawingPnt^.Layer := axDrawingPnt.Layer;
        asDrawingPnt^.color := axDrawingPnt.color;
        {aDrawingPnt := PointList.Items[Counter];
           aDrawingPnt^.PX:=(Round( aDrawingPnt^.X * RX ));
           aDrawingPnt^.PY:=(ScreenHeight-(Round( aDrawingPnt^.Y * RY )));
         Image1.Canvas.Pixels[aDrawingPnt^.PX,aDrawingPnt^.PY]:=aDrawingPnt^.Color;}
      end;
    end;
  end;{DLGOType 0}

  If ((DLGOType=1)or(DoLayers)) then
  begin
    if (CurrentLine > 0 ) then
    begin
      CurrentLine := 0;
      for Counter := 0 to (LineList.Count - 1) do
      begin
        asDrawingLnPnt := LineList.Items[Counter];
        if (asDrawingLnPnt^.Line <> CurrentLine) then
        begin
          axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
          axDrawingLnPnt.X := asDrawingLnPnt^.X;
          axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
          axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
          axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
          axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
          axDrawingLnPnt.color := asDrawingLnPnt^.color;
          CurrentLine := axDrawingLnPnt.Line;
          axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
          axDrawingLnPnt.PY := (ScreenHeight - (Round(axDrawingLnPnt.Y*RY)));
          If (   ((axDrawingLnPnt.Layer = Layered)
                   and(axDrawingLnPnt.Line =DLGOItem))
             or
             ((DoLayers)
                   and (axDrawingLnPnt.Layer = Layered)) )then
          begin
            Image1.Canvas.Pen.Color := axDrawingLnPnt.color;
            Image1.Canvas.moveto(axDrawingLnPnt.PX + PanCentroidX,
                                 axDrawingLnPnt.PY + PanCentroidY);
          end;
          asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
          asDrawingLnPnt^.X := axDrawingLnPnt.X;
          asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
          asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
          asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
          asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
          asDrawingLnPnt^.color := axDrawingLnPnt.color;
        end else
        begin
          axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
          axDrawingLnPnt.X := asDrawingLnPnt^.X;
          axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
          axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
          axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
          axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
          axDrawingLnPnt.color := asDrawingLnPnt^.color;
          axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
          axDrawingLnPnt.PY := (ScreenHeight - (Round(axDrawingLnPnt.Y*RY)));
          If (   ((axDrawingLnPnt.Layer = Layered)
                 and(axDrawingLnPnt.Line =DLGOItem))
             or
             ((DoLayers)
                 and (axDrawingLnPnt.Layer = Layered)) )then
          begin
            Image1.Canvas.lineto(axDrawingLnPnt.PX + PanCentroidX,
                                 axDrawingLnPnt.PY + PanCentroidY);
          end;
          asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
          asDrawingLnPnt^.X := axDrawingLnPnt.X;
          asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
          asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
          asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
          asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
          asDrawingLnPnt^.color := axDrawingLnPnt.color;
        end;
      end;
    end;
  end;{DLGOType 1}

  If ((DLGOType=2)or(DoLayers)) then
  begin
    if (CurrentArea > 0 ) then
    begin
      CurrentArea := 0;
      {new(aDrawingAreaPnt);  }
      for Counter := 0 to (AreaList.Count - 1) do
      begin
        asDrawingAreaPnt := AreaList.Items[Counter];
        if (asDrawingAreaPnt^.Area = CurrentArea) then
        begin
          if (asDrawingAreaPnt^.Area <> CurrentArea) then
          begin
            axDrawingAreaPnt.Area := asDrawingAreaPnt^.Area;
            axDrawingAreaPnt.X := asDrawingAreaPnt^.X;
            axDrawingAreaPnt.Y := asDrawingAreaPnt^.Y;
            axDrawingAreaPnt.PX := asDrawingAreaPnt^.PX;
            axDrawingAreaPnt.PY := asDrawingAreaPnt^.PY;
            axDrawingAreaPnt.Layer := asDrawingAreaPnt^.Layer;
            axDrawingAreaPnt.Pencolor := asDrawingAreaPnt^.Pencolor;
            axDrawingAreaPnt.Brushcolor := asDrawingAreaPnt^.Brushcolor;
            axDrawingAreaPnt.PolyType := asDrawingAreaPnt^.PolyType;
            CurrentArea := axDrawingAreaPnt.Area;
            axDrawingAreaPnt.PX := (Round(axDrawingAreaPnt.X * RX));
            axDrawingAreaPnt.PY := (ScreenHeight -
                (Round(axDrawingAreaPnt.Y * RY)));
            If (   ((axDrawingAreaPnt.Layer = Layered)
                    and(axDrawingAreaPnt.Area =DLGOItem))
               or
               ((DoLayers)
                    and (axDrawingAreaPnt.Layer = Layered)) )then
            begin
              Image1.Canvas.Pen.Color := axDrawingAreaPnt.Pencolor;
              Image1.Canvas.moveto(axDrawingAreaPnt.PX,
                                   axDrawingAreaPnt.PY);
            end;
            asDrawingAreaPnt^.Area := axDrawingAreaPnt.Area;
            asDrawingAreaPnt^.X := axDrawingAreaPnt.X;
            asDrawingAreaPnt^.Y := axDrawingAreaPnt.Y;
            asDrawingAreaPnt^.PX := axDrawingAreaPnt.PX;
            asDrawingAreaPnt^.PY := axDrawingAreaPnt.PY;
            asDrawingAreaPnt^.Layer := axDrawingAreaPnt.Layer;
            asDrawingAreaPnt^.Pencolor := axDrawingAreaPnt.Pencolor;
            asDrawingAreaPnt^.Brushcolor := axDrawingAreaPnt.Brushcolor;
            asDrawingAreaPnt^.PolyType := axDrawingAreaPnt.PolyType;
          end else
          begin
            axDrawingAreaPnt.Area := asDrawingAreaPnt^.Area;
            axDrawingAreaPnt.X := asDrawingAreaPnt^.X;
            axDrawingAreaPnt.Y := asDrawingAreaPnt^.Y;
            axDrawingAreaPnt.PX := asDrawingAreaPnt^.PX;
            axDrawingAreaPnt.PY := asDrawingAreaPnt^.PY;
            axDrawingAreaPnt.Layer := asDrawingAreaPnt^.Layer;
            axDrawingAreaPnt.Pencolor := asDrawingAreaPnt^.Pencolor;
            axDrawingAreaPnt.Brushcolor := asDrawingAreaPnt^.Brushcolor;
            axDrawingAreaPnt.PolyType := asDrawingAreaPnt^.PolyType;
            axDrawingAreaPnt.PX := (Round(axDrawingAreaPnt.X * RX));
            axDrawingAreaPnt.PY := (ScreenHeight -
                           (Round(axDrawingAreaPnt.Y * RY)));
            If (   ((axDrawingAreaPnt.Layer = Layered)
                   and(axDrawingAreaPnt.Area =DLGOItem))
               or
               ((DoLayers)
                   and (axDrawingAreaPnt.Layer = Layered)) )then
            begin
              Image1.Canvas.lineto(axDrawingAreaPnt.PX,
                                   axDrawingAreaPnt.PY);
            end;
            asDrawingAreaPnt^.Area := axDrawingAreaPnt.Area;
            asDrawingAreaPnt^.X := axDrawingAreaPnt.X;
            asDrawingAreaPnt^.Y := axDrawingAreaPnt.Y;
            asDrawingAreaPnt^.PX := axDrawingAreaPnt.PX;
            asDrawingAreaPnt^.PY := axDrawingAreaPnt.PY;
            asDrawingAreaPnt^.Layer := axDrawingAreaPnt.Layer;
            asDrawingAreaPnt^.Pencolor := axDrawingAreaPnt.Pencolor;
            asDrawingAreaPnt^.Brushcolor := axDrawingAreaPnt.Brushcolor;
            asDrawingAreaPnt^.PolyType := axDrawingAreaPnt.PolyType;
          end;
        end;{aught}
      end;
    end;
  end;{DLGOType 2}

  {DLG areas require Getting the Lines of the Area}
  {3 is Display THIS DLG area only
   4 is Refresh  display the area without erasing
   5 is Test: Make a background and display area as a filled Polygon }
  If ((DLGOType=3)or(DLGOType=4)or(DLGOType=5)) then
     {Check ALL DLGAreas then do ALL Lines of the Area}
     {Layer Area Line DrawingDLGArea DLGCounter  DLGDLGOItem}
  if (CurrentDLGArea > 0 ) then
  begin
    (*    CurrentLine := 0;*)
    for DLGCounter := 0 to (DLGAreaList.Count - 1) do
    begin
      asDrawingDLGArea := DLGAreaList.Items[DLGCounter];
      axDrawingDLGArea.Layer := asDrawingDLGArea^.Layer;
      axDrawingDLGArea.Area := asDrawingDLGArea^.Area;
      axDrawingDLGArea.Line := asDrawingDLGArea^.Line;
      If  ((axDrawingDLGArea.Layer = Layered)
           and(axDrawingDLGArea.Area =DLGOItem))
      then
      begin
        DLGDLGOItem:= axDrawingDLGArea.Line;

        if (CurrentLine > 0 ) then
        begin
          CurrentLine := 0;
          for Counter := 0 to (LineList.Count - 1) do
          begin
            asDrawingLnPnt := LineList.Items[Counter];
            if ((asDrawingLnPnt^.Line <> CurrentLine)
               and (asDrawingLnPnt^.Line =DLGDLGOItem)) then
            begin
              axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
              axDrawingLnPnt.X := asDrawingLnPnt^.X;
              axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
              axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
              axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
              axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
              axDrawingLnPnt.color := asDrawingLnPnt^.color;
              CurrentLine := axDrawingLnPnt.Line;
              axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
              axDrawingLnPnt.PY := (ScreenHeight - (Round(axDrawingLnPnt.Y * RY)));
              If (DLGOType=5) then
              begin
                {Add and Put point into array}
                inc(CurrentDLGAreaPoint);
                SetLength(DlgPoints, CurrentDLGAreaPoint);
                DlgPoints[CurrentDLGAreaPoint]:=
                     Point(axDrawingLnPnt.PX,axDrawingLnPnt.PY);
              end else
              begin
                 {Image1.Canvas.Pen.Color := axDrawingLnPnt.color;}
                Image1.Canvas.Pen.Color := clFuchsia;
                Image1.Canvas.moveto(axDrawingLnPnt.PX + PanCentroidX,
                                     axDrawingLnPnt.PY + PanCentroidY);
              end;
              asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
              asDrawingLnPnt^.X := axDrawingLnPnt.X;
              asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
              asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
              asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
              asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
              asDrawingLnPnt^.color := axDrawingLnPnt.color;
            end else
            if ((asDrawingLnPnt^.Line = CurrentLine)
                and (asDrawingLnPnt^.Line =DLGDLGOItem)) then
            begin
              axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
              axDrawingLnPnt.X := asDrawingLnPnt^.X;
              axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
              axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
              axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
              axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
              axDrawingLnPnt.color := asDrawingLnPnt^.color;
              axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
              axDrawingLnPnt.PY := (ScreenHeight - (Round(axDrawingLnPnt.Y* RY)));
              If (DLGOType=5) then
              begin
                {Add and Put point into array}
                inc(CurrentDLGAreaPoint);
                If (CurrentDLGAreaPoint> MaxPolyPnts) then
                begin
                  ShowMessage('Too many Points in Area');
                  Exit;
                end;
                SetLength(DlgPoints, CurrentDLGAreaPoint);
                DlgPoints[CurrentDLGAreaPoint]:=
                      Point(axDrawingLnPnt.PX,axDrawingLnPnt.PY);
              end else
              begin
                Image1.Canvas.lineto(axDrawingLnPnt.PX + PanCentroidX,
                           axDrawingLnPnt.PY + PanCentroidY);
              end;
              asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
              asDrawingLnPnt^.X := axDrawingLnPnt.X;
              asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
              asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
              asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
              asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
              asDrawingLnPnt^.color := axDrawingLnPnt.color;
            end;
          end;
        end;
      end;
    end;
  end;{DLGOType 3,4,5}

  { DLGOType 5: Collate the points into a Polygon
    Change the background and Plot a filled Poly}
  If (DLGOType=5) then
  begin
    {Reorganize Polygon Points}
    {CurrentDLGAreaPoint}
    (*procedure OrderPolygon(GMode: Byte; var Poly: XYPolygon;
           NrPnts:Integer);
    XYPolygon = array[1..MaxPolyPnts] of RXYCoord;
    MaxPolyPnts = 100;
    RXYCoord = record {Real X and Y Coordinates}
    X: Double;
    Y: Double;
    end;  *)
    For ICount:=1 to CurrentDLGAreaPoint do
    begin
      DlgPointsXY[ICount].X:=DlgPoints[ICount].X;
      DlgPointsXY[ICount].Y:=DlgPoints[ICount].Y;
    end;
    OrderPolygon(2, DlgPointsXY,CurrentDLGAreaPoint);
    For ICount:=1 to CurrentDLGAreaPoint do
    begin
      DlgPoints[ICount].X:=Round(DlgPointsXY[ICount].X);
      DlgPoints[ICount].Y:=Round(DlgPointsXY[ICount].Y);
    end;
    Image1.Canvas.Brush.Color := clAqua;
    Image1.Canvas.Polygon(DlgPoints);
  end;

  If (DLGOType<>4) then
  begin
    OldX := 10;
    OldY := 10;
    {SetROP2(Image1.Canvas.handle, R2_NOT);}
    Image1.Canvas.Pen.Mode := pmNotXor;
    Image1.Canvas.moveto(OldX - 1, OldY);
    Image1.Canvas.lineto(OldX - CurrentCursorSize, OldY);
    Image1.Canvas.moveto(OldX + 1, OldY);
    Image1.Canvas.lineto(OldX + CurrentCursorSize, OldY);
    Image1.Canvas.moveto(OldX, OldY + 1);
    Image1.Canvas.lineto(OldX, OldY + CurrentCursorSize);
    Image1.Canvas.moveto(OldX, OldY - 1);
    Image1.Canvas.lineto(OldX, OldY - CurrentCursorSize);
  end;
  Cursor := crDefault;
  {Application.ProcessMessages;}
end;
(***********************************************************)
procedure TDigitizerForm2.BigCursor1Click(Sender: TObject);
begin
  If CurrentCursorSize = BigCursorSize then
  Begin
    TempCursorSize  := CursorSize;
    CursorSizeChanged:=True;
    BigCursor1.Checked:=False;
  End else
  Begin
    TempCursorSize := BigCursorSize;
    CursorSizeChanged:=True;
    BigCursor1.Checked:=True;
  End;
end;
(***********************************************************)





end.
